ALTER TABLE "user" ADD COLUMN is_group BOOLEAN;
ALTER TABLE "user" ALTER COLUMN is_group SET DEFAULT false;
UPDATE "user" set is_group=false;

ALTER TABLE "user" ADD COLUMN password_change_date TIMESTAMPTZ;
ALTER TABLE "user" ALTER COLUMN password_change_date SET DEFAULT now();
UPDATE "user" set password_change_date=now();

CREATE TABLE usergroup_user (
usergroup_id INT NOT NULL CONSTRAINT usergroupid_fk REFERENCES "user"(user_id),
member_user_id INT NOT NULL CONSTRAINT memberuserid_fk REFERENCES "user"(user_id),
PRIMARY KEY (usergroup_id,member_user_id)
);
CREATE INDEX usergroupuser_memberuseridusergroupid ON usergroup_user(member_user_id,usergroup_id);

ALTER TABLE project ADD COLUMN parent_project_id INT;
ALTER TABLE project ALTER COLUMN parent_project_id SET DEFAULT 0;
ALTER TABLE project ADD COLUMN root_parent_project_id INT;
ALTER TABLE project ALTER COLUMN root_parent_project_id SET DEFAULT 0;
ALTER TABLE project ADD COLUMN root_path TEXT;
ALTER TABLE project ADD COLUMN project_text1 TEXT;
ALTER TABLE project ADD COLUMN project_text2 TEXT;
ALTER TABLE project ADD COLUMN project_text3 TEXT;
ALTER TABLE project ADD COLUMN project_text4 TEXT;
ALTER TABLE project ADD COLUMN project_text5 TEXT;
ALTER TABLE project ADD COLUMN project_text6 TEXT;

CREATE INDEX project_rootparentprojectid ON project(root_parent_project_id);
CREATE INDEX project_parentprojectid ON project(parent_project_id);

ALTER TABLE frs_release ADD COLUMN is_released BOOLEAN;
ALTER TABLE frs_release ALTER COLUMN is_released SET DEFAULT false;
UPDATE frs_release set is_released=true WHERE release_date <= now();
UPDATE frs_release set is_released=false WHERE release_date > now();

ALTER TABLE docman_file_version ADD COLUMN is_approved BOOLEAN;
ALTER TABLE docman_file_version ALTER COLUMN is_approved SET DEFAULT false;
UPDATE docman_file_version set is_approved=true;

CREATE TABLE associations (
section varchar(20),
ref_id int,
to_section varchar(20),
to_ref_id int,
primary key (section,ref_id,to_section,to_ref_id)
);
CREATE UNIQUE INDEX associations_tosection ON associations(to_section,to_ref_id,section,ref_id);

