DROP TABLE cruisecontrol_module;
DROP TABLE cruisecontrol_platform CASCADE;
DROP TABLE cruisecontrol_platform_tracker_item;
DROP TABLE cruisecontrol_preference;

DELETE FROM cruisecontrol;
DELETE FROM cruisecontrol_publisher;
DELETE FROM cruisecontrol_assignee;
ALTER TABLE cruisecontrol DROP COLUMN builder;
ALTER TABLE cruisecontrol DROP COLUMN log_type;
ALTER TABLE cruisecontrol DROP COLUMN developer;
CREATE SEQUENCE cruisecontrol_cruisecontrol_id_seq;
ALTER TABLE cruisecontrol ADD COLUMN cruisecontrol_id INT;
ALTER TABLE cruisecontrol ALTER COLUMN cruisecontrol_id SET DEFAULT NEXTVAL('cruisecontrol_cruisecontrol_id_seq');
ALTER TABLE cruisecontrol ADD COLUMN build_name text;
ALTER TABLE cruisecontrol ADD COLUMN build_description text;
ALTER TABLE cruisecontrol DROP CONSTRAINT cruisecontrol_pkey;
ALTER TABLE cruisecontrol ADD CONSTRAINT cruisecontrol_pkey PRIMARY KEY (cruisecontrol_id);
ALTER TABLE cruisecontrol ADD COLUMN submitter_id INT;
ALTER TABLE cruisecontrol ALTER COLUMN submitter_id SET NOT NULL;
ALTER TABLE cruisecontrol ADD CONSTRAINT userid_fk FOREIGN KEY (submitter_id) REFERENCES "user"(user_id);

--DROP TABLE cruisecontrol_build CASCADE;
CREATE TABLE cruisecontrol_build (
cruisecontrol_build_id SERIAL PRIMARY KEY,
cruisecontrol_id INT NOT NULL CONSTRAINT cruisecontrolid_fk 
	REFERENCES cruisecontrol(cruisecontrol_id) ON DELETE CASCADE,
cruisecontrol_defect_id INT default 0,
build_date TIMESTAMPTZ NOT NULL DEFAULT now(),
was_successful boolean default true,
was_fix boolean default true,
was_necessary boolean default true,
description text
);
CREATE INDEX cruisecontrolbuild_cruisecontrolidbuilddate ON cruisecontrol_build(cruisecontrol_id,build_date);

--DROP TABLE cruisecontrol_build_change_user;
CREATE TABLE cruisecontrol_build_change_user (
cruisecontrol_build_id INT NOT NULL CONSTRAINT cruisecontrolbuildid_fk
        REFERENCES cruisecontrol_build(cruisecontrol_build_id) ON DELETE CASCADE,
user_id INT NOT NULL CONSTRAINT userid_fk
        REFERENCES "user"(user_id) ON DELETE CASCADE,
PRIMARY KEY (cruisecontrol_build_id,user_id)
);

ALTER TABLE cruisecontrol_publisher DROP CONSTRAINT projectid_fk;
ALTER TABLE cruisecontrol_publisher RENAME COLUMN project_id TO cruisecontrol_id;
ALTER TABLE cruisecontrol_assignee DROP CONSTRAINT projectid_fk;
ALTER TABLE cruisecontrol_assignee RENAME COLUMN project_id TO cruisecontrol_id;
ALTER TABLE cruisecontrol_publisher ADD CONSTRAINT cruisecontrolid_fk FOREIGN KEY (cruisecontrol_id) REFERENCES cruisecontrol(cruisecontrol_id);
ALTER TABLE cruisecontrol_assignee ADD CONSTRAINT cruisecontrolid_fk FOREIGN KEY (cruisecontrol_id) REFERENCES cruisecontrol(cruisecontrol_id);

CREATE TABLE cruisecontrol_defect (
cruisecontrol_defect_id SERIAL PRIMARY KEY,
cruisecontrol_id INT NOT NULL CONSTRAINT cruisecontrolid_fk 
	REFERENCES cruisecontrol(cruisecontrol_id) ON DELETE CASCADE,
tracker_item_id INT NOT NULL CONSTRAINT trackeritemid_fk
	REFERENCES tracker_item(tracker_item_id) ON DELETE CASCADE,
open boolean default true
);
CREATE INDEX cruisecontroldefect_cruisecontrolid ON cruisecontrol_defect(cruisecontrol_id);
