DROP RULE forum_message_insert_rule ON forum_message;
DROP RULE forum_message_delete_rule ON forum_message;
DROP FUNCTION forum_insertdelete_agg() CASCADE;

CREATE OR REPLACE FUNCTION forummessage_insertupdatedelete_agg() RETURNS "trigger"
    AS '
BEGIN
        IF TG_OP != ''DELETE'' THEN
		UPDATE forum_thread SET message_count=(SELECT count(*) FROM forum_message 
			WHERE is_approved=true AND forum_thread_id=NEW.forum_thread_id) 
			WHERE forum_thread_id=NEW.forum_thread_id;
        ELSE
		UPDATE forum_thread SET message_count=(SELECT count(*) FROM forum_message 
			WHERE is_approved=true AND forum_thread_id=OLD.forum_thread_id) 
			WHERE forum_thread_id=OLD.forum_thread_id;
        END IF;
        RETURN NEW;
END;
'
    LANGUAGE plpgsql;

CREATE TRIGGER forum_message_insertupdatedelete_trigg
    AFTER INSERT OR DELETE OR UPDATE ON forum_message
    FOR EACH ROW
    EXECUTE PROCEDURE forummessage_insertupdatedelete_agg();

CREATE OR REPLACE FUNCTION forumthread_insertupdatedelete_agg() RETURNS "trigger"
    AS '
BEGIN
        IF TG_OP != ''DELETE'' THEN
		UPDATE forum SET message_count=coalesce((SELECT sum(message_count) FROM forum_thread
				WHERE forum_id=NEW.forum_id),0),
			thread_count=coalesce((SELECT count(*) FROM forum_thread
                        	WHERE forum_id=NEW.forum_id AND message_count > 0),0)
			WHERE forum_id=NEW.forum_id;
        ELSE
		UPDATE forum SET message_count=coalesce((SELECT sum(message_count) FROM forum_thread
				WHERE forum_id=OLD.forum_id),0),
			thread_count=coalesce((SELECT count(*) FROM forum_thread
                        	WHERE forum_id=OLD.forum_id AND message_count > 0),0)
			WHERE forum_id=OLD.forum_id;
        END IF;
        RETURN NEW;
END;
'
    LANGUAGE plpgsql;

CREATE TRIGGER forum_thread_insertupdatedelete_trigg
    AFTER INSERT OR DELETE OR UPDATE ON forum_thread
    FOR EACH ROW
    EXECUTE PROCEDURE forumthread_insertupdatedelete_agg();


