<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/MyReport.php';
// (on-demand) include_once 'core/MyReportPeer.php';

include_once 'core/MyReportFieldDisplayPeer.php';

/**
 * Base class that represents a row from the 'my_report_field_display' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to MyReportFieldDisplay class. 
 * 
 * @package core 
 */
abstract class BaseMyReportFieldDisplay extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var MyReportFieldDisplayPeer
	 */
	protected static $peer;

	/**
	 * The value for the my_report_field_display_id field.
	 * @var int	  
	 */
	protected $my_report_field_display_id;	

	/**
	 * The value for the my_report_id field.
	 * @var int	  
	 */
	protected $my_report_id;	

	/**
	 * The value for the field_name field.
	 * @var string	  
	 */
	protected $field_name;	

	/**
	 * The value for the type field.
	 * @var int	  
	 */
	protected $type;	

	/**
	 * The value for the order_priority field.
	 * @var int	  
	 */
	protected $order_priority = 0;	

	/**
	 * The value for the order_asc field.
	 * @var boolean	  
	 */
	protected $order_asc = true;	

	/**
	 * The value for the column_order field.
	 * @var int	  
	 */
	protected $column_order;	
  
	/**
	 * Get the MyReportFieldDisplayId column value.
	 *  
	 * @return int	  
	 */
	public function getMyReportFieldDisplayId()
	{
		return $this->my_report_field_display_id;
	}


	/**
	 * Set the value of `my_report_field_display_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setMyReportFieldDisplayId($v)
	{
		if ($this->my_report_field_display_id !== $v) {
			$this->my_report_field_display_id = $v;
			$this->modifiedColumns[] = MyReportFieldDisplayPeer::MY_REPORT_FIELD_DISPLAY_ID;
		}
				
	}

  
	/**
	 * Get the MyReportId column value.
	 *  
	 * @return int	  
	 */
	public function getMyReportId()
	{
		return $this->my_report_id;
	}


	/**
	 * Set the value of `my_report_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setMyReportId($v)
	{
		if ($this->my_report_id !== $v) {
			$this->my_report_id = $v;
			$this->modifiedColumns[] = MyReportFieldDisplayPeer::MY_REPORT_ID;
		}
			
		if ($this->aMyReport !== null && $this->aMyReport->getMyReportId() !== $v) {
			$this->aMyReport = null;
		}
			
	}

  
	/**
	 * Get the FieldName column value.
	 *  
	 * @return string	  
	 */
	public function getFieldName()
	{
		return $this->field_name;
	}


	/**
	 * Set the value of `field_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFieldName($v)
	{
		if ($this->field_name !== $v) {
			$this->field_name = $v;
			$this->modifiedColumns[] = MyReportFieldDisplayPeer::FIELD_NAME;
		}
				
	}

  
	/**
	 * Get the Type column value.
	 *  
	 * @return int	  
	 */
	public function getType()
	{
		return $this->type;
	}


	/**
	 * Set the value of `type` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setType($v)
	{
		if ($this->type !== $v) {
			$this->type = $v;
			$this->modifiedColumns[] = MyReportFieldDisplayPeer::TYPE;
		}
				
	}

  
	/**
	 * Get the OrderPriority column value.
	 *  
	 * @return int	  
	 */
	public function getOrderPriority()
	{
		return $this->order_priority;
	}


	/**
	 * Set the value of `order_priority` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setOrderPriority($v)
	{
		if ($this->order_priority !== $v || $v === 0) {
			$this->order_priority = $v;
			$this->modifiedColumns[] = MyReportFieldDisplayPeer::ORDER_PRIORITY;
		}
				
	}

  
	/**
	 * Get the OrderAsc column value.
	 *  
	 * @return boolean	  
	 */
	public function getOrderAsc()
	{
		return $this->order_asc;
	}


	/**
	 * Set the value of `order_asc` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setOrderAsc($v)
	{
		if ($this->order_asc !== $v || $v === true) {
			$this->order_asc = $v;
			$this->modifiedColumns[] = MyReportFieldDisplayPeer::ORDER_ASC;
		}
				
	}

  
	/**
	 * Get the ColumnOrder column value.
	 *  
	 * @return int	  
	 */
	public function getColumnOrder()
	{
		return $this->column_order;
	}


	/**
	 * Set the value of `column_order` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setColumnOrder($v)
	{
		if ($this->column_order !== $v) {
			$this->column_order = $v;
			$this->modifiedColumns[] = MyReportFieldDisplayPeer::COLUMN_ORDER;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->my_report_field_display_id = $rs->getInt($startcol + 0);					
			$this->my_report_id = $rs->getInt($startcol + 1);					
			$this->field_name = $rs->getString($startcol + 2);					
			$this->type = $rs->getInt($startcol + 3);					
			$this->order_priority = $rs->getInt($startcol + 4);					
			$this->order_asc = $rs->getBoolean($startcol + 5);					
			$this->column_order = $rs->getInt($startcol + 6);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating MyReportFieldDisplay object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(MyReportFieldDisplayPeer::DATABASE_NAME);
		$criteria->add(MyReportFieldDisplayPeer::MY_REPORT_FIELD_DISPLAY_ID, $this->my_report_field_display_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(MyReportFieldDisplayPeer::DATABASE_NAME);
		if ($this->isColumnModified(MyReportFieldDisplayPeer::MY_REPORT_FIELD_DISPLAY_ID)) $criteria->add(MyReportFieldDisplayPeer::MY_REPORT_FIELD_DISPLAY_ID, $this->my_report_field_display_id);
		if ($this->isColumnModified(MyReportFieldDisplayPeer::MY_REPORT_ID)) $criteria->add(MyReportFieldDisplayPeer::MY_REPORT_ID, $this->my_report_id);
		if ($this->isColumnModified(MyReportFieldDisplayPeer::FIELD_NAME)) $criteria->add(MyReportFieldDisplayPeer::FIELD_NAME, $this->field_name);
		if ($this->isColumnModified(MyReportFieldDisplayPeer::TYPE)) $criteria->add(MyReportFieldDisplayPeer::TYPE, $this->type);
		if ($this->isColumnModified(MyReportFieldDisplayPeer::ORDER_PRIORITY)) $criteria->add(MyReportFieldDisplayPeer::ORDER_PRIORITY, $this->order_priority);
		if ($this->isColumnModified(MyReportFieldDisplayPeer::ORDER_ASC)) $criteria->add(MyReportFieldDisplayPeer::ORDER_ASC, $this->order_asc);
		if ($this->isColumnModified(MyReportFieldDisplayPeer::COLUMN_ORDER)) $criteria->add(MyReportFieldDisplayPeer::COLUMN_ORDER, $this->column_order);
		return $criteria;			
	}
	
	

	/**
	 * @var MyReport	  
	 */
	protected $aMyReport;

	/**
	 * Declares an association between this object and a MyReport object
	 *
	 * @param MyReport $v
	 * @return void
	 * @throws PropelException
	 */
	public function setMyReport($v)
	{
			
		if ($v === null) {
			$this->setMyReportId(NULL);
		} else {
			$this->setMyReportId($v->getMyReportId());
		}
   
		$this->aMyReport = $v;
	}


	/**
	 * Get the associated MyReport object
	 *
	 * @param Connection Optional Connection object.
	 * @return MyReport The associated MyReport object.
	 * @throws PropelException
	 */
	public function getMyReport($con = null)
	{
		// include the Peer class
		include_once 'core/MyReportPeer.php';

		if ($this->aMyReport === null && ($this->my_report_id !== null)) {
	
			$this->aMyReport = MyReportPeer::retrieveByPK($this->my_report_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = MyReportPeer::retrieveByPK($this->my_report_id, $con);
			   $obj->addMyReportFieldDisplays($this);
			 */
		}
		return $this->aMyReport;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setMyReportKey($key)
	{

		$this->setMyReportId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("my_report_field_display_id", "my_report_id", "field_name", "type", "order_priority", "order_asc", "column_order", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case MyReportFieldDisplayPeer::MY_REPORT_FIELD_DISPLAY_ID:
				return $this->getMyReportFieldDisplayId();
				break;
		  
			case MyReportFieldDisplayPeer::MY_REPORT_ID:
				return $this->getMyReportId();
				break;
		  
			case MyReportFieldDisplayPeer::FIELD_NAME:
				return $this->getFieldName();
				break;
		  
			case MyReportFieldDisplayPeer::TYPE:
				return $this->getType();
				break;
		  
			case MyReportFieldDisplayPeer::ORDER_PRIORITY:
				return $this->getOrderPriority();
				break;
		  
			case MyReportFieldDisplayPeer::ORDER_ASC:
				return $this->getOrderAsc();
				break;
		  
			case MyReportFieldDisplayPeer::COLUMN_ORDER:
				return $this->getColumnOrder();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getMyReportFieldDisplayId();
				break;
  
			case 1:
				return $this->getMyReportId();
				break;
  
			case 2:
				return $this->getFieldName();
				break;
  
			case 3:
				return $this->getType();
				break;
  
			case 4:
				return $this->getOrderPriority();
				break;
  
			case 5:
				return $this->getOrderAsc();
				break;
  
			case 6:
				return $this->getColumnOrder();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(MyReportFieldDisplayPeer::MY_REPORT_FIELD_DISPLAY_ID, $arr)) $this->setMyReportFieldDisplayId($arr[MyReportFieldDisplayPeer::MY_REPORT_FIELD_DISPLAY_ID]);
  
		if (array_key_exists(MyReportFieldDisplayPeer::MY_REPORT_ID, $arr)) $this->setMyReportId($arr[MyReportFieldDisplayPeer::MY_REPORT_ID]);
  
		if (array_key_exists(MyReportFieldDisplayPeer::FIELD_NAME, $arr)) $this->setFieldName($arr[MyReportFieldDisplayPeer::FIELD_NAME]);
  
		if (array_key_exists(MyReportFieldDisplayPeer::TYPE, $arr)) $this->setType($arr[MyReportFieldDisplayPeer::TYPE]);
  
		if (array_key_exists(MyReportFieldDisplayPeer::ORDER_PRIORITY, $arr)) $this->setOrderPriority($arr[MyReportFieldDisplayPeer::ORDER_PRIORITY]);
  
		if (array_key_exists(MyReportFieldDisplayPeer::ORDER_ASC, $arr)) $this->setOrderAsc($arr[MyReportFieldDisplayPeer::ORDER_ASC]);
  
		if (array_key_exists(MyReportFieldDisplayPeer::COLUMN_ORDER, $arr)) $this->setColumnOrder($arr[MyReportFieldDisplayPeer::COLUMN_ORDER]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case MyReportFieldDisplayPeer::MY_REPORT_FIELD_DISPLAY_ID:
				$this->setMyReportFieldDisplayId($value);
				break;
	  
			case MyReportFieldDisplayPeer::MY_REPORT_ID:
				$this->setMyReportId($value);
				break;
	  
			case MyReportFieldDisplayPeer::FIELD_NAME:
				$this->setFieldName($value);
				break;
	  
			case MyReportFieldDisplayPeer::TYPE:
				$this->setType($value);
				break;
	  
			case MyReportFieldDisplayPeer::ORDER_PRIORITY:
				$this->setOrderPriority($value);
				break;
	  
			case MyReportFieldDisplayPeer::ORDER_ASC:
				$this->setOrderAsc($value);
				break;
	  
			case MyReportFieldDisplayPeer::COLUMN_ORDER:
				$this->setColumnOrder($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setMyReportFieldDisplayId($value);
				break;
  
			case 1:
				$this->setMyReportId($value);
				break;
  
			case 2:
				$this->setFieldName($value);
				break;
  
			case 3:
				$this->setType($value);
				break;
  
			case 4:
				$this->setOrderPriority($value);
				break;
  
			case 5:
				$this->setOrderAsc($value);
				break;
  
			case 6:
				$this->setColumnOrder($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(MyReportFieldDisplayPeer::DATABASE_NAME);

		try {
			$con->begin();
			MyReportFieldDisplayPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(MyReportFieldDisplayPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aMyReport !== null) {
				if ($this->aMyReport->isModified()) $this->aMyReport->save($con);
				$this->setMyReport($this->aMyReport);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = MyReportFieldDisplayPeer::doInsert($this, $con);
					$this->setMyReportFieldDisplayId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					MyReportFieldDisplayPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return MyReportFieldDisplayPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aMyReport !== null) {
				if (($retval = $this->aMyReport->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = MyReportFieldDisplayPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed my_report_field_display_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setMyReportFieldDisplayId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getMyReportFieldDisplayId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return MyReportFieldDisplay Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new MyReportFieldDisplay();
		$copyObj->setMyReportId($this->my_report_id);
		$copyObj->setFieldName($this->field_name);
		$copyObj->setType($this->type);
		$copyObj->setOrderPriority($this->order_priority);
		$copyObj->setOrderAsc($this->order_asc);
		$copyObj->setColumnOrder($this->column_order);
		
		$copyObj->setNew(true);
		
		$copyObj->setMyReportFieldDisplayId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return MyReportFieldDisplayPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new MyReportFieldDisplayPeer();
		}
		return self::$peer;
	}

}
