<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/MyReport.php';
// (on-demand) include_once 'core/MyReportPeer.php';

include_once 'core/MyReportFieldFilterPeer.php';

/**
 * Base class that represents a row from the 'my_report_field_filter' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to MyReportFieldFilter class. 
 * 
 * @package core 
 */
abstract class BaseMyReportFieldFilter extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var MyReportFieldFilterPeer
	 */
	protected static $peer;

	/**
	 * The value for the my_report_field_filter_id field.
	 * @var int	  
	 */
	protected $my_report_field_filter_id;	

	/**
	 * The value for the my_report_id field.
	 * @var int	  
	 */
	protected $my_report_id;	

	/**
	 * The value for the field_name field.
	 * @var string	  
	 */
	protected $field_name;	

	/**
	 * The value for the type field.
	 * @var int	  
	 */
	protected $type;	
  
	/**
	 * Get the MyReportFieldFilterId column value.
	 *  
	 * @return int	  
	 */
	public function getMyReportFieldFilterId()
	{
		return $this->my_report_field_filter_id;
	}


	/**
	 * Set the value of `my_report_field_filter_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setMyReportFieldFilterId($v)
	{
		if ($this->my_report_field_filter_id !== $v) {
			$this->my_report_field_filter_id = $v;
			$this->modifiedColumns[] = MyReportFieldFilterPeer::MY_REPORT_FIELD_FILTER_ID;
		}
			
		  // update associated MyReportFieldValue		  
		  if ($this->collMyReportFieldValues !== null) {
			  for ($i=0,$size=count($this->collMyReportFieldValues); $i < $size; $i++) {
				  $this->collMyReportFieldValues[$i]->setMyReportFieldFilterId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the MyReportId column value.
	 *  
	 * @return int	  
	 */
	public function getMyReportId()
	{
		return $this->my_report_id;
	}


	/**
	 * Set the value of `my_report_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setMyReportId($v)
	{
		if ($this->my_report_id !== $v) {
			$this->my_report_id = $v;
			$this->modifiedColumns[] = MyReportFieldFilterPeer::MY_REPORT_ID;
		}
			
		if ($this->aMyReport !== null && $this->aMyReport->getMyReportId() !== $v) {
			$this->aMyReport = null;
		}
			
	}

  
	/**
	 * Get the FieldName column value.
	 *  
	 * @return string	  
	 */
	public function getFieldName()
	{
		return $this->field_name;
	}


	/**
	 * Set the value of `field_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFieldName($v)
	{
		if ($this->field_name !== $v) {
			$this->field_name = $v;
			$this->modifiedColumns[] = MyReportFieldFilterPeer::FIELD_NAME;
		}
				
	}

  
	/**
	 * Get the Type column value.
	 *  
	 * @return int	  
	 */
	public function getType()
	{
		return $this->type;
	}


	/**
	 * Set the value of `type` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setType($v)
	{
		if ($this->type !== $v) {
			$this->type = $v;
			$this->modifiedColumns[] = MyReportFieldFilterPeer::TYPE;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->my_report_field_filter_id = $rs->getInt($startcol + 0);					
			$this->my_report_id = $rs->getInt($startcol + 1);					
			$this->field_name = $rs->getString($startcol + 2);					
			$this->type = $rs->getInt($startcol + 3);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating MyReportFieldFilter object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(MyReportFieldFilterPeer::DATABASE_NAME);
		$criteria->add(MyReportFieldFilterPeer::MY_REPORT_FIELD_FILTER_ID, $this->my_report_field_filter_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(MyReportFieldFilterPeer::DATABASE_NAME);
		if ($this->isColumnModified(MyReportFieldFilterPeer::MY_REPORT_FIELD_FILTER_ID)) $criteria->add(MyReportFieldFilterPeer::MY_REPORT_FIELD_FILTER_ID, $this->my_report_field_filter_id);
		if ($this->isColumnModified(MyReportFieldFilterPeer::MY_REPORT_ID)) $criteria->add(MyReportFieldFilterPeer::MY_REPORT_ID, $this->my_report_id);
		if ($this->isColumnModified(MyReportFieldFilterPeer::FIELD_NAME)) $criteria->add(MyReportFieldFilterPeer::FIELD_NAME, $this->field_name);
		if ($this->isColumnModified(MyReportFieldFilterPeer::TYPE)) $criteria->add(MyReportFieldFilterPeer::TYPE, $this->type);
		return $criteria;			
	}
	
	

	/**
	 * @var MyReport	  
	 */
	protected $aMyReport;

	/**
	 * Declares an association between this object and a MyReport object
	 *
	 * @param MyReport $v
	 * @return void
	 * @throws PropelException
	 */
	public function setMyReport($v)
	{
			
		if ($v === null) {
			$this->setMyReportId(NULL);
		} else {
			$this->setMyReportId($v->getMyReportId());
		}
   
		$this->aMyReport = $v;
	}


	/**
	 * Get the associated MyReport object
	 *
	 * @param Connection Optional Connection object.
	 * @return MyReport The associated MyReport object.
	 * @throws PropelException
	 */
	public function getMyReport($con = null)
	{
		// include the Peer class
		include_once 'core/MyReportPeer.php';

		if ($this->aMyReport === null && ($this->my_report_id !== null)) {
	
			$this->aMyReport = MyReportPeer::retrieveByPK($this->my_report_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = MyReportPeer::retrieveByPK($this->my_report_id, $con);
			   $obj->addMyReportFieldFilters($this);
			 */
		}
		return $this->aMyReport;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setMyReportKey($key)
	{

		$this->setMyReportId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collMyReportFieldValues	  
	 * @var array
	 */
	protected $collMyReportFieldValues; 

	/**
	 * Temporary storage of collMyReportFieldValues to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMyReportFieldValues()
	{
		if ($this->collMyReportFieldValues === null) {
			$this->collMyReportFieldValues = array();
		}
	}

	/**
	 * Method called to associate a MyReportFieldValue object to this object
	 * through the MyReportFieldValue foreign key attribute
	 *
	 * @param MyReportFieldValue $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMyReportFieldValue(MyReportFieldValue $l)
	{
		$this->collMyReportFieldValues[] = $l;
		$l->setMyReportFieldFilter($this);
	}

	/**
	 * The criteria used to select the current contents of collMyReportFieldValues.
	 * @var Criteria
	 */
	private $lastMyReportFieldValuesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReportFieldFilter has previously
	 * been saved, it will retrieve related MyReportFieldValues from storage.
	 * If this MyReportFieldFilter is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMyReportFieldValues($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportFieldValuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMyReportFieldValues === null) {
			if ($this->isNew()) {
			   $this->collMyReportFieldValues = array();
			} else {
	
				$criteria->add(MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID, $this->getMyReportFieldFilterId() );

				$this->collMyReportFieldValues = MyReportFieldValuePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID, $this->getMyReportFieldFilterId());

				if (!isset($this->lastMyReportFieldValuesCriteria) || !$this->lastMyReportFieldValuesCriteria->equals($criteria)) {
					$this->collMyReportFieldValues = MyReportFieldValuePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMyReportFieldValuesCriteria = $criteria;

		return $this->collMyReportFieldValues;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReportFieldFilter is new, it will return
	 * an empty collection; or if this MyReportFieldFilter has previously
	 * been saved, it will retrieve related MyReportFieldValues from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in MyReportFieldFilter.
	 */
	public function getMyReportFieldValuesJoinMyReportFieldFilter($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportFieldValuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportFieldValues === null) {
			if ($this->isNew()) {
			   $this->collMyReportFieldValues = array();
			} else {
	   
				$criteria->add(MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID, $this->getMyReportFieldFilterId());
				$this->collMyReportFieldValues = MyReportFieldValuePeer::doSelectJoinMyReportFieldFilter($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID, $this->getMyReportFieldFilterId());
			if (!isset($this->lastMyReportFieldValuesCriteria) || !$this->lastMyReportFieldValuesCriteria->equals($criteria)) {
				$this->collMyReportFieldValues = MyReportFieldValuePeer::doSelectJoinMyReportFieldFilter($criteria, $con);
			}
		}
		$this->lastMyReportFieldValuesCriteria = $criteria;

		return $this->collMyReportFieldValues;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("my_report_field_filter_id", "my_report_id", "field_name", "type", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case MyReportFieldFilterPeer::MY_REPORT_FIELD_FILTER_ID:
				return $this->getMyReportFieldFilterId();
				break;
		  
			case MyReportFieldFilterPeer::MY_REPORT_ID:
				return $this->getMyReportId();
				break;
		  
			case MyReportFieldFilterPeer::FIELD_NAME:
				return $this->getFieldName();
				break;
		  
			case MyReportFieldFilterPeer::TYPE:
				return $this->getType();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getMyReportFieldFilterId();
				break;
  
			case 1:
				return $this->getMyReportId();
				break;
  
			case 2:
				return $this->getFieldName();
				break;
  
			case 3:
				return $this->getType();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(MyReportFieldFilterPeer::MY_REPORT_FIELD_FILTER_ID, $arr)) $this->setMyReportFieldFilterId($arr[MyReportFieldFilterPeer::MY_REPORT_FIELD_FILTER_ID]);
  
		if (array_key_exists(MyReportFieldFilterPeer::MY_REPORT_ID, $arr)) $this->setMyReportId($arr[MyReportFieldFilterPeer::MY_REPORT_ID]);
  
		if (array_key_exists(MyReportFieldFilterPeer::FIELD_NAME, $arr)) $this->setFieldName($arr[MyReportFieldFilterPeer::FIELD_NAME]);
  
		if (array_key_exists(MyReportFieldFilterPeer::TYPE, $arr)) $this->setType($arr[MyReportFieldFilterPeer::TYPE]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case MyReportFieldFilterPeer::MY_REPORT_FIELD_FILTER_ID:
				$this->setMyReportFieldFilterId($value);
				break;
	  
			case MyReportFieldFilterPeer::MY_REPORT_ID:
				$this->setMyReportId($value);
				break;
	  
			case MyReportFieldFilterPeer::FIELD_NAME:
				$this->setFieldName($value);
				break;
	  
			case MyReportFieldFilterPeer::TYPE:
				$this->setType($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setMyReportFieldFilterId($value);
				break;
  
			case 1:
				$this->setMyReportId($value);
				break;
  
			case 2:
				$this->setFieldName($value);
				break;
  
			case 3:
				$this->setType($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(MyReportFieldFilterPeer::DATABASE_NAME);

		try {
			$con->begin();
			MyReportFieldFilterPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(MyReportFieldFilterPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aMyReport !== null) {
				if ($this->aMyReport->isModified()) $this->aMyReport->save($con);
				$this->setMyReport($this->aMyReport);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = MyReportFieldFilterPeer::doInsert($this, $con);
					$this->setMyReportFieldFilterId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					MyReportFieldFilterPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collMyReportFieldValues !== null) {
				for ($i=0,$size=count($this->collMyReportFieldValues); $i < $size; $i++) {
					$this->collMyReportFieldValues[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return MyReportFieldFilterPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aMyReport !== null) {
				if (($retval = $this->aMyReport->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = MyReportFieldFilterPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collMyReportFieldValues !== null) {
				for ($i=0,$size=count($this->collMyReportFieldValues); $i < $size; $i++) {
					if (($retval = $this->collMyReportFieldValues[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed my_report_field_filter_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setMyReportFieldFilterId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getMyReportFieldFilterId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return MyReportFieldFilter Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new MyReportFieldFilter();
		$copyObj->setMyReportId($this->my_report_id);
		$copyObj->setFieldName($this->field_name);
		$copyObj->setType($this->type);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getMyReportFieldValues() as $relObj) {
				$copyObj->addMyReportFieldValue($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setMyReportFieldFilterId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return MyReportFieldFilterPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new MyReportFieldFilterPeer();
		}
		return self::$peer;
	}

}
