<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'core/UserRelationPeer.php';

/**
 * Base class that represents a row from the 'user_relation' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to UserRelation class. 
 * 
 * @package core 
 */
abstract class BaseUserRelation extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var UserRelationPeer
	 */
	protected static $peer;

	/**
	 * The value for the user_id field.
	 * @var int	  
	 */
	protected $user_id;	

	/**
	 * The value for the related_user_id field.
	 * @var int	  
	 */
	protected $related_user_id;	
  
	/**
	 * Get the UserId column value.
	 *  
	 * @return int	  
	 */
	public function getUserId()
	{
		return $this->user_id;
	}


	/**
	 * Set the value of `user_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUserId($v)
	{
		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = UserRelationPeer::USER_ID;
		}
			
		if ($this->aUserRelatedByUserId !== null && $this->aUserRelatedByUserId->getUserId() !== $v) {
			$this->aUserRelatedByUserId = null;
		}
			
	}

  
	/**
	 * Get the RelatedUserId column value.
	 *  
	 * @return int	  
	 */
	public function getRelatedUserId()
	{
		return $this->related_user_id;
	}


	/**
	 * Set the value of `related_user_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setRelatedUserId($v)
	{
		if ($this->related_user_id !== $v) {
			$this->related_user_id = $v;
			$this->modifiedColumns[] = UserRelationPeer::RELATED_USER_ID;
		}
			
		if ($this->aUserRelatedByRelatedUserId !== null && $this->aUserRelatedByRelatedUserId->getUserId() !== $v) {
			$this->aUserRelatedByRelatedUserId = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->user_id = $rs->getInt($startcol + 0);					
			$this->related_user_id = $rs->getInt($startcol + 1);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating UserRelation object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(UserRelationPeer::DATABASE_NAME);
		$criteria->add(UserRelationPeer::USER_ID, $this->user_id);
		$criteria->add(UserRelationPeer::RELATED_USER_ID, $this->related_user_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(UserRelationPeer::DATABASE_NAME);
		if ($this->isColumnModified(UserRelationPeer::USER_ID)) $criteria->add(UserRelationPeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(UserRelationPeer::RELATED_USER_ID)) $criteria->add(UserRelationPeer::RELATED_USER_ID, $this->related_user_id);
		return $criteria;			
	}
	
	

	/**
	 * @var User	  
	 */
	protected $aUserRelatedByRelatedUserId;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUserRelatedByRelatedUserId($v)
	{
			
		if ($v === null) {
			$this->setRelatedUserId(NULL);
		} else {
			$this->setRelatedUserId($v->getUserId());
		}
   
		$this->aUserRelatedByRelatedUserId = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUserRelatedByRelatedUserId($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUserRelatedByRelatedUserId === null && ($this->related_user_id !== null)) {
	
			$this->aUserRelatedByRelatedUserId = UserPeer::retrieveByPK($this->related_user_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->related_user_id, $con);
			   $obj->addUserRelationsRelatedByRelatedUserId($this);
			 */
		}
		return $this->aUserRelatedByRelatedUserId;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserRelatedByRelatedUserIdKey($key)
	{

		$this->setRelatedUserId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUserRelatedByUserId;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUserRelatedByUserId($v)
	{
			
		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getUserId());
		}
   
		$this->aUserRelatedByUserId = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUserRelatedByUserId($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUserRelatedByUserId === null && ($this->user_id !== null)) {
	
			$this->aUserRelatedByUserId = UserPeer::retrieveByPK($this->user_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->user_id, $con);
			   $obj->addUserRelationsRelatedByUserId($this);
			 */
		}
		return $this->aUserRelatedByUserId;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserRelatedByUserIdKey($key)
	{

		$this->setUserId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("user_id", "related_user_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case UserRelationPeer::USER_ID:
				return $this->getUserId();
				break;
		  
			case UserRelationPeer::RELATED_USER_ID:
				return $this->getRelatedUserId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getUserId();
				break;
  
			case 1:
				return $this->getRelatedUserId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(UserRelationPeer::USER_ID, $arr)) $this->setUserId($arr[UserRelationPeer::USER_ID]);
  
		if (array_key_exists(UserRelationPeer::RELATED_USER_ID, $arr)) $this->setRelatedUserId($arr[UserRelationPeer::RELATED_USER_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case UserRelationPeer::USER_ID:
				$this->setUserId($value);
				break;
	  
			case UserRelationPeer::RELATED_USER_ID:
				$this->setRelatedUserId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setUserId($value);
				break;
  
			case 1:
				$this->setRelatedUserId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserRelationPeer::DATABASE_NAME);

		try {
			$con->begin();
			UserRelationPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserRelationPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aUserRelatedByRelatedUserId !== null) {
				if ($this->aUserRelatedByRelatedUserId->isModified()) $this->aUserRelatedByRelatedUserId->save($con);
				$this->setUserRelatedByRelatedUserId($this->aUserRelatedByRelatedUserId);
			}
 
			if ($this->aUserRelatedByUserId !== null) {
				if ($this->aUserRelatedByUserId->isModified()) $this->aUserRelatedByUserId->save($con);
				$this->setUserRelatedByUserId($this->aUserRelatedByUserId);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UserRelationPeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					UserRelationPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return UserRelationPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aUserRelatedByRelatedUserId !== null) {
				if (($retval = $this->aUserRelatedByRelatedUserId->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUserRelatedByUserId !== null) {
				if (($retval = $this->aUserRelatedByUserId->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = UserRelationPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  


	private $pks = array();
	
	/**
	 * Set the PrimaryKey.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 * @throws PropelException
	 */
	public function setPrimaryKey($keys)
	{						

		$this->setUserId($keys[0]);

		$this->setRelatedUserId($keys[1]);

	}


	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return array 
	 */
	public function getPrimaryKey()
	{
		$this->pks[0] = $this->getUserId();
		$this->pks[1] = $this->getRelatedUserId();
		return $this->pks;

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return UserRelation Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new UserRelation();
		
		$copyObj->setNew(true);
		
		$copyObj->setUserId(NULL); // this is a pkey column, so set to default value
		$copyObj->setRelatedUserId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return UserRelationPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UserRelationPeer();
		}
		return self::$peer;
	}

}
