<?php 
/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2005 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * "Support Open Source software. What about a donation today?"
 * 
 * File Name: upload.php
 * 	This is the "File Uploader" for PHP.
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

require_once('initialize.php');
require_once('lib/session/Session.php');
require_once('lib/core/Filesystem.php');

require('config.php') ;
require('../../connectors/php/util.php') ;
require('../../connectors/php/io.php') ;

$Section = 'htmleditor';
if (isset($_GET['project_id'])) {
	$RefId = $_GET['project_id'];
} else {
	$RefId = 0;
}

// This is the function that sends the results of the uploading process.
function SendResults( $errorNumber, $fileUrl = '', $fileName = '', $customMsg = '' )
{
	echo '<script type="text/javascript">' ;
	echo 'window.parent.OnUploadCompleted(' . $errorNumber . ',"' . str_replace( '"', '\\"', $fileUrl ) . '","' . str_replace( '"', '\\"', $fileName ) . '", "' . str_replace( '"', '\\"', $customMsg ) . '") ;' ;
	echo '</script>' ;
	exit ;
}

$session = Session::getSession();
// user is already logged in
if (isset($_COOKIE['sessionHash'])) {
	$ip = $_SERVER['REMOTE_ADDR'];
	try {
		$session->setup($_COOKIE['sessionHash'], $ip);
	} catch (SessionException $ex) {
		// This means the cookie is invalid... we delete it
		setcookie('sessionHash', false, 0, '/');		// set expiration one year ago
		SendResults('1000', '', '', 'Not logged in');
	}
} else {
	SendResults('1000', '', '', 'Not logged in');
}

// Check if this uploader has been enabled.
if ( !$Config['Enabled'] )
	SendResults( '1', '', '', 'This file uploader is disabled. Please check the "editor/filemanager/upload/php/config.php" file' ) ;

// Check if the file has been correctly uploaded.
if ( !isset( $_FILES['NewFile'] ) || is_null( $_FILES['NewFile']['tmp_name'] ) || $_FILES['NewFile']['name'] == '' )
	SendResults( '202' ) ;

// Get the posted file.
$oFile = $_FILES['NewFile'] ;

// Get the uploaded file name and extension.
$sFileName = $oFile['name'] ;
$sOriginalFileName = $sFileName ;
$sExtension = substr( $sFileName, ( strrpos($sFileName, '.') + 1 ) ) ;
$sExtension = strtolower( $sExtension ) ;

// The the file type (from the QueryString, by default 'File').
$sType = isset( $_GET['Type'] ) ? $_GET['Type'] : 'File' ;

// Get the allowed and denied extensions arrays.
$arAllowed	= $Config['AllowedExtensions'][$sType] ;
$arDenied	= $Config['DeniedExtensions'][$sType] ;

// Check if it is an allowed extension.
if ( ( count($arAllowed) > 0 && !in_array( $sExtension, $arAllowed ) ) || ( count($arDenied) > 0 && in_array( $sExtension, $arDenied ) ) )
	SendResults( '202' ) ;

$sErrorNumber	= '0' ;
$sFileUrl		= '' ;

try {
	$User = $session->getUser();
	$filepath = GFConf::get('system.filesPath').'/'.$Section;
	$FsObj=new Filesystem();
	$FsObj->setPostedBy($User->getUserId());
	$FsObj->setRefId($RefId);
	$FsObj->setSection($Section);
	$FsObj->setFileType($oFile['type']);
	$FsObj->setFileName($sFileName);
	$FsObj->save();
	$FsObj->setFileDataFromPath($oFile['tmp_name']);
	SendResults($sErrorNumber, '/fckeditor/editor/filemanager/img.php?file='.$FsObj->getFilesystemId(), $FsObj->getFileNameSafe());
} catch (Exception $e) {
	SendResults('202');
}
?>