<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new DocmanFile and saves it to the 
// database
//
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Lang = Language::getSessLang();

$DocmanFile = DocmanFilePeer::retrieveByPk($_POST['id']);
if (is_object($DocmanFile) && $DocmanFile->userCanDelete()) {
	$subdir=$DocmanFile->getDocmanFolderId();
} else {
	throw new PermissionDeniedError();
}
if (isset($_POST['sure'])) {
	$DocmanFile->delete();
	GFUrl::redirect($url->currentBaseURL('DocmanFileBrowse'), array('feedback' => $Lang->getText('DocmanFile.DeleteFeedback'),'subdir'=>$subdir));
} else {
	GFUrl::redirect($url->currentBaseURL('DocmanFileBrowse'), array('feedback' => $Lang->getText('DocmanFileDeleteForm.DidntConfirm'),'subdir'=>$subdir));
}

?>
