<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 * @date 2006-03-08
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/docman/lib/InfoParser.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/html/TagsRenderer.php');

$theme->header($params);
?>
<form name="docedit" action="<?php echo GFUrl::getUrl()->currentBaseURL('DocmanFileEditAction') ?>" method="POST">
	<input type="hidden" name="id" value="<?php echo $id; ?>" />
	<table border="0">
	<tr>
		<td><img src="/images/docman_doc.gif" height="16" width="16" border="0">&nbsp;[#<?php echo $id ;?>] <?php echo $file->getLatestVersion()->getFile()->getFileName(); ?></td>
	</tr>
	<tr>
		<td><strong><?php echo $Lang->getText('Docman.Folder'); ?>:</strong><br />
		<?php
			$parser = new InfoParser($project);
			$nested_folders = $parser->getNestedFolders();
			$result = array();
			$res = HTMLWidget::renderArranged($nested_folders,0,0,$result,false); // get the elements 
			echo HTMLWidget::selectBoxFromAssoc($res,'folder_id',$folder_id,false,false);			
		?>
		</td>
	</tr>
	<tr>
		<td><strong><?php echo $Lang->getText('Docman.Locked'); ?>:</strong><br /><input type="checkbox" <?php echo ($is_locked ? "checked" : " ")?> name="is_locked" /></td>
	</tr>
	<tr>
		<td><strong><?php echo $Lang->getText('Docman.DescriptionName'); ?>:</strong><br />
		<textarea rows="4" cols="40" name="description"><?php echo $description; ?></textarea></td>
	</tr>
	<tr>
		<td align="center">
			<?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.edit') . " ","submitupdate","","")?>
			<?php 
				if ($return_to == 'admin') {
			?>
			<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'','docman','admin',array('subdir' => $subdir)) . "'; ")?>
			<?php 
				} else {
			?>
			<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'DocmanFileEdit','docman','',array('id' => $id)) . "'; ")?>
			<?php 
				}
			?>
		</td>
	</tr>		
</table>
</form>
<?php
/*
        Get the versions of docs
*/
$rs = DocmanFilePeer::doSelectDocumentVersionsRS($id, false);

$theader = array();
$theader[] = $Lang->getText('Docman.Download');
$theader[] = $Lang->getText('Docman.Version');
$theader[] = $Lang->getText('Docman.Approve');
$theader[] = $Lang->getText('Delete');
$theader[] = $Lang->getText('Docman.ChangesName');
$theader[] = $Lang->getText('Docman.DateName');
$theader[] = $Lang->getText('Docman.Author');

?>
<div id="mainTabSet" class="tabber">
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='versions') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('Docman.Versions'); ?>" id="versionstab">
<?php

echo $theme->tableTop($theader);

while ($rs->next()) {
	$trow = array();
	$url = GFUrl::getURL()->downloadURL(DocmanFileVersion::SECTION,$rs->getInt('docman_file_version_id'),$rs->getInt('filesystem_id'),$rs->getString('file_name_safe'));
	$trow[] = '<a href="'.$url.'"><img src="/images/docman_doc.gif" height="16" width="16" border="0">&nbsp;'.$rs->getString('file_name_safe').'</a>';	
	$trow[] = $rs->getInt('version_number');	
	if ($rs->getBoolean('is_approved')) {
		$trow[] = ' ';
	} else {
		$trow[] = '<a href="'.GFUrl::getURL()->projectUrl($project,'DocmanFileVersionApprove','docman','admin',array('docman_file_version_id'=>$rs->getInt('docman_file_version_id'))).'">Approve</a>';
	}
	if ($versions > 1) {
		$trow[] = '<a href="'.GFUrl::getURL()->projectUrl($project,'DocmanFileVersionDelete','docman','admin',array('docman_file_version_id'=>$rs->getInt('docman_file_version_id'))).'">'.$Lang->getText('Docman.DeleteFileVersion').'</a>';
	} else {
		$trow[] = '<a href="'.GFUrl::getURL()->projectUrl($project,'DocmanFileDelete','docman','admin',array('id'=>$rs->getInt('docman_file_id'))).'">'.$Lang->getText('Docman.DeleteFile').'</a>';
	}
	$trow[] = $rs->getString('changes');
	$trow[] = $rs->getDate('create_date');
	$trow[] = UserPeer::retrieveByPk($rs->getInt('created_by'))->getUserLink();
	echo $theme->tableRow($trow);	
}

	if ($file->userCanUpdate()) {
		$button_enabled = true;
	} else {
		$button_enabled = false;
	}
	echo $theme->tableBottom(array(GFUrl::getURL()->projectUrl($project,'DocmanFileVersionAdd','docman','',array('id'=>$id,'redirect_to'=>'admin'))=>$Lang->getText('Docman.AddNewVersion')),array($button_enabled));
?>
</div>
<?php
$settings = DocmanProjectSettingPeer::retrieveByPk(GFUrl::getUrl()->getProject()->getProjectId());
/* express doesn't have associations
if(!$settings || $settings->getShowAssociationsTab()){
?>
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='associations') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('Associations') ?>" id="associationstab">
<?php
	echo renderAssociationList(DocmanFile::SECTION,$file->getDocmanFileId(),$file->userCanUpdate(),$theme,$project);
?>
</div>
<?php

}
*/
if(!$settings || $settings->getShowTagsTab()){
?>
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='tags') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('Tag.TabHeader') ?>" id="tagstab">
<?php 
echo TagsRenderer::getTagsTable($file->getDocmanFileId(),DocmanFile::SECTION, $theme);

?>

</div>
<?php }?>

</div>
<?php
$theme->footer($params);
?>
