<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';

include_once 'plugins/frs/lib/FrsPackagePeer.php';

/**
 * Base class that represents a row from the 'frs_package' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to FrsPackage class. 
 * 
 * @package plugins.frs.lib 
 */
abstract class BaseFrsPackage extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var FrsPackagePeer
	 */
	protected static $peer;

	/**
	 * The value for the frs_package_id field.
	 * @var int	  
	 */
	protected $frs_package_id;	

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the package_name field.
	 * @var string	  
	 */
	protected $package_name;	

	/**
	 * The value for the status_id field.
	 * @var int	  
	 */
	protected $status_id = 1;	

	/**
	 * The value for the is_public field.
	 * @var boolean	  
	 */
	protected $is_public = true;	

	/**
	 * The value for the require_login field.
	 * @var boolean	  
	 */
	protected $require_login = false;	
  
	/**
	 * Get the FrsPackageId column value.
	 *  
	 * @return int	  
	 */
	public function getFrsPackageId()
	{
		return $this->frs_package_id;
	}


	/**
	 * Set the value of `frs_package_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setFrsPackageId($v)
	{
		if ($this->frs_package_id !== $v) {
			$this->frs_package_id = $v;
			$this->modifiedColumns[] = FrsPackagePeer::FRS_PACKAGE_ID;
		}
			
		  // update associated FrsRelease		  
		  if ($this->collFrsReleases !== null) {
			  for ($i=0,$size=count($this->collFrsReleases); $i < $size; $i++) {
				  $this->collFrsReleases[$i]->setFrsPackageId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = FrsPackagePeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the PackageName column value.
	 *  
	 * @return string	  
	 */
	public function getPackageName()
	{
		return $this->package_name;
	}


	/**
	 * Set the value of `package_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setPackageName($v)
	{
		if ($this->package_name !== $v) {
			$this->package_name = $v;
			$this->modifiedColumns[] = FrsPackagePeer::PACKAGE_NAME;
		}
				
	}

  
	/**
	 * Get the StatusId column value.
	 *  
	 * @return int	  
	 */
	public function getStatusId()
	{
		return $this->status_id;
	}


	/**
	 * Set the value of `status_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setStatusId($v)
	{
		if ($this->status_id !== $v || $v === 1) {
			$this->status_id = $v;
			$this->modifiedColumns[] = FrsPackagePeer::STATUS_ID;
		}
				
	}

  
	/**
	 * Get the IsPublic column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsPublic()
	{
		return $this->is_public;
	}


	/**
	 * Set the value of `is_public` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsPublic($v)
	{
		if ($this->is_public !== $v || $v === true) {
			$this->is_public = $v;
			$this->modifiedColumns[] = FrsPackagePeer::IS_PUBLIC;
		}
				
	}

  
	/**
	 * Get the RequireLogin column value.
	 *  
	 * @return boolean	  
	 */
	public function getRequireLogin()
	{
		return $this->require_login;
	}


	/**
	 * Set the value of `require_login` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setRequireLogin($v)
	{
		if ($this->require_login !== $v || $v === false) {
			$this->require_login = $v;
			$this->modifiedColumns[] = FrsPackagePeer::REQUIRE_LOGIN;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->frs_package_id = $rs->getInt($startcol + 0);					
			$this->project_id = $rs->getInt($startcol + 1);					
			$this->package_name = $rs->getString($startcol + 2);					
			$this->status_id = $rs->getInt($startcol + 3);					
			$this->is_public = $rs->getBoolean($startcol + 4);					
			$this->require_login = $rs->getBoolean($startcol + 5);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating FrsPackage object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(FrsPackagePeer::DATABASE_NAME);
		$criteria->add(FrsPackagePeer::FRS_PACKAGE_ID, $this->frs_package_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(FrsPackagePeer::DATABASE_NAME);
		if ($this->isColumnModified(FrsPackagePeer::FRS_PACKAGE_ID)) $criteria->add(FrsPackagePeer::FRS_PACKAGE_ID, $this->frs_package_id);
		if ($this->isColumnModified(FrsPackagePeer::PROJECT_ID)) $criteria->add(FrsPackagePeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(FrsPackagePeer::PACKAGE_NAME)) $criteria->add(FrsPackagePeer::PACKAGE_NAME, $this->package_name);
		if ($this->isColumnModified(FrsPackagePeer::STATUS_ID)) $criteria->add(FrsPackagePeer::STATUS_ID, $this->status_id);
		if ($this->isColumnModified(FrsPackagePeer::IS_PUBLIC)) $criteria->add(FrsPackagePeer::IS_PUBLIC, $this->is_public);
		if ($this->isColumnModified(FrsPackagePeer::REQUIRE_LOGIN)) $criteria->add(FrsPackagePeer::REQUIRE_LOGIN, $this->require_login);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addFrsPackages($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collFrsReleases	  
	 * @var array
	 */
	protected $collFrsReleases; 

	/**
	 * Temporary storage of collFrsReleases to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initFrsReleases()
	{
		if ($this->collFrsReleases === null) {
			$this->collFrsReleases = array();
		}
	}

	/**
	 * Method called to associate a FrsRelease object to this object
	 * through the FrsRelease foreign key attribute
	 *
	 * @param FrsRelease $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addFrsRelease(FrsRelease $l)
	{
		$this->collFrsReleases[] = $l;
		$l->setFrsPackage($this);
	}

	/**
	 * The criteria used to select the current contents of collFrsReleases.
	 * @var Criteria
	 */
	private $lastFrsReleasesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this FrsPackage has previously
	 * been saved, it will retrieve related FrsReleases from storage.
	 * If this FrsPackage is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getFrsReleases($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/frs/lib/FrsReleasePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collFrsReleases === null) {
			if ($this->isNew()) {
			   $this->collFrsReleases = array();
			} else {
	
				$criteria->add(FrsReleasePeer::FRS_PACKAGE_ID, $this->getFrsPackageId() );

				$this->collFrsReleases = FrsReleasePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(FrsReleasePeer::FRS_PACKAGE_ID, $this->getFrsPackageId());

				if (!isset($this->lastFrsReleasesCriteria) || !$this->lastFrsReleasesCriteria->equals($criteria)) {
					$this->collFrsReleases = FrsReleasePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastFrsReleasesCriteria = $criteria;

		return $this->collFrsReleases;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this FrsPackage is new, it will return
	 * an empty collection; or if this FrsPackage has previously
	 * been saved, it will retrieve related FrsReleases from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in FrsPackage.
	 */
	public function getFrsReleasesJoinFrsPackage($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/frs/lib/FrsReleasePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collFrsReleases === null) {
			if ($this->isNew()) {
			   $this->collFrsReleases = array();
			} else {
	   
				$criteria->add(FrsReleasePeer::FRS_PACKAGE_ID, $this->getFrsPackageId());
				$this->collFrsReleases = FrsReleasePeer::doSelectJoinFrsPackage($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(FrsReleasePeer::FRS_PACKAGE_ID, $this->getFrsPackageId());
			if (!isset($this->lastFrsReleasesCriteria) || !$this->lastFrsReleasesCriteria->equals($criteria)) {
				$this->collFrsReleases = FrsReleasePeer::doSelectJoinFrsPackage($criteria, $con);
			}
		}
		$this->lastFrsReleasesCriteria = $criteria;

		return $this->collFrsReleases;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this FrsPackage is new, it will return
	 * an empty collection; or if this FrsPackage has previously
	 * been saved, it will retrieve related FrsReleases from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in FrsPackage.
	 */
	public function getFrsReleasesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/frs/lib/FrsReleasePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collFrsReleases === null) {
			if ($this->isNew()) {
			   $this->collFrsReleases = array();
			} else {
	   
				$criteria->add(FrsReleasePeer::FRS_PACKAGE_ID, $this->getFrsPackageId());
				$this->collFrsReleases = FrsReleasePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(FrsReleasePeer::FRS_PACKAGE_ID, $this->getFrsPackageId());
			if (!isset($this->lastFrsReleasesCriteria) || !$this->lastFrsReleasesCriteria->equals($criteria)) {
				$this->collFrsReleases = FrsReleasePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastFrsReleasesCriteria = $criteria;

		return $this->collFrsReleases;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("frs_package_id", "project_id", "package_name", "status_id", "is_public", "require_login", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case FrsPackagePeer::FRS_PACKAGE_ID:
				return $this->getFrsPackageId();
				break;
		  
			case FrsPackagePeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case FrsPackagePeer::PACKAGE_NAME:
				return $this->getPackageName();
				break;
		  
			case FrsPackagePeer::STATUS_ID:
				return $this->getStatusId();
				break;
		  
			case FrsPackagePeer::IS_PUBLIC:
				return $this->getIsPublic();
				break;
		  
			case FrsPackagePeer::REQUIRE_LOGIN:
				return $this->getRequireLogin();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getFrsPackageId();
				break;
  
			case 1:
				return $this->getProjectId();
				break;
  
			case 2:
				return $this->getPackageName();
				break;
  
			case 3:
				return $this->getStatusId();
				break;
  
			case 4:
				return $this->getIsPublic();
				break;
  
			case 5:
				return $this->getRequireLogin();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(FrsPackagePeer::FRS_PACKAGE_ID, $arr)) $this->setFrsPackageId($arr[FrsPackagePeer::FRS_PACKAGE_ID]);
  
		if (array_key_exists(FrsPackagePeer::PROJECT_ID, $arr)) $this->setProjectId($arr[FrsPackagePeer::PROJECT_ID]);
  
		if (array_key_exists(FrsPackagePeer::PACKAGE_NAME, $arr)) $this->setPackageName($arr[FrsPackagePeer::PACKAGE_NAME]);
  
		if (array_key_exists(FrsPackagePeer::STATUS_ID, $arr)) $this->setStatusId($arr[FrsPackagePeer::STATUS_ID]);
  
		if (array_key_exists(FrsPackagePeer::IS_PUBLIC, $arr)) $this->setIsPublic($arr[FrsPackagePeer::IS_PUBLIC]);
  
		if (array_key_exists(FrsPackagePeer::REQUIRE_LOGIN, $arr)) $this->setRequireLogin($arr[FrsPackagePeer::REQUIRE_LOGIN]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case FrsPackagePeer::FRS_PACKAGE_ID:
				$this->setFrsPackageId($value);
				break;
	  
			case FrsPackagePeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case FrsPackagePeer::PACKAGE_NAME:
				$this->setPackageName($value);
				break;
	  
			case FrsPackagePeer::STATUS_ID:
				$this->setStatusId($value);
				break;
	  
			case FrsPackagePeer::IS_PUBLIC:
				$this->setIsPublic($value);
				break;
	  
			case FrsPackagePeer::REQUIRE_LOGIN:
				$this->setRequireLogin($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setFrsPackageId($value);
				break;
  
			case 1:
				$this->setProjectId($value);
				break;
  
			case 2:
				$this->setPackageName($value);
				break;
  
			case 3:
				$this->setStatusId($value);
				break;
  
			case 4:
				$this->setIsPublic($value);
				break;
  
			case 5:
				$this->setRequireLogin($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(FrsPackagePeer::DATABASE_NAME);

		try {
			$con->begin();
			FrsPackagePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(FrsPackagePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FrsPackagePeer::doInsert($this, $con);
					$this->setFrsPackageId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					FrsPackagePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collFrsReleases !== null) {
				for ($i=0,$size=count($this->collFrsReleases); $i < $size; $i++) {
					$this->collFrsReleases[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return FrsPackagePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = FrsPackagePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collFrsReleases !== null) {
				for ($i=0,$size=count($this->collFrsReleases); $i < $size; $i++) {
					if (($retval = $this->collFrsReleases[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed frs_package_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setFrsPackageId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getFrsPackageId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return FrsPackage Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new FrsPackage();
		$copyObj->setProjectId($this->project_id);
		$copyObj->setPackageName($this->package_name);
		$copyObj->setStatusId($this->status_id);
		$copyObj->setIsPublic($this->is_public);
		$copyObj->setRequireLogin($this->require_login);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getFrsReleases() as $relObj) {
				$copyObj->addFrsRelease($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setFrsPackageId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return FrsPackagePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FrsPackagePeer();
		}
		return self::$peer;
	}

}
