<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/frs/lib/FrsPackage.php';
// (on-demand) include_once 'plugins/frs/lib/FrsPackagePeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/frs/lib/FrsReleasePeer.php';

/**
 * Base class that represents a row from the 'frs_release' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to FrsRelease class. 
 * 
 * @package plugins.frs.lib 
 */
abstract class BaseFrsRelease extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var FrsReleasePeer
	 */
	protected static $peer;

	/**
	 * The value for the frs_release_id field.
	 * @var int	  
	 */
	protected $frs_release_id;	

	/**
	 * The value for the frs_package_id field.
	 * @var int	  
	 */
	protected $frs_package_id;	

	/**
	 * The value for the release_name field.
	 * @var string	  
	 */
	protected $release_name;	

	/**
	 * The value for the release_notes field.
	 * @var string	  
	 */
	protected $release_notes;	

	/**
	 * The value for the changes field.
	 * @var string	  
	 */
	protected $changes;	

	/**
	 * The value for the status_id field.
	 * @var int	  
	 */
	protected $status_id = 1;	

	/**
	 * The value for the preformatted field.
	 * @var boolean	  
	 */
	protected $preformatted = false;	

	/**
	 * The value for the release_date field.
	 * @var int	  
	 */
	protected $release_date = -1;	

	/**
	 * The value for the released_by field.
	 * @var int	  
	 */
	protected $released_by;	

	/**
	 * The value for the is_released field.
	 * @var boolean	  
	 */
	protected $is_released = false;	
  
	/**
	 * Get the FrsReleaseId column value.
	 *  
	 * @return int	  
	 */
	public function getFrsReleaseId()
	{
		return $this->frs_release_id;
	}


	/**
	 * Set the value of `frs_release_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setFrsReleaseId($v)
	{
		if ($this->frs_release_id !== $v) {
			$this->frs_release_id = $v;
			$this->modifiedColumns[] = FrsReleasePeer::FRS_RELEASE_ID;
		}
				
	}

  
	/**
	 * Get the FrsPackageId column value.
	 *  
	 * @return int	  
	 */
	public function getFrsPackageId()
	{
		return $this->frs_package_id;
	}


	/**
	 * Set the value of `frs_package_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setFrsPackageId($v)
	{
		if ($this->frs_package_id !== $v) {
			$this->frs_package_id = $v;
			$this->modifiedColumns[] = FrsReleasePeer::FRS_PACKAGE_ID;
		}
			
		if ($this->aFrsPackage !== null && $this->aFrsPackage->getFrsPackageId() !== $v) {
			$this->aFrsPackage = null;
		}
			
	}

  
	/**
	 * Get the ReleaseName column value.
	 *  
	 * @return string	  
	 */
	public function getReleaseName()
	{
		return $this->release_name;
	}


	/**
	 * Set the value of `release_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setReleaseName($v)
	{
		if ($this->release_name !== $v) {
			$this->release_name = $v;
			$this->modifiedColumns[] = FrsReleasePeer::RELEASE_NAME;
		}
				
	}

  
	/**
	 * Get the ReleaseNotes column value.
	 *  
	 * @return string	  
	 */
	public function getReleaseNotes()
	{
		return $this->release_notes;
	}


	/**
	 * Set the value of `release_notes` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setReleaseNotes($v)
	{
		if ($this->release_notes !== $v) {
			$this->release_notes = $v;
			$this->modifiedColumns[] = FrsReleasePeer::RELEASE_NOTES;
		}
				
	}

  
	/**
	 * Get the Changes column value.
	 *  
	 * @return string	  
	 */
	public function getChanges()
	{
		return $this->changes;
	}


	/**
	 * Set the value of `changes` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setChanges($v)
	{
		if ($this->changes !== $v) {
			$this->changes = $v;
			$this->modifiedColumns[] = FrsReleasePeer::CHANGES;
		}
				
	}

  
	/**
	 * Get the StatusId column value.
	 *  
	 * @return int	  
	 */
	public function getStatusId()
	{
		return $this->status_id;
	}


	/**
	 * Set the value of `status_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setStatusId($v)
	{
		if ($this->status_id !== $v || $v === 1) {
			$this->status_id = $v;
			$this->modifiedColumns[] = FrsReleasePeer::STATUS_ID;
		}
				
	}

  
	/**
	 * Get the Preformatted column value.
	 *  
	 * @return boolean	  
	 */
	public function getPreformatted()
	{
		return $this->preformatted;
	}


	/**
	 * Set the value of `preformatted` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setPreformatted($v)
	{
		if ($this->preformatted !== $v || $v === false) {
			$this->preformatted = $v;
			$this->modifiedColumns[] = FrsReleasePeer::PREFORMATTED;
		}
				
	}


	/**
	 * Get the [optionally formatted] `release_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getReleaseDate($format = 'Y-m-d H:i:s')
	{
		if ($this->release_date === null || $this->release_date === '') {
			return null;
		} elseif (!is_int($this->release_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->release_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of release_date as date/time value: " . var_export($this->release_date, true));
			}
		} else {
			$ts = $this->release_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `release_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setReleaseDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for release_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->release_date !== $ts || $ts === -1) {
			$this->release_date = $ts;
			$this->modifiedColumns[] = FrsReleasePeer::RELEASE_DATE;
		}
		
	}

  
	/**
	 * Get the ReleasedBy column value.
	 *  
	 * @return int	  
	 */
	public function getReleasedBy()
	{
		return $this->released_by;
	}


	/**
	 * Set the value of `released_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setReleasedBy($v)
	{
		if ($this->released_by !== $v) {
			$this->released_by = $v;
			$this->modifiedColumns[] = FrsReleasePeer::RELEASED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the IsReleased column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsReleased()
	{
		return $this->is_released;
	}


	/**
	 * Set the value of `is_released` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsReleased($v)
	{
		if ($this->is_released !== $v || $v === false) {
			$this->is_released = $v;
			$this->modifiedColumns[] = FrsReleasePeer::IS_RELEASED;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->frs_release_id = $rs->getInt($startcol + 0);					
			$this->frs_package_id = $rs->getInt($startcol + 1);					
			$this->release_name = $rs->getString($startcol + 2);					
			$this->release_notes = $rs->getString($startcol + 3);					
			$this->changes = $rs->getString($startcol + 4);					
			$this->status_id = $rs->getInt($startcol + 5);					
			$this->preformatted = $rs->getBoolean($startcol + 6);					
			$this->release_date = $rs->getTimestamp($startcol + 7, null);
			$this->released_by = $rs->getInt($startcol + 8);					
			$this->is_released = $rs->getBoolean($startcol + 9);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating FrsRelease object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(FrsReleasePeer::DATABASE_NAME);
		$criteria->add(FrsReleasePeer::FRS_RELEASE_ID, $this->frs_release_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(FrsReleasePeer::DATABASE_NAME);
		if ($this->isColumnModified(FrsReleasePeer::FRS_RELEASE_ID)) $criteria->add(FrsReleasePeer::FRS_RELEASE_ID, $this->frs_release_id);
		if ($this->isColumnModified(FrsReleasePeer::FRS_PACKAGE_ID)) $criteria->add(FrsReleasePeer::FRS_PACKAGE_ID, $this->frs_package_id);
		if ($this->isColumnModified(FrsReleasePeer::RELEASE_NAME)) $criteria->add(FrsReleasePeer::RELEASE_NAME, $this->release_name);
		if ($this->isColumnModified(FrsReleasePeer::RELEASE_NOTES)) $criteria->add(FrsReleasePeer::RELEASE_NOTES, $this->release_notes);
		if ($this->isColumnModified(FrsReleasePeer::CHANGES)) $criteria->add(FrsReleasePeer::CHANGES, $this->changes);
		if ($this->isColumnModified(FrsReleasePeer::STATUS_ID)) $criteria->add(FrsReleasePeer::STATUS_ID, $this->status_id);
		if ($this->isColumnModified(FrsReleasePeer::PREFORMATTED)) $criteria->add(FrsReleasePeer::PREFORMATTED, $this->preformatted);
		if ($this->isColumnModified(FrsReleasePeer::RELEASE_DATE)) $criteria->add(FrsReleasePeer::RELEASE_DATE, $this->release_date);
		if ($this->isColumnModified(FrsReleasePeer::RELEASED_BY)) $criteria->add(FrsReleasePeer::RELEASED_BY, $this->released_by);
		if ($this->isColumnModified(FrsReleasePeer::IS_RELEASED)) $criteria->add(FrsReleasePeer::IS_RELEASED, $this->is_released);
		return $criteria;			
	}
	
	

	/**
	 * @var FrsPackage	  
	 */
	protected $aFrsPackage;

	/**
	 * Declares an association between this object and a FrsPackage object
	 *
	 * @param FrsPackage $v
	 * @return void
	 * @throws PropelException
	 */
	public function setFrsPackage($v)
	{
			
		if ($v === null) {
			$this->setFrsPackageId(NULL);
		} else {
			$this->setFrsPackageId($v->getFrsPackageId());
		}
   
		$this->aFrsPackage = $v;
	}


	/**
	 * Get the associated FrsPackage object
	 *
	 * @param Connection Optional Connection object.
	 * @return FrsPackage The associated FrsPackage object.
	 * @throws PropelException
	 */
	public function getFrsPackage($con = null)
	{
		// include the Peer class
		include_once 'plugins/frs/lib/FrsPackagePeer.php';

		if ($this->aFrsPackage === null && ($this->frs_package_id !== null)) {
	
			$this->aFrsPackage = FrsPackagePeer::retrieveByPK($this->frs_package_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = FrsPackagePeer::retrieveByPK($this->frs_package_id, $con);
			   $obj->addFrsReleases($this);
			 */
		}
		return $this->aFrsPackage;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setFrsPackageKey($key)
	{

		$this->setFrsPackageId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setReleasedBy(NULL);
		} else {
			$this->setReleasedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->released_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->released_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->released_by, $con);
			   $obj->addFrsReleases($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setReleasedBy( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("frs_release_id", "frs_package_id", "release_name", "release_notes", "changes", "status_id", "preformatted", "release_date", "released_by", "is_released", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case FrsReleasePeer::FRS_RELEASE_ID:
				return $this->getFrsReleaseId();
				break;
		  
			case FrsReleasePeer::FRS_PACKAGE_ID:
				return $this->getFrsPackageId();
				break;
		  
			case FrsReleasePeer::RELEASE_NAME:
				return $this->getReleaseName();
				break;
		  
			case FrsReleasePeer::RELEASE_NOTES:
				return $this->getReleaseNotes();
				break;
		  
			case FrsReleasePeer::CHANGES:
				return $this->getChanges();
				break;
		  
			case FrsReleasePeer::STATUS_ID:
				return $this->getStatusId();
				break;
		  
			case FrsReleasePeer::PREFORMATTED:
				return $this->getPreformatted();
				break;
		  
			case FrsReleasePeer::RELEASE_DATE:
				return $this->getReleaseDate();
				break;
		  
			case FrsReleasePeer::RELEASED_BY:
				return $this->getReleasedBy();
				break;
		  
			case FrsReleasePeer::IS_RELEASED:
				return $this->getIsReleased();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getFrsReleaseId();
				break;
  
			case 1:
				return $this->getFrsPackageId();
				break;
  
			case 2:
				return $this->getReleaseName();
				break;
  
			case 3:
				return $this->getReleaseNotes();
				break;
  
			case 4:
				return $this->getChanges();
				break;
  
			case 5:
				return $this->getStatusId();
				break;
  
			case 6:
				return $this->getPreformatted();
				break;
  
			case 7:
				return $this->getReleaseDate();
				break;
  
			case 8:
				return $this->getReleasedBy();
				break;
  
			case 9:
				return $this->getIsReleased();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(FrsReleasePeer::FRS_RELEASE_ID, $arr)) $this->setFrsReleaseId($arr[FrsReleasePeer::FRS_RELEASE_ID]);
  
		if (array_key_exists(FrsReleasePeer::FRS_PACKAGE_ID, $arr)) $this->setFrsPackageId($arr[FrsReleasePeer::FRS_PACKAGE_ID]);
  
		if (array_key_exists(FrsReleasePeer::RELEASE_NAME, $arr)) $this->setReleaseName($arr[FrsReleasePeer::RELEASE_NAME]);
  
		if (array_key_exists(FrsReleasePeer::RELEASE_NOTES, $arr)) $this->setReleaseNotes($arr[FrsReleasePeer::RELEASE_NOTES]);
  
		if (array_key_exists(FrsReleasePeer::CHANGES, $arr)) $this->setChanges($arr[FrsReleasePeer::CHANGES]);
  
		if (array_key_exists(FrsReleasePeer::STATUS_ID, $arr)) $this->setStatusId($arr[FrsReleasePeer::STATUS_ID]);
  
		if (array_key_exists(FrsReleasePeer::PREFORMATTED, $arr)) $this->setPreformatted($arr[FrsReleasePeer::PREFORMATTED]);
  
		if (array_key_exists(FrsReleasePeer::RELEASE_DATE, $arr)) $this->setReleaseDate($arr[FrsReleasePeer::RELEASE_DATE]);
  
		if (array_key_exists(FrsReleasePeer::RELEASED_BY, $arr)) $this->setReleasedBy($arr[FrsReleasePeer::RELEASED_BY]);
  
		if (array_key_exists(FrsReleasePeer::IS_RELEASED, $arr)) $this->setIsReleased($arr[FrsReleasePeer::IS_RELEASED]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case FrsReleasePeer::FRS_RELEASE_ID:
				$this->setFrsReleaseId($value);
				break;
	  
			case FrsReleasePeer::FRS_PACKAGE_ID:
				$this->setFrsPackageId($value);
				break;
	  
			case FrsReleasePeer::RELEASE_NAME:
				$this->setReleaseName($value);
				break;
	  
			case FrsReleasePeer::RELEASE_NOTES:
				$this->setReleaseNotes($value);
				break;
	  
			case FrsReleasePeer::CHANGES:
				$this->setChanges($value);
				break;
	  
			case FrsReleasePeer::STATUS_ID:
				$this->setStatusId($value);
				break;
	  
			case FrsReleasePeer::PREFORMATTED:
				$this->setPreformatted($value);
				break;
	  
			case FrsReleasePeer::RELEASE_DATE:
				$this->setReleaseDate($value);
				break;
	  
			case FrsReleasePeer::RELEASED_BY:
				$this->setReleasedBy($value);
				break;
	  
			case FrsReleasePeer::IS_RELEASED:
				$this->setIsReleased($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setFrsReleaseId($value);
				break;
  
			case 1:
				$this->setFrsPackageId($value);
				break;
  
			case 2:
				$this->setReleaseName($value);
				break;
  
			case 3:
				$this->setReleaseNotes($value);
				break;
  
			case 4:
				$this->setChanges($value);
				break;
  
			case 5:
				$this->setStatusId($value);
				break;
  
			case 6:
				$this->setPreformatted($value);
				break;
  
			case 7:
				$this->setReleaseDate($value);
				break;
  
			case 8:
				$this->setReleasedBy($value);
				break;
  
			case 9:
				$this->setIsReleased($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(FrsReleasePeer::DATABASE_NAME);

		try {
			$con->begin();
			FrsReleasePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(FrsReleasePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aFrsPackage !== null) {
				if ($this->aFrsPackage->isModified()) $this->aFrsPackage->save($con);
				$this->setFrsPackage($this->aFrsPackage);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FrsReleasePeer::doInsert($this, $con);
					$this->setFrsReleaseId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					FrsReleasePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return FrsReleasePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aFrsPackage !== null) {
				if (($retval = $this->aFrsPackage->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = FrsReleasePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed frs_release_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setFrsReleaseId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getFrsReleaseId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return FrsRelease Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new FrsRelease();
		$copyObj->setFrsPackageId($this->frs_package_id);
		$copyObj->setReleaseName($this->release_name);
		$copyObj->setReleaseNotes($this->release_notes);
		$copyObj->setChanges($this->changes);
		$copyObj->setStatusId($this->status_id);
		$copyObj->setPreformatted($this->preformatted);
		$copyObj->setReleaseDate($this->release_date);
		$copyObj->setReleasedBy($this->released_by);
		$copyObj->setIsReleased($this->is_released);
		
		$copyObj->setNew(true);
		
		$copyObj->setFrsReleaseId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return FrsReleasePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FrsReleasePeer();
		}
		return self::$peer;
	}

}
