<?php

require_once("system/Cronjob.php");
require_once('core/CronHistory.php');
require_once('core/ProjectPluginPeer.php');
require_once('core/PluginPeer.php');
require_once('plugin/ActionManager.php');
require_once('core/UserUnixPeer.php');

class CreateSSHCronjob extends Cronjob {

	public function __construct() {
		$this->jobname = basename(__FILE__);
		parent::__construct();
	}

	public function run() {		
		
		$c = new Criteria();
		$c->add(UserUnixPeer::AUTHORIZED_KEYS, '', Criteria::NOT_EQUAL);
		$c->add(UserPeer::STATUS, 1);
		$Users = UserUnixPeer::doSelectJoinUser($c);
		
		foreach($Users as $user) {
			$user_unix_name = $user->getUser()->getUnixName();
			if (!SystemUtils::userExists($user_unix_name)) continue;
			
			$user_dir = SystemUtils::getHomedir($user_unix_name);
			if (!is_dir($user_dir)) {
				SystemUtils::initializeHomedir($user_unix_name);
			}

			$ssh_dir = SystemUtils::buildFilePath($user_dir, '/.ssh');
			if (!is_dir($ssh_dir)) mkdir($ssh_dir, 0755);
			chown($ssh_dir, $user_unix_name);
			chgrp($ssh_dir, 'users');
	
			$ssh = "# This file is automatically generated from your account settings.\n".str_replace('###',"\n", $user->getAuthorizedKeys());
			file_put_contents($ssh_dir.'/authorized_keys', $ssh);
			
			chmod ($ssh_dir.'/authorized_keys', 0644);
			chown ($ssh_dir.'/authorized_keys', $user_unix_name);
			chgrp ($ssh_dir.'/authorized_keys', 'users');
		}	
			
	}
}
$cronjob = new CreateSSHCronjob();
$cronjob->run();
?>
