<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('lib/html/SiteTemplate.php');
require_once('lib/plugin/PluginResult.php');

class SnippetTemplate extends SiteTemplate {

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	 */
	function header($params) {
		$params['selectedtoptab']='snippet';
		$Lang = Session::getSession()->getLanguage();
		if (isset($params['title'])) {
			$params['title']=' '.$Lang->getText('Snippet.TabString').' > '.$params['title'];
		} else {
			Throw new exception('Missing title in snippet template');
		}
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->currentBaseURL('','','','','').'">'.$Lang->getText('Snippet.TabString').'</a>');
		return parent::header($params);
	}

	/**
	 *	getPluginNavElements - this overrides parent class and adds its own 
	 *	plugin listener
	 *	@return	PluginResultSet
	 */
	function getPluginNavElements($params) {
		$prs = parent::getPluginNavElements($params);
	       	$tprs = ActionManager::Notify('GET_SNIPPET_NAV_ELEMENTS',null);
		foreach ($tprs as $pr) {
			$prs->addResult($pr);
		}
		return $prs;
	}

}

?>