<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

echo $theme->header($params);
echo '<p><div class="infobox">'.$Lang->getText('Tracker.AddTrackerDescription').'</div></p>';
?>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('TrackerAddAction') ?>" method="post">
	<table border="0">
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.TrackerNameName'); ?>&nbsp;*</strong><br />
			<input type="text" name="tracker_name" value="<?php echo $tracker_name; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.DescriptionName'); ?>&nbsp;*</strong><br />
			<input type="text" name="description" value="<?php echo $description; ?>" size="40" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.IsPublicName'); ?></strong><br />
			<input type="checkbox" name="is_public" value="1" <?php echo (($is_public==1) ? 'checked="checked"' : '' ) ?> /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.RestrictBrowseName'); ?></strong><br />
			<input type="checkbox" name="restrict_browse" value="1" <?php echo (($restrict_browse==1) ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.EmailAllUpdatesName'); ?></strong><br />
			<input type="checkbox" name="email_all_updates" value="1" <?php echo (($email_all_updates==1) ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.EmailAddressName'); ?></strong><br />
			<input type="text" name="email_address" value="<?php echo $email_address; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.DuePeriodName'); ?></strong><span class="required">*</span><br />
			<input type="text" name="due_period" value="15"  size="3" maxlength="3"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.SubmitInstructionsName'); ?></strong><br />
			<textarea name="submit_instructions" rows="10" cols="60"><?php echo $submit_instructions; ?></textarea></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.BrowseInstructionsName'); ?></strong><br />
			<textarea name="browse_instructions" rows="10" cols="60"><?php echo $browse_instructions; ?></textarea></td>
		</tr>

		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.ShowDependenciesTab'); ?></strong><br />
			<input type="checkbox" name="show_dependencies_tab" value="1" <?php echo ($show_dependencies_tab ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.ShowDuplicatesTab'); ?></strong><br />
			<input type="checkbox" name="show_duplicates_tab" value="1" <?php echo ($show_duplicates_tab ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tabs.ShowAssociationsTab'); ?></strong><br />
			<input type="checkbox" name="show_associations_tab" value="1" <?php echo ($show_associations_tab ? 'checked="checked"' : '' ) ?> disabled="disabled"/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.ShowTimeTrackingTab'); ?></strong><br />
			<input type="checkbox" name="show_time_tracking_tab" value="1" <?php echo ($show_time_tracking_tab ? 'checked="checked"' : '' ) ?> disabled="disabled"/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tabs.ShowTagsTab'); ?></strong><br />
			<input type="checkbox" name="show_tags_tab" value="1" <?php echo ($show_tags_tab ? 'checked="checked"' : '' ) ?>/></td>
		</tr>


		<tr>
			<td colspan="2"><strong><?php echo $Lang->getText('Tracker.DatatypeName'); ?></strong><br />
			<input type="radio" name="datatype" value="<?php echo Tracker::DATATYPE_TRACKER; ?>" <?php echo (($datatype==Tracker::DATATYPE_TRACKER) ? 'checked="checked"' : '' ) ?> /><?php echo $Lang->getText('Tracker.DatatypeTracker'); ?><br /><input type="radio" name="datatype" value="<?php echo Tracker::DATATYPE_TASK; ?>" <?php echo (($datatype==Tracker::DATATYPE_TASK) ? 'checked="checked"' : '' ) ?> /><?php echo $Lang->getText('Tracker.DatatypeTask'); ?></td>
		</tr>
		<tr>
			<td>
				<input type="checkbox" name="clone_tracker" <?php if ($clone_tracker) echo 'checked="checked"'; ?> /> <strong><?php echo $Lang->getText('Tracker.Clone'); ?></strong>
				<select name="clone_tracker_id">
					<option value="0"><?php echo $Lang->getText('Tracker.SelectTrackerOption') ?></option>
				<?php
					// Show the list of possible trackers to clone from (all the trackers the user has access to)
					
					// All projects the user has access to
					$user = Session::getSession()->getUser();
					$projects = $user->getAllProjects();
					
					foreach ($projects as $project) {
						$c = new Criteria();
						$c->add(TrackerPeer::PROJECT_ID, $project->getProjectId());
						$trackers = TrackerPeer::doSelect($c);
						foreach ($trackers as $tracker) {
							if ($tracker->userCanRead()) {
								echo '<option value="'.$tracker->getTrackerId().'">';
								echo $project->getProjectName().' / '.$tracker->getTrackerName().' ';
								if ($tracker->getDatatype() == Tracker::DATATYPE_TRACKER) {
									echo '('.$Lang->getText('Tracker.DatatypeTracker').')';
								} else if ($tracker->getDatatype() == Tracker::DATATYPE_TASK) {
									echo '('.$Lang->getText('Tracker.DatatypeTask').')';
								}
								echo '</option>'."\n";
							}
						}
					}
				?>
			</select>
			</td>
		</tr>
		<tr>
		<td>
			<?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.add') . " ","submit","","")?>
			<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Cancel') . " ","cancel","","javascript:history.go(-1);")?>
		</td>
		</tr>
	</table>
</form>

<?php
echo $theme->footer($params);
?>
