<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/userwiki/lib/Wiki.php');

$components = GFUrl::getUrl()->getURI();
$arr = explode('/',$components);
if (in_array('my',$arr)) {
	require_once('plugins/userwiki/lib/html/WikiMyTemplate.php');
	$theme = new WikiMyTemplate();
} else {
	require_once('plugins/userwiki/lib/html/WikiUserTemplate.php');
	$theme = new WikiUserTemplate();
}

$user = GFUrl::getUrl()->getUser();

$section = User::SECTION;
$ref_id = $user->getUserId();
$edit = (isset($_REQUEST['edit'])) ? Validator::sanitizeString($_REQUEST['edit']) : null;

if ($edit) {
	$wiki = new UserWiki($section,$ref_id,$theme,$user);
	$PageContent = $wiki->editPage($edit);
} else {
	throw new PermissionDeniedException();
}

$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? Validator::sanitizeString($_REQUEST['feedback']) : (isset($feedback) ? $feedback : ''),
		'title' => Language::getSessText('UserWiki.EditPageTitle'),
		'wiki' => $wiki,
		'selectedbottomtab' => 'userwiki'
		);

$theme->header($params);

echo $PageContent;

$theme->footer();

?>
