<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

// This code generates a SOAP API for handling Project

require_once('core/Project.php');
require_once('core/UserProject.php');
require_once('Validator.php');

/* ******************************************************************** */
/*                                 DATA TYPES                           */
/* ******************************************************************** */
$server->wsdl->addComplexType(
	'Project',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'project_id' => array('name'=>'project_id', 'type' => 'xsd:int'),
		'project_name' => array('name'=>'project_name', 'type' => 'xsd:string'),
		'unix_name' => array('name'=>'unix_name', 'type' => 'xsd:string'),
		'homepage_url' => array('name'=>'homepage_url', 'type' => 'xsd:string'),
		'is_public' => array('name'=>'is_public', 'type' => 'xsd:boolean'),
		'status' => array('name'=>'status', 'type' => 'xsd:int'),
		'description' => array('name'=>'description', 'type' => 'xsd:string'),
		'register_purpose' => array('name'=>'register_purpose', 'type' => 'xsd:string'),
		'register_license_other' => array('name'=>'register_license_other', 'type' => 'xsd:string'),
		'create_date' => array('name'=>'create_date', 'type' => 'xsd:string'),
		'template_project_id' => array('name'=>'template_project_id', 'type' => 'xsd:int'),
		'is_template' => array('name'=>'is_template', 'type' => 'xsd:boolean'),
		'parent_project_id' => array('name'=>'parent_project_id', 'type' => 'xsd:int'),
		'project_text1' => array('name'=>'project_text1', 'type' => 'xsd:string'),
		'project_text2' => array('name'=>'project_text2', 'type' => 'xsd:string'),
		'project_text3' => array('name'=>'project_text3', 'type' => 'xsd:string'),
		'project_text4' => array('name'=>'project_text4', 'type' => 'xsd:string'),
		'project_text5' => array('name'=>'project_text5', 'type' => 'xsd:string'),
		'project_text6' => array('name'=>'project_text6', 'type' => 'xsd:string'),
	)
);


$server->wsdl->addComplexType(
	'ArrayOfProject',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:Project[]')),
	'tns:Project'
);

$server->wsdl->addComplexType(
	'Role',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'role_id'=>array('name'=>'role_id','type'=>'xsd:int'),
		'role_name'=>array('name'=>'role_name','type'=>'xsd:string'),
		'project_id'=>array('name'=>'project_id','type'=>'xsd:int')
	)
);

$server->wsdl->addComplexType(
	'ArrayOfRole',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref'=>'SOAP-ENC:arrayType', 'wsdl:arrayType'=>'tns:Role[]')),
	'tns:Role'
);

$server->wsdl->addComplexType(
	'MemberWithRole',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'user_id' => array('name'=>'user_id', 'type' => 'xsd:int'),
		'unix_name' => array('name'=>'unix_name', 'type' => 'xsd:string'),
		'email' => array('name'=>'email', 'type' => 'xsd:string'),
		'status' => array('name'=>'status', 'type' => 'xsd:int'),
		'create_date' => array('name'=>'create_date', 'type' => 'xsd:string'),
		'timezone' => array('name'=>'timezone', 'type' => 'xsd:string'),
		'date_format' => array('name'=>'date_format', 'type' => 'xsd:string'),
		'address' => array('name'=>'address', 'type' => 'xsd:string'),
		'address2' => array('name'=>'address2', 'type' => 'xsd:string'),
		'phone' => array('name'=>'phone', 'type' => 'xsd:string'),
		'fax' => array('name'=>'fax', 'type' => 'xsd:string'),
		'title' => array('name'=>'title', 'type' => 'xsd:string'),
		'firstname' => array('name'=>'firstname', 'type' => 'xsd:string'),
		'lastname' => array('name'=>'lastname', 'type' => 'xsd:string'),
		'country_code' => array('name'=>'country_code', 'type' => 'xsd:string'),
		'language_id' => array('name'=>'language_id', 'type' => 'xsd:int'),
		'theme_id' => array('name'=>'theme_id', 'type' => 'xsd:int'),
		'external_id' => array('name'=>'external_id', 'type' => 'xsd:string'),
		'last_login' => array('name'=>'last_login', 'type' => 'xsd:string'),
		'user_text1' => array('name'=>'user_text1', 'type' => 'xsd:string'),
		'user_text2' => array('name'=>'user_text2', 'type' => 'xsd:string'),
		'user_text3' => array('name'=>'user_text3', 'type' => 'xsd:string'),
		'user_text4' => array('name'=>'user_text4', 'type' => 'xsd:string'),
		'user_text5' => array('name'=>'user_text5', 'type' => 'xsd:string'),
		'user_text6' => array('name'=>'user_text6', 'type' => 'xsd:string'),
		'is_group'=>array('name'=>'is_group', 'type'=>'xsd:boolean'),
		'roles'=>array('name'=>'Roles', 'type'=>'tns:ArrayOfRole')
	)
);
$server->wsdl->addComplexType(
	'ArrayOfMemberWithRole',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref'=>'SOAP-ENC:arrayType', 'wsdl:arrayType'=>'tns:MemberWithRole[]')),
	'tns:MemberWithRole'
);

$server->wsdl->addComplexType(
	'ProjectWithRole',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'project_id' => array('name'=>'project_id', 'type' => 'xsd:int'),
		'project_name' => array('name'=>'project_name', 'type' => 'xsd:string'),
		'unix_name' => array('name'=>'unix_name', 'type' => 'xsd:string'),
		'homepage_url' => array('name'=>'homepage_url', 'type' => 'xsd:string'),
		'is_public' => array('name'=>'is_public', 'type' => 'xsd:boolean'),
		'status' => array('name'=>'status', 'type' => 'xsd:int'),
		'description' => array('name'=>'description', 'type' => 'xsd:string'),
		'register_purpose' => array('name'=>'register_purpose', 'type' => 'xsd:string'),
		'register_license_other' => array('name'=>'register_license_other', 'type' => 'xsd:string'),
		'create_date' => array('name'=>'create_date', 'type' => 'xsd:string'),
		'template_project_id' => array('name'=>'template_project_id', 'type' => 'xsd:int'),
		'is_template' => array('name'=>'is_template', 'type' => 'xsd:boolean'),
		'parent_project_id' => array('name'=>'parent_project_id', 'type' => 'xsd:int'),
		'project_text1' => array('name'=>'project_text1', 'type' => 'xsd:string'),
		'project_text2' => array('name'=>'project_text2', 'type' => 'xsd:string'),
		'project_text3' => array('name'=>'project_text3', 'type' => 'xsd:string'),
		'project_text4' => array('name'=>'project_text4', 'type' => 'xsd:string'),
		'project_text5' => array('name'=>'project_text5', 'type' => 'xsd:string'),
		'project_text6' => array('name'=>'project_text6', 'type' => 'xsd:string'),
		'roles'=>array('name'=>'Roles', 'type'=>'tns:ArrayOfRole')
	)
);

$server->wsdl->addComplexType(
	'ArrayOfProjectWithRole',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref'=>'SOAP-ENC:arrayType', 'wsdl:arrayType'=>'tns:ProjectWithRole[]')),
	'tns:ProjectWithRole'
);


/* ******************************************************************** */
/*                                 METHODS                              */
/* ******************************************************************** */

$server->register(
	'getProjects',
	array(
		'sessionHash'	=> 'xsd:string',
		'is_public' => 'xsd:boolean',
		'status' => 'xsd:int'
	), 
	array('getProjects' => 'tns:ArrayOfProject'),
	$uri, 
	$uri.'#getProjects',
	'rpc',
	'encoded'
);


/**
 * SOAP method to retrieve a list of Project
 * @param	$project_id	Filter by project_id
 * @param	$is_public	Filter by is_public
 * @param	$status	Filter by status
 */
function getProjects($sessionHash, $is_public, $status) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$c = new Criteria();
	
	if (!is_null($is_public)) {
		$c->add(ProjectPeer::IS_PUBLIC, $is_public);
	}
	if ($status >= 0) {
		$c->add(ProjectPeer::STATUS, $status);
	}
	
	$objs = ProjectPeer::doSelect($c);
	$res = array();
	foreach ($objs as $obj) {
		if ($obj->userCanRead()) {
			$res[] = ProjectToSOAP($obj);
		}
	}
	return $res;
}


$server->register(
	'getProjectArray',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' => 'tns:ArrayOfInt',
	), 
	array('getProjectArray' => 'tns:ArrayOfProject'),
	$uri, 
	$uri.'#getProjectArray',
	'rpc',
	'encoded'
);

/**
 * SOAP method to retrieve an array of Project
 * @param	$project_id	Retrieve the Project array identified by the array of project_id
 */
function getProjectArray($sessionHash, $project_idArr) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$ret = array();

	$crit=new Criteria();
        $crit->add(ProjectPeer::PROJECT_ID,$project_idArr,Criteria::IN);
	$objs = ProjectPeer::doSelect($crit);
	foreach ($objs as $obj) {
		if ($obj->userCanRead()) {
			$ret[] = ProjectToSOAP($obj);
		}
	}
	return $ret;
}

$server->register(
	'getProjectArrayByUnixName',
	array(
		'sessionHash'	=> 'xsd:string',
		'unix_name' => 'tns:ArrayOfString',
	), 
	array('getProjectArrayByUnixName' => 'tns:ArrayOfProject'),
	$uri, 
	$uri.'#getProjectArrayByUnixName',
	'rpc',
	'encoded'
);

/**
 * SOAP method to retrieve an array of Project
 * @param	$project_id	Retrieve the Project array identified by the array of project_id
 */
function getProjectArrayByUnixName($sessionHash, $unix_nameArr) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$ret = array();

	$crit=new Criteria();
  $crit->add(ProjectPeer::UNIX_NAME,$unix_nameArr,Criteria::IN);
	$objs = ProjectPeer::doSelect($crit);
	foreach ($objs as $obj) {
		if ($obj->userCanRead()) {
			$ret[] = ProjectToSOAP($obj);
		}
	}
	return $ret;
}

$server->register(
	'getProject',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' => 'xsd:int',
	), 
	array('getProject' => 'tns:Project'),
	$uri, 
	$uri.'#getProject',
	'rpc',
	'encoded'
);

/**
 * SOAP method to retrieve a single Project
 * @param	$project_id	Retrieve the Project identified by this project_id
 */
function getProject($sessionHash, $project_id) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$obj = ProjectPeer::retrieveByPK($project_id);
	if (is_null($obj)) {
		return null;
	}
	if (!$obj->userCanRead()) {
		return new soap_fault('', 'getProject','Permission Denied - Cannot View This Record','Permission Denied - Cannot View This Record');
	}
	return ProjectToSOAP($obj);
}


$server->register(
	'getProjectByUnixName',
	array(
		'sessionHash'	=> 'xsd:string',
		'unix_name' => 'xsd:string',
	), 
	array('getProjectByUnixName' => 'tns:Project'),
	$uri, 
	$uri.'#getProjectByUnixName',
	'rpc',
	'encoded'
);

/**
 * SOAP method to retrieve a single Project
 * @param	$project_id	Retrieve the Project identified by this project_id
 */
function getProjectByUnixName($sessionHash, $unix_name) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$obj = ProjectPeer::retrieveByUnixName($unix_name);
	if (is_null($obj)) {
		return null;
	}
	if (!$obj->userCanRead()) {
		return new soap_fault('', 'getProjectByUnixName','Permission Denied - Cannot View This Record','Permission Denied - Cannot View This Record');
	}
	return ProjectToSOAP($obj);
}


$server->register(
	'deleteProject',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' => 'xsd:int',
	), 
	array('deleteProject' => 'xsd:int'),
	$uri, 
	$uri.'#deleteProject',
	'rpc',
	'encoded'
);

/**
 * SOAP method to delete a single Project
 * @param	$project_id	Delete the Project identified by this project_id
 */
function deleteProject($sessionHash, $project_id) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$obj = ProjectPeer::retrieveByPK($project_id);
	if (is_null($obj)) {
		return new soap_fault('', 'deleteProject','Permission Denied - Cannot Delete This Record: Cannot View This Record','Permission Denied - Cannot View This Record');
	}
	try {
		$obj->delete();
	} catch (Exception $e) {
		return new soap_fault('', 'deleteProject','Permission Denied - Cannot Delete This Record: ' . $e->getMessage(),$e->getMessage());
	}
	return 1;
}


$server->register(
	'deleteProjectByUnixName',
	array(
		'sessionHash'	=> 'xsd:string',
		'unix_name' => 'xsd:string',
	), 
	array('deleteProjectByUnixName' => 'xsd:int'),
	$uri, 
	$uri.'#deleteProjectByUnixName',
	'rpc',
	'encoded'
);

/**
 * SOAP method to delete a single Project
 * @param	$unix_name	Delete the Project identified by this unix_name
 */
function deleteProjectByUnixName($sessionHash, $unix_name) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$obj = ProjectPeer::retrieveByUnixName($unix_name);
	if (is_null($obj)) {
		return new soap_fault('', 'deleteProject','Permission Denied - Cannot Delete This Record','Permission Denied - Cannot View This Record');
	}
	try {
		$obj->delete();
	} catch (Exception $e) {
		return new soap_fault('', 'deleteProject','Permission Denied - Cannot Delete This Record: ' . $e->getMessage(),$e->getMessage());
	}
	return 1;
}


$server->register(
	'updateProject',
	array(
		'sessionHash'	=> 'xsd:string',
		'unix_name' => 'xsd:string',
		'project_name' => 'xsd:string',
		'homepage_url' => 'xsd:string',
		'is_public' => 'xsd:boolean',
		'description' => 'xsd:string',
		'register_purpose' => 'xsd:string',
		'register_license_other' => 'xsd:string',
		'parent_project_id' => 'xsd:int',
		'project_text1' => 'xsd:string',
		'project_text2' => 'xsd:string',
		'project_text3' => 'xsd:string',
		'project_text4' => 'xsd:string',
		'project_text5' => 'xsd:string',
		'project_text6' => 'xsd:string',
	), 
	array('updateProject' => 'xsd:int'),
	$uri, 
	$uri.'#updateProject',
	'rpc',
	'encoded'
);

/**
 * SOAP method to update Project
 * @param	$unix_name	 Project to update
 * @param	$project_name
 * @param	$homepage_url
 * @param	$is_public
 * @param	$description
 * @param	$register_purpose
 * @param	$register_license_other
 * @param   $parent_project_id
 * @param	$project_text1
 * @param	$project_text2
 * @param	$project_text3
 * @param	$project_text4
 * @param	$project_text5
 * @param	$project_text6
 */
function updateProject($sessionHash, $unix_name, $project_name, $homepage_url, $is_public, $description, $register_purpose, $register_license_other, $parent_project_id, $project_text1, $project_text2, $project_text3, $project_text4, $project_text5, $project_text6) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$obj = ProjectPeer::retrieveByUnixName($unix_name);
	if (is_null($obj)) {
		return new soap_fault('', 'updateProject', 'Couldn\'t update Project: invalid unix_name '.$unix_name);
	}
	
	if ($obj->getStatus() == Project::STATUS_ACTIVE) {
		if (!is_null($project_name)) {
			$obj->setProjectName( Validator::sanitizeString($project_name) );
		}
		if (!is_null($homepage_url)) {
			$obj->setHomepageUrl( Validator::sanitizeString($homepage_url) );
		}
		if (!is_null($is_public)) {
			$obj->setIsPublic( Validator::sanitizeBool($is_public) );
		}
		if (!is_null($description)) {
			$obj->setDescription( Validator::sanitizeString($description) );
		}
		if (!is_null($register_purpose)) {
			$obj->setRegisterPurpose( Validator::sanitizeString($register_purpose) );
		}
		if (!is_null($register_license_other)) {
			$obj->setRegisterLicenseOther( Validator::sanitizeString($register_license_other) );
		}

		if (Validator::sanitizeInt($parent_project_id) > 0) {
			$parentprj = ProjectPeer::retrieveByPK(Validator::sanitizeInt($parent_project_id));
			if(!is_null($parentprj)) {
				$obj->setParentProject($parentprj);
			}
			else return new soap_fault('', 'updateProject', 'Parent does not exist: ' . $parent_project_id);
		}
		
		/*if (!is_null($parent_project_id)) {
			$obj->setParentProjectId( Validator::sanitizeInt($parent_project_id) );
		}
	        */
		if (!is_null($project_text1)) {
			$obj->setProjectText1( Validator::sanitizeString($project_text1) );
		}
		if (!is_null($project_text2)) {
			$obj->setProjectText2( Validator::sanitizeString($project_text2) );
		}
		if (!is_null($project_text3)) {
			$obj->setProjectText3( Validator::sanitizeString($project_text3) );
		}
		if (!is_null($project_text4)) {
			$obj->setProjectText4( Validator::sanitizeString($project_text4) );
		}
		if (!is_null($project_text5)) {
			$obj->setProjectText5( Validator::sanitizeString($project_text5) );
		}
		if (!is_null($project_text6)) {
			$obj->setProjectText6( Validator::sanitizeString($project_text6) );
		}
		
		try {
			$obj->save();
		} catch (Exception $e) {
			return new soap_fault('', 'updateProject','Permission Denied - Cannot update This Record: ' . $e->getMessage(),$e->getMessage());
		}
	} else {
		return new soap_fault('', 'updateProject','Permission Denied - Cannot update This Record: Project not currently active', 'Permission Denied - Project not currently active');
	}
	return 1;
}



$server->register(
	'addProject',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_name' => 'xsd:string',
		'unix_name' => 'xsd:string',
		'homepage_url' => 'xsd:string',
		'is_public' => 'xsd:boolean',
		'description' => 'xsd:string',
		'register_purpose' => 'xsd:string',
		'register_license_other' => 'xsd:string',
		'template_project_id' => 'xsd:int',
		'parent_project_id' => 'xsd:int',
		'project_text1' => 'xsd:string',
		'project_text2' => 'xsd:string',
		'project_text3' => 'xsd:string',
		'project_text4' => 'xsd:string',
		'project_text5' => 'xsd:string',
		'project_text6' => 'xsd:string',
	), 
	array('addProject' => 'xsd:int'),
	$uri, 
	$uri.'#getProjects',
	'rpc',
	'encoded'
);


/**
 * SOAP method to add a Project
 * @param	$project_name
 * @param	$unix_name
 * @param	$homepage_url
 * @param	$is_public
 * @param	$description
 * @param	$register_purpose
 * @param	$register_license_other
 * @param	$template_project_id
 * @param   $parent_project_id
 * @param	$project_text1
 * @param	$project_text2
 * @param	$project_text3
 * @param	$project_text4
 * @param	$project_text5
 * @param	$project_text6
 */
function addProject($sessionHash, $project_name, $unix_name, $homepage_url, $is_public, $description, $register_purpose, $register_license_other, $template_project_id, $parent_project_id, $project_text1, $project_text2, $project_text3, $project_text4, $project_text5, $project_text6) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	if (Session::getSession()->isSiteAdmin() || (GFConf::get('system.projectRegRestricted')==false) ) {
		$obj = new Project();
	
		$obj->setProjectName( Validator::sanitizeString($project_name) );
		$obj->setUnixName( Validator::sanitizeString($unix_name) );
		$obj->setHomepageUrl( Validator::sanitizeString($homepage_url) );
		$obj->setIsPublic( Validator::sanitizeBool($is_public) );
		$obj->setDescription( Validator::sanitizeString($description) );
		$obj->setRegisterPurpose( Validator::sanitizeString($register_purpose) );
		$obj->setRegisterLicenseOther( Validator::sanitizeString($register_license_other) );
		$obj->setTemplateProjectId( Validator::sanitizeInt($template_project_id) );
		$obj->setStatus(Project::STATUS_PENDING);
		$obj->setProjectText1( Validator::sanitizeString($project_text1) );
		$obj->setProjectText2( Validator::sanitizeString($project_text2) );
		$obj->setProjectText3( Validator::sanitizeString($project_text3) );
		$obj->setProjectText4( Validator::sanitizeString($project_text4) );
		$obj->setProjectText5( Validator::sanitizeString($project_text5) );
		$obj->setProjectText6( Validator::sanitizeString($project_text6) );
		
		try {
			$obj->save();
			//After saving it and thus obtaining an id, we can set the parent if needed
	
			if (Validator::sanitizeInt($parent_project_id) > 0) {
				$parentprj = ProjectPeer::retrieveByPK(Validator::sanitizeInt($parent_project_id));
				if(!is_null($parentprj)) {
					$obj->setParentProject($parentprj);
					$obj->save();
				}
				else return new soap_fault('', 'addProject', 'Parent does not exist: ' . $parent_project_id);
		}


			return $obj->getProjectId();
		} catch (Exception $e) {
			return new soap_fault('', 'addProject','Permission Denied - Cannot add This Record: ' . $e->getMessage(),$e->getMessage());
		}
	} else {
		return new soap_fault('', 'addProject','Permission Denied - Cannot add This Record: ' . $e->getMessage(),$e->getMessage());
	}
}

$server->register(
	'approveProject',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' => 'xsd:int',
	), 
	array('addProject' => 'xsd:int'),
	$uri, 
	$uri.'#approveProject',
	'rpc',
	'encoded'
);
/**
 * SOAP method to approve a Project
 * @param string $sessionHash
 * @param string $project_id
 */
function approveProject($sessionHash, $project_id){
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	//Check for site admin prilegies
	if(!Session::getSession()->isSiteAdmin()){
		return new soap_fault('', 'approveProject', 'Permission Denied - only site admin can approve projects');
	}
	if(Validator::sanitizeInt($project_id) > 0){
		try{
			$project = ProjectPeer::retrieveByPk($project_id);
		} catch (Exception $e){
			return new soap_fault('', 'approveProject','Permission Denied - cannot approve project:' . $e->getMessage(), $e->getMessage());
		}
		if(!is_object($project)){
			return new soap_fault('', 'approveProject', 'Invalid project id');
		}
	}
	try{
		$project->approve();
	} catch (Exception $e) {
		//ProjectPeer::approve() will ignore any attempt to approve a project already approved,
		//just in case
		return new soap_fault('', 'addProject', 'Permission Deniend - cannot approve project:' . $e->getMessage(), $e->getMessage());
	}
	return 1;

}
/**
 * SOAP method to get members for a given project
 *
 * @param string  $sessionHash the session hash
 * @param integer $project_id the project id
 * @param integer $expand_groups (false == 0, any other value == true)
 */

$server->register(
	'getProjectMembers',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' => 'xsd:int',
		'expand_groups' => 'xsd:int',
	), 
	array('getProjectMembers' => 'tns:ArrayOfUser'),
	$uri, 
	$uri.'#getProjectMembers',
	'rpc',
	'encoded'
);

function getProjectMembers($sessionHash, $project_id, $expand_groups){
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	try{ 
		$project = ProjectPeer::retrieveByPk(Validator::sanitizeInt($project_id));
	} catch(Exception $e){
		return new soap_fault('',__FUNCTION__, $e->getMessage(), $e->getMessage());
	}
	if (is_null($project)) {
		return new soap_fault('',__FUNCTION__,'Invalid project id','Invalid project id');
	}
	if (!$project->userCanRead()) {
		return new soap_fault('', __FUNCTION__,'Permission Denied - Cannot get project members','Permission Denied - Cannot get project members');
	}
	if($expand_groups){
		//get all members (groups are expanded)
		$members = $project->getMembers();
	} else {
		//get users and groups unexpanded
		try{
			$c = new Criteria();
			$c->add(UserProjectPeer::PROJECT_ID, $project_id);
			$ups= UserProjectPeer::doSelect($c);
			foreach($ups as $up){
				$members[] = $up->getUser();
			}
		} catch(Exception $e){
			return new soap_fault('',__FUNCTION__,$e->getMessage(), $e->getMessage());
		}
	}
		
		
	foreach($members as $member){
		$ret[] = MemberToSOAP($member);
	}

	return $ret;

}

/**
 * SOAP method to add an user to a given project
 *
 * @param $sessionHash 
 * @param $project_id 
 * @param $project_id
 * @param $user_id
 * @param $roles
 *
 */
$server->register(
	'addUserProject',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' => 'xsd:int',
		'user_id'=>'xsd:int',
		'roles'=>'tns:ArrayOfInt'
	), 
	array('addUserProject' => 'xsd:int'),
	$uri, 
	$uri.'#addUserProject',
	'rpc',
	'encoded'
);
function addUserProject($sessionHash, $project_id, $user_id, $roles){
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	//Sanitize
	$user_id = Validator::sanitizeInt($user_id);
	$project_id = Validator::sanitizeInt($project_id);

	//Check valid project id
	$project = ProjectPeer::retrieveByPk($project_id);
	if(is_null($project)) {
		return new soap_fault('','addUserProject', 'Project id not found', 'Invalid project id');
	}
	//Check if user is project admin
	if(!$project->userIsAdmin()){
		return new soap_fault('','addUserProject', 'Permission Denied', 'Only project admins can add users');
	};

	//Check valid user id
	$user = UserPeer::retrieveByPk($user_id);
	if(is_null($user)){
		return new soap_fault('','addUserProject', 'User id not found', "Invalid user id $user_id");
	}
	//Check that user is not a member already
	if($user->isProjectMember($project)){
		return new soap_fault('','addUserProject', 'User already a member of this project', "User with id $user_id already a member of this project");
	}
	

	//Check that roles paramater is an array and is not empty
	if(!is_array($roles) || empty($roles)){
		return new soap_fault('','addUserProject', 'Invalid data', 'Parameter roles must be a non empty array');
	}
	//Get project roles
	$projectRoles = $project->getRoles();
	foreach($projectRoles as $projectRole){
		$prj_roles[] = $projectRole->getId();
	}
	//Check that $roles are valid
	foreach ($roles as $role){
		if(!in_array($role, $prj_roles)){
			return new soap_fault('', 'addUserProject', 'Invalid data', "Role id $role is not valid for this project");
		}
	}

	//Save
	try{
		$user_project = new UserProject();
		$user_project->setUserId($user_id);
		$user_project->setProjectId($project_id);
		foreach ($roles as $role){
			$upr = new UserProjectRole();
			$upr->setRoleId(Validator::sanitizeInt($role));
			$user_project->addUserProjectRole($upr);
		}
		$user_project->save();
	} catch (Exception $e) {
		return new soap_fault('','addUserProject', 'Cannot add user to project' , $e->getMessage());
	}

	return 1;
}

$server->register(
	'deleteUserProject',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' => 'xsd:int',
		'user_id'=>'xsd:int',
	), 
	array('deleteUserProject' => 'xsd:int'),
	$uri, 
	$uri.'#deleteUserProject',
	'rpc',
	'encoded'
);

/**
 * SOAP method to delete an user from a given project
 *
 * @param $sessionHash
 * @param $project_id
 * @param $user_id
 *
 */

function deleteUserProject($sessionHash, $project_id, $user_id){
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	//Sanitize
	$project_id = Validator::SanitizeInt($project_id);
	$user_id = Validator::SanitizeInt($user_id);

	//Check valid project id
	$project = ProjectPeer::retrieveByPk($project_id);
	if(is_null($project)) {
		return new soap_fault('','deleteUserProject', 'Project id not found', 'Invalid project id');
	}

	//Check if user is project admin
	if(!$project->userIsAdmin()){
		return new soap_fault('','deleteUserProject', 'Permission Denied', 'Only project admins can add users');
	};
	//Check valid user id
	$user = UserPeer::retrieveByPk($user_id);
	if(is_null($user)){
		return new soap_fault('','deleteUserProject', 'User id not found', "Invalid user id $user_id");
	}
	//Check that user is  a member of this project
	if(!$user->isProjectMember($project)){
		return new soap_fault('','deleteUserProject', 'User is not a member of this project', "User with id $user_id is not a member of this project");
	}

	//Delete
	try {
		$c = new Criteria();
		$c->add(UserProjectPeer::USER_ID, $user_id);
		$c->add(UserProjectPeer::PROJECT_ID, $project_id);
		$user_project = UserProjectPeer::doSelectOne($c);
		$user_project->delete();
	} catch (Exception $e) {
		return new soap_fault('', 'deleteUserProject', 'Cannot delete user from project', $e->getMessage());
	}

	return 1;

}

$server->register(
	'getUserProjectRoles',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' => 'xsd:int',
		'user_id'=>'xsd:int',
	), 
	array('getUserProjectRoles' => 'tns:ArrayOfRole'),
	$uri, 
	$uri.'#getUserProjectRoles',
	'rpc',
	'encoded'
);

/**
 * get roles for the user on the given project
 *
 * If the user is a member of a group which is a member of the project, 
 * this function will return an invalid user_id error message, you must
 * pass the user_id of the group.
 *
 * @param string $sessionHash the session has
 * @param int $project_id the project id
 * @param int $user_id the user id
 * @return array an array of role objects
 */


function getUserProjectRoles($sessionHash, $project_id, $user_id){
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	//Sanitize
	$project_id = Validator::SanitizeInt($project_id);
	$user_id = Validator::SanitizeInt($user_id);

	try{
		$project = ProjectPeer::retrieveByPk($project_id);
	} catch (Exception $e){
		return new soap_fault('', __FUNCTION__, $e->getMessages());
	}
	if(is_null($project)){
		return new soap_fault('',__FUNCTION__, 'Invalid project id');
	}
	if(!$project->userCanRead()){
		return new soap_fault('',__FUNCTION__, 'Permission Denied');
	}
	try {
		$c = new Criteria();
		$c->add(UserProjectPeer::PROJECT_ID, $project_id);
		$c->add(UserProjectPeer::USER_ID, $user_id);
		$up = UserProjectPeer::doSelectOne($c);
	} catch (Exception $e) {
		return new soap_fault('',__FUNCTION__, $e->getMessage());
	}
	
	if(is_null($up)){
		return new soap_fault('',__FUNCTION__, 'Invalid user_id');
	}
	$uprs = $up->getUserProjectRoles();
	foreach ($uprs as $upr){
		$role = $upr->getRole();
		$roles[] = RoleToSOAP($role);
	}

	return $roles;
		
}

$server->register(
	'getUserProjectsWithRoles',
	array(
		'sessionHash'	=> 'xsd:string',
		'user_id'=>'xsd:int'
	), 
	array('getUserProjectsWithRoles' => 'tns:ArrayOfProjectWithRole'),
	$uri, 
	$uri.'#getUserProjectsWithRoles',
	'rpc',
	'encoded'
);

/**
 * get projects with roles for the given user
 *
 * If the user is a member of a group which is a member of the project, 
 * you must pass the user_id of the group. 
 *
 * @param string $sessionHash the session has
 * @param int $project_id the project id
 * @param int $user_id the user id
 * @return array an array of role objects
 */

function getUserProjectsWithRoles($sessionHash, $user_id){
	$ip = $_SERVER['REMOTE_ADDR'];

	$session = Session::getSession();
	$session->setup($sessionHash, $ip);

	//Check for site admin permissions
	if(!$session->isSiteAdmin()){
		return new soap_fault('', __FUNCTION__, 'Permission Denied','Only site admin can perform this action');
	}

	//Sanitize
	$user_id = Validator::SanitizeInt($user_id);

	//Get user projects
	try {
		$c = new Criteria();
		$c->add(UserProjectPeer::USER_ID, $user_id);
		$userProjects = UserProjectPeer::doSelect($c);
	} catch (Exception $e) {
		return new soap_fault('',__FUNCTION__, $e->getMessage());
	}

	$ProjectsWithRoles = array();
	//No projects found for the given user, return an empty array
	if(is_null($userProjects)){
		return $ProjecstWithRoles;
	}
	$i = 0;
	foreach($userProjects as $up){
		$ProjectsWithRoles[$i] = ProjectToSOAP($up->getProject());
		//Get roles for this project
		$upRoles = $up->getUserProjectRoles();
		//Transform each role into a SOAP role object
		foreach ($upRoles as $upr){
			$role = $upr->getRole();
			$roles[] = RoleToSOAP($role);
		}
		$ProjectsWithRoles[$i]['roles'] = $roles;
		//Cleanup $roles array
		$roles = null;
		$i++;
	}

	return $ProjectsWithRoles;
		
}


$server->register(
	'getProjectRoles',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' => 'xsd:int'
	), 
	array('getProjectRoles' => 'tns:ArrayOfRole'),
	$uri, 
	$uri.'#getProjectRoles',
	'rpc',
	'encoded'
);

/**
 * gets roles for the given project
 * 
 * @param string $sessionHash the session hash
 * @param int $project_id the project id
 * @return array an array of role objects
 */

function getProjectRoles($sessionHash, $project_id){
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	//Sanitize
	$project_id = Validator::SanitizeInt($project_id);

	try{
		$project = ProjectPeer::retrieveByPk($project_id);
	} catch (Exception $e){
		return new soap_fault('',__FUNCTION__, $e->getMessages());
	}
	if(is_null($project)){
		return new soap_fault('',__FUNCTION__, 'Invalid project id');
	}
	if(!$project->userIsAdmin()){
		return new soap_fault('',__FUNCTION__, 'Permission Denied');
	}
	$rs = $project->getRoles();
	
	foreach($rs as $r){
		$roles[] = RoleToSOAP($r);
	}
	
	return $roles;
}

$server->register(
	'updateProjectStatus',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' => 'xsd:int',
		'status'=>'xsd:int'
	), 
	array('updateProjectStatus' => 'xsd:int'),
	$uri, 
	$uri.'#updateProjectStatus',
	'rpc',
	'encoded'
);
/**
 * updates project status
 *
 * @param string $sessionHash
 * @param integer $project_id
 * @param integer $status
 *
 * @return mixed 1 on success, soap_fault on failure
 */
function updateProjectStatus($sessionHash, $project_id, $status){
	$ip = $_SERVER['REMOTE_ADDR'];
	$session = Session::getSession();
	$session->setup($sessionHash, $ip);

	//Sanitize
	$project_id = Validator::SanitizeInt($project_id);
	$status = Validator::SanitizeInt($status);

	//Check valid status code
	if(!($status == Project::STATUS_ACTIVE || $status == Project::STATUS_HOLDING || $status == Project::STATUS_PENDING)){
		return new soap_fault('',__FUNCTION__, 'Invalid project status');
	}
	//Check for site admin rights
	if(!$session->isSiteAdmin()){
		return new soap_fault('',__FUNCTION__,'Permission Denied', 'Only site admin can update project status');
	}

	//Get project
	try{
		$project = ProjectPeer::retrieveByPk($project_id);
	} catch (Exception $e){
		return new soap_fault('',__FUNCTION__, $e->getMessages());
	}
	if(is_null($project)){
		return new soap_fault('',__FUNCTION__, 'Invalid project id');
	}
	//Set status
	try{
		$project->setStatus($status);
		$project->save();
	}catch(Exception $e){
		return new soap_fault('',__FUNCTION__, $e->getMessage());
	}

	return 1;

}

$server->register(
	'getProjectMembersWithRoles',
	array(
		'sessionHash'  => 'xsd:string',
		'project_id' => 'xsd:int'
	),
	array('getProjectMembersWithRoles' => 'tns:ArrayOfMemberWithRole'),
	$uri,
	$uri.'#getProjectMembersWithRoles',
	'rpc',
	'encoded'
);

/**
 * Gets members for the given project with roles
 *
 * For each member of the given project wraps an array of role object inside the member object
 *
 * @param string $sessionHash the session hash
 * @param string $project_id the project id
 */
function getProjectMembersWithRoles($sessionHash, $project_id){
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	try{
		$project = ProjectPeer::retrieveByPk(Validator::sanitizeInt($project_id));
	} catch(Exception $e){
		return new soap_fault('',__FUNCTION__, $e->getMessage(), $e->getMessage());
 	}
 	if (is_null($project)) {
		return new soap_fault('',__FUNCTION__,'Invalid project id','Invalid project id');
	}
 	if (!$project->userCanRead()) {
		return new soap_fault('', __FUNCTION__,'Permission Denied - Cannot get project members','Permission Denied - Cannot get project members');
	}
	$ups = $project->getUserProjects();

	$i = 0;
	foreach($ups as $up){
 		$ret[$i] = MemberToSOAP($up->getUser());
		$roles = $up->getUserProjectRoles();
		foreach($roles as $role){
			$ret[$i]['roles'][] = RoleToSOAP($role->getRole());
		}
		$i++;
	}
	return $ret;
}



function checkProjectPermission($project_id, $type='') {
	$obj = ProjectPeer::retrieveByPK($project_id);
	if (is_null($obj)) {
		return false;
	} else if ($type=='delete') {
		return $obj->userCanDelete();
	} else if ($type=='create') {
		return $obj->userCanCreate();
	} else if ($type=='update') {
		return $obj->userCanUpdate();
	} else {
		return $obj->userCanRead();
	}	
}

function ProjectToSOAP(&$obj) {
	$ret = array();
	$ret['project_id'] = $obj->getProjectId();
	$ret['project_name'] = $obj->getProjectName();
	$ret['unix_name'] = $obj->getUnixName();
	$ret['homepage_url'] = $obj->getHomepageUrl();
	$ret['is_public'] = $obj->getIsPublic();
	$ret['status'] = $obj->getStatus();
	$ret['description'] = $obj->getDescription();
	$ret['register_purpose'] = $obj->getRegisterPurpose();
	$ret['register_license_other'] = $obj->getRegisterLicenseOther();
	$ret['create_date'] = $obj->getCreateDate();
	$ret['template_project_id'] = $obj->getTemplateProjectId();
	$ret['is_template'] = $obj->getIsTemplate();
	$ret['parent_project_id'] = $obj->getParentProjectId();
	$ret['project_text1'] = $obj->getProjectText1();
	$ret['project_text2'] = $obj->getProjectText2();
	$ret['project_text3'] = $obj->getProjectText3();
	$ret['project_text4'] = $obj->getProjectText4();
	$ret['project_text5'] = $obj->getProjectText5();
	$ret['project_text6'] = $obj->getProjectText6();
	return $ret;
}

function MemberToSOAP(&$obj) {
	$ret = array();
	$ret['user_id'] = $obj->getUserId();
	$ret['unix_name'] = $obj->getUnixName();
	$ret['email'] = $obj->getEmail();
	$ret['status'] = $obj->getStatus();
	$ret['password_md5'] = $obj->getPasswordMd5();
	$ret['password_crypt'] = $obj->getPasswordCrypt();
	$ret['create_date'] = $obj->getCreateDate();
	$ret['confirm_hash'] = $obj->getConfirmHash();
	$ret['email_new'] = $obj->getEmailNew();
	$ret['timezone'] = $obj->getTimezone();
	$ret['date_format'] = $obj->getDateFormat();
	$ret['address'] = $obj->getAddress();
	$ret['address2'] = $obj->getAddress2();
	$ret['phone'] = $obj->getPhone();
	$ret['fax'] = $obj->getFax();
	$ret['title'] = $obj->getTitle();
	$ret['firstname'] = $obj->getFirstname();
	$ret['lastname'] = $obj->getLastname();
	$ret['country_code'] = $obj->getCcode();
	$ret['language_id'] = $obj->getLanguageId();
	$ret['theme_id'] = $obj->getThemeId();
	$ret['external_id'] = $obj->getExternalId();
	$ret['last_login'] = $obj->getLastLogin();
	$ret['user_text1'] = $obj->getUserText1();
	$ret['user_text2'] = $obj->getUserText2();
	$ret['user_text3'] = $obj->getUserText3();
	$ret['user_text4'] = $obj->getUserText4();
	$ret['user_text5'] = $obj->getUserText5();
	$ret['user_text6'] = $obj->getUserText6();
	$ret['is_group'] = $obj->getIsGroup();
	//$ret['password_change_date'] = $obj->getPasswordChangeDate();

	return $ret;
}

function RoleToSOAP(&$obj){
	$ret=array();
	$ret['role_id'] = $obj->getRoleId();
	$ret['role_name'] = $obj->getRoleName();
	$ret['project_id'] = $obj->getProjectId();
	
	return $ret;
}


	
?>
