<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Federico Tarantini      federico@gforgegroup.com
 * @date 2006-11-22
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

include ("lib/external/jpgraph/jpgraph.php");
include ("lib/external/jpgraph/jpgraph_line.php");

if (!Session::getSession()->isSiteAdmin()) {
	throw new PermissionDeniedException();
}

$session = Session::getSession();
$Lang = $session->getLanguage();

$con = Propel::getConnection(TrackerPeer::DATABASE_NAME);
$stmt = $con->createStatement();

$begin = Validator::sanitizeDate($_GET['start_date']);
$end = Validator::sanitizeDate($_GET['end_date']);

$sql = 'SELECT date_part(\'year\', commit_date)::text || \'-\' || date_part(\'month\', commit_date)::text AS month, COUNT(*) AS commits 
	FROM scm_commit
	WHERE commit_date BETWEEN \''.$begin.'\' AND \''.$end.'\' 
	GROUP BY month;';

$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

$raw_data  = array();
if ($rs != null && $rs->getRecordCount() > 0) {
        while($rs->next()) {
                $raw_data[] = array($rs->getString('month') => $rs->getInt('commits'));
        }
}
//print_r($raw_data);
// Create an array with all the months of the given date range
$months = array();
$i = strtotime($begin);
while($i <= strtotime($end)) {
        $date = getdate($i);
        $months[$date['year'].'-'.$date['mon']] = 0;
        $i = mktime(0, 0, 0, ($date['mon']+1), 1, $date['year']);
}

$result = $months;
foreach($raw_data as $values) {
	foreach($values as $month => $commits) {
		$result[$month] = $commits;
	}
}
//print_r($result);

$font = $Lang->getFontProperties(FF_FONT1, FS_BOLD, 12);
// Create the graph.
$graph = new Graph(450, 250);
$graph->SetScale('textlin');
$graph->img->SetMargin(40, 100, 15, 70);
$graph->title->Set($Lang->getText('SiteAdmin.CommitsByMonth'));
$graph->title->SetFont($font[0], $font[1], $font[2]);
$graph->setBox(false);
$graph->setFrame(false);

$font = $Lang->getFontProperties(FF_FONT1, FS_BOLD, 8);
$graph->xaxis->SetTitle($Lang->getText('Common.Month'));
$graph->xaxis->SetTitleMargin(39);
$graph->xaxis->title->SetFont($font[0], $font[1], $font[2]);
$graph->xaxis->SetTickLabels(array_keys($months));
$graph->xaxis->SetLabelAngle(90);

$graph->yaxis->SetTitle($Lang->getText('SiteAdmin.GraphCommits'), 'low');
$graph->yaxis->SetTitleMargin(25);
$graph->yaxis->title->SetFont($font[0], $font[1], $font[2]);
$graph->yaxis->scale->SetGrace(0);
$graph->yaxis->SetLabelMargin(1);

$graph ->legend->Pos( 0.8,0.1,"left" ,"center");

if (count($result) != 0) {
        $lineplot = new LinePlot(array_values($result));
        $lineplot->SetFillColor('#ADD8E6');
        $graph->Add($lineplot);
} else {
        $lineplot = new LinePlot(array_values($months));
        $graph->Add($lineplot);
}

$graph->Stroke();
?>
