<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('core/ProjectPeer.php');
require_once('session/Session.php');
require_once('core/RolePeer.php');
require_once('core/UserProject.php');
require_once('html/HTMLWidget.php');

require_once('html/MyTemplate.php');
$session = Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$Language = $session->getLanguage();
$user = $session->getUser();
$template = new MyTemplate();
$params = array(
	'user'=>$user,
	'title' => Language::getSessText('MyActivity.Title'),
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'selectedbottomtab' => 'activity',
	);

if (!isset($feedback)) {
	$feedback = '';
}

// get all projects for this user
$all_projects = $user->getAllProjects();

// Create an array with all the trackers (id=>name)
$projects = array();
$projects[0] = $Language->getText('MyActivity.AllProjects');
foreach($all_projects as $project) {
	$projects[$project->getProjectId()]=$project->getProjectName();
}
//an array of all project ids that the user is a member of
$allids=$user->getAllProjectIds();
if (count($allids) > 0) {
	$allids=implode(',',$user->getAllProjectIds());
} else {
	$allids=0;
}


// Save the project_id that came in the request, only if it's valid
$project_id = (isset($_REQUEST['project_id']) && 
			  $_REQUEST['project_id'] > 0 &&
			  array_key_exists($_REQUEST['project_id'], $projects) === true) ? intval($_REQUEST['project_id']) : 0;



$template->header($params);
$begin=((isset($_REQUEST['start_date'])) ? $_REQUEST['start_date'] : 0 );
$end=((isset($_REQUEST['end_date'])) ? $_REQUEST['end_date'] : 0 );

if ($begin=="0") {
	$begin = (time()-(30*86400));
} else {
	$begin = strtotime($begin);
}
if ($end=="0") {
	$end = time();
} else {
	$end=strtotime($end)+86399;
}
if ($begin > $end) {
	$endtmp=$end;
	$end=$begin;
	$begin=$endtmp;
}

// Check if we want to filter only the user's items
$onlymine = (isset($_REQUEST['onlymine']) && $_REQUEST['onlymine'] == 1) ? true : false;

$ids = array();
$ids[] = 'scm';
$ids[] = 'trackeritem';
$ids[] = 'forum';

$texts=array();
$texts['scm']=$Language->getText('ProjectActivity.Commit');
$texts['trackeritem']=$Language->getText('ProjectActivity.TrackerItem');
$texts['forum']=$Language->getText('ProjectActivity.ForumPost');

if (!isset($_REQUEST['show'])) {
	$show=$ids;
} else {
	$show=$_REQUEST['show'];
}

if(!is_array($show)) Throw new Exception('Invalid Data Passed to query');

foreach ($show as $showthis) {
	if (array_search($showthis,$ids) === false) {
		Throw new Exception('Invalid Data Passed to query');
	}
}

$multiselect=HTMLWidget::multiSelectFromAssoc('show[]',$texts,$show,'',false,null,false,null,5);

$con = Propel::getConnection(UserPeer::DATABASE_NAME);
$stmt = $con->createStatement();

if ($project_id > 0) {
	$sqlproject = "AND project_id='$project_id' ";
} else {
	$sqlproject = "AND project_id IN ($allids) ";
}

if ($onlymine) {
	$sqlmine = "AND user_id='".$user->getUserId()."' ";
} else {
	$sqlmine = '';
}


$sql="SELECT COUNT(*) FROM project_activity_vw WHERE activity_date 
	BETWEEN '".date('Y-m-d',$begin)." 00:00:00' AND '".date('Y-m-d',$end)." 23:59:59'
	$sqlmine
	AND section IN ('".implode("','",$show)."') 
	$sqlproject";
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM );
$rs->next();
$total = $rs->getInt(1);

$paginator = new Paginator('myactiv', -1, $total, 'activity_date', array('activity_date'=>''));

$sql="SELECT * FROM project_activity_vw WHERE activity_date 
	BETWEEN '".date('Y-m-d',$begin)." 00:00:00' AND '".date('Y-m-d',$end)." 23:59:59'
	$sqlmine
	AND section IN ('".implode("','",$show)."') 
	$sqlproject " . $paginator->getSQL();
//echo $sql;
$rs = $stmt->executeQuery($sql);

	?>
<script language="javascript" type="text/javascript" src="/datetimepicker.js">
</script>
<br />
<form action="/gf/my/activity/" method="post">
<table border="0" cellspacing="0" cellpadding="3" bgcolor="#E0E0E0">
<tr>
	<td><strong><?php echo $Language->getText('MyActivity.FilterByProject') ?></strong></td>
	<td><strong><?php echo $Language->getText('ProjectActivity.HeaderActivity') ?></strong></td>
	<td><strong><?php echo $Language->getText('ProjectActivity.StartDate') ?></strong></td>
	<td><strong><?php echo $Language->getText('ProjectActivity.EndDate') ?></strong></td>
	<td rowspan="3" valign="middle"><?php echo HTMLWidget::button("submit", $Language->getText('Common.Submit'), "submit"); ?></td>
</tr>
<tr>
	<td valign="top"><?php echo HTMLWidget::selectBoxFromAssoc($projects,'project_id',$project_id, false, false) ?></td>
	<td rowspan="2" valign="top"><?php echo $multiselect; ?></td>
	<td valign="top"><input id="startdate" name="start_date" value="<?php echo date('M d Y',$begin); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('startdate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td valign="top"><input id="enddate" name="end_date" value="<?php echo date('M d Y',$end); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('enddate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td colspan="2" align="right"><strong><?php echo $Language->getText('MyActivity.IncludeOnlyMine') ?></strong>
	<input type="checkbox" name="onlymine" value="1" <?php if ($onlymine) echo 'checked' ?> /></td>
</tr>
</table>
</form>
<br />
	<?php

	$theader=array();
	$theader[]=$Language->getText('ProjectActivity.HeaderTime');
	$theader[]=$Language->getText('ProjectActivity.HeaderActivity');
	if ($project_id == 0) {
		if ($onlymine !== true) {
			$theader[]=$Language->getText('MyActivity.HeaderProject');
		} else {
			$theader[] = $paginator->insertLimitOptions($Language->getText('MyActivity.HeaderProject'));
		}
	}
	if ($onlymine !== true) {
		$theader[]=$paginator->insertLimitOptions($Language->getText('ProjectActivity.HeaderPerson'));
	}

	echo $template->tableTop($theader);

	$j=0;
	$last_day=0;

	while ($rs->next()) {
		$j++;
		$arr = $rs->getRow();
		if ($last_day != date('Y-M-d',strtotime($arr['activity_date']))) {
			echo $template->tableFullRow(date('Y-M-d',strtotime($arr['activity_date'])));
			$last_day=date('Y-M-d',strtotime($arr['activity_date']));
		}
		$project = ProjectPeer::retrieveByPk($arr['project_id']);
		$userlink=UserPeer::retrieveByPk($arr['user_id'])->getUserLink();
		$projectlink='<a href="' . GFUrl::getUrl()->projectURL($project) . '" >' .  $project->getProjectName() . '</a>';

		switch ($arr['section']) {
			case 'scm': {
				
				$description = $arr['description1'];
				// CVS commits for initial imports may be huge, so we trim it
				$description = StringUtils::trimString($description, 256);

				$activity_desc = $Language->getText('ProjectActivity.CommitDescription', array($description));
				
				$scmplugin = $project->getExclusiveTypePlugin('scm');
				if (is_null($scmplugin)) continue;		// shouldn't happen... means SCM was disabled in the project
				$url='<a href="'.GFUrl::getURL()->projectURL($project, 'ScmCommitDetail', $scmplugin->getName(), '', array('scm_commit_id'=>$arr['ref_id'])).'">'.$activity_desc.'</a>';
				break;
			}
			case 'trackeritem': {
				$action = $arr['action'];
				switch ($action) {
				case 'create':
					$activity_desc = $Language->getText('ProjectActivity.TrackerItemCreate', array($arr['description1']));
					$url='<a href="'.GFUrl::getURL()->projectURL($project, 'TrackerItemEdit', 'tracker', '', array('tracker_item_id'=>$arr['ref_id'],'tracker_id'=>$arr['ref_id'])).'">'.$activity_desc.'</a>';
					break;
				case 'delete':
					// We can't link to the item since it was deleted
					$activity_desc = $Language->getText('ProjectActivity.TrackerItemDelete', array($arr['description1']));
					$url = $activity_desc;
					break;
				case 'statuschange':
					$activity_desc = $Language->getText('ProjectActivity.TrackerItemStatusChange', array($arr['description1'], $arr['description2']));
					$url='<a href="'.GFUrl::getURL()->projectURL($project, 'TrackerItemEdit', 'tracker', '', array('tracker_item_id' => $arr['ref_id'],'tracker_id'=>$arr['ref_id'])).'">'.$activity_desc.'</a>';
					break;
				default:
					continue;
				}
				break;
			}
			case 'forum': {
				$activity_desc=$Language->getText('ProjectActivity.ForumPostDescription', array($arr['description1']));
				$url = '<a href="'.GFUrl::getURL()->projectURL($project, 'ForumBrowse', 'forum', '', array('_forum_action'=>'MessageReply','message_id'=>$arr['subref_id'])).'">'.$activity_desc.'</a>';
				break;
			}
			default: {
				// Not handled
				continue;
			}
		}
		$trow=array();
		$trow[]='&nbsp;&nbsp;&nbsp;'.date('H:m:s',strtotime($arr['activity_date']));
		$trow[]=$url;
		if ($project_id == 0) {
			$trow[]=$projectlink;
		}
		if ($onlymine !== true) {
			$trow[]=$userlink;
		}
		echo $template->tableRow($trow, array(), false);
		unset($trow);
	}
	if ($j==0) {
		echo $template->tableFullRow($Language->getText('ProjectActivity.NoneFound'));
	}
	else {
		//echo $template->listPaginatorRow($paginator);
	}
	echo $template->tableBottom();

	if(isset($paginator) && is_object($paginator)) {
		echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
	}


$template->footer();
?>
