<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/MyTemplate.php');
require_once('lib/html/HTMLWidget.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
$user = $session->getUser();
$theme = new MyTemplate();

$con = Propel::getConnection(TrackerPeer::DATABASE_NAME);

// get all my projects from the DB
$projectsObj = $user->getAllProjects();

//a list of all ids of projects this user is a member of
$allids=$user->getAllProjectIds();
if (count($allids) > 0) {
	$allids=implode(',',$user->getAllProjectIds());
} else {
	$allids=0;
}

// Create an array with all my projects (id=>name)
$projects = array();
$projects[0] = $Lang->getText('Dashboard.AllProjects');
foreach($projectsObj as $prj) {
	$projects[$prj->getProjectId()]=$prj->getProjectName();
}

// Save the project_id that came in the request, only if it's valid
$project_id = (isset($_REQUEST['project_id']) && 
			  $_REQUEST['project_id'] > 0 &&
			  array_search($_REQUEST['project_id'], array_keys($projects)) !== false) ? intval($_REQUEST['project_id']) : 0;

// If there's a valid project_id, we'll filter by project all the queries
if ($project_id > 0) {
	$sqlproject_id = "AND t.project_id = '$project_id'";
} else {
	$sqlproject_id = "AND t.project_id IN (".$allids.")";
}

// Check if we want to filter only the user's items
$onlymine = (isset($_REQUEST['onlymine']) && $_REQUEST['onlymine'] == 1) ? true : false;

// If there's a valid project_id, we'll filter by project all the queries
if (!$onlymine) {
	$sqlmine = '';
} else {
	$sqlmine = "AND (ti.submitted_by = ".$user->getUserId()." OR
	ti.tracker_item_id IN (SELECT tracker_item_id FROM tracker_item_assignee
	WHERE assignee=".$user->getUserId()."))";
}


if(isset($_REQUEST['feedback'])) $feedback = $_REQUEST['feedback'];
$params = array(
	'title' => $Lang->getText('Tabs.Dashboard'),
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'selectedbottomtab' => 'dashboard',
	'user' => $user
	);

$theme->header($params);

if (count($projectsObj) == 0) {
	echo '<h3>'.$Lang->getText('Dashboard.NotAMember').'</h3>';
	$theme->footer();
	exit();
}
?>
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
<table border="0" cellspacing="0" cellpadding="3" bgcolor="#E0E0E0">
<tr>
	<td><strong><?php echo $Lang->getText('Dashboard.FilterByProject') ?></strong></td>
	<td><?php echo HTMLWidget::selectBoxFromAssoc($projects,'project_id',$project_id, false, false) ?></td>
	<td valign="middle" rowspan="2"><?php echo HTMLWidget::button("submit","" .   $Lang->getText('Common.Submit')  . " ","submit","","")?></td>
</tr>
<tr>
	<td colspan="2"><strong><?php echo $Lang->getText('Dashboard.IncludeOnlyMine') ?></strong>
	<input type="checkbox" name="onlymine" value="1" <?php if ($onlymine) echo 'checked' ?> /></td>
</tr>
</table>
</form>
<?php
$imgquerystring = '&amp;project_id='.$project_id.'&amp;onlymine='.$onlymine;
//echo '<br /><img src="/gf/my/dashboard/graphs/?action=OpenItemsByPriority'.$imgquerystring.'" alt="" /> &nbsp;';
echo '<img src="/gf/my/dashboard/graphs/?action=OpenItemsByTracker'.$imgquerystring.'" width="400" height="250" alt="" />&nbsp;&nbsp;';
//echo '<br /> &nbsp; <br /><img src="/gf/my/dashboard/graphs/?action=OpenItemsByUser'.$imgquerystring.'" alt="" /> &nbsp;';
echo '<img src="/gf/my/dashboard/graphs/?action=AgeOfItems'.$imgquerystring.'" width="400" height="250" alt="" />';

echo '<br />&nbsp;<br />';

/* *****************************
 * Get All Trackers In My Projects And Count of Late Items
 *******************************/

$latecount=array();
$trackers=array();
$taskmgrs=array();
$projectcount=array();
$sql="SELECT t.*,(SELECT count(*) FROM tracker_item 
	WHERE status_id=".Tracker::STATUS_OPEN." 
	AND open_date < (now() - (t.due_period*'1 second'::interval) )
	AND tracker_id=t.tracker_id) AS latecount 
	FROM tracker t
	WHERE 
	t.datatype=".Tracker::DATATYPE_TRACKER."
	$sqlproject_id
	AND t.open_count > 0
	ORDER BY t.project_id,t.tracker_name";
$stmt = $con->createStatement();

$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);
while ($rs->next()) {
	//$latecount[$rs->getInt('tracker_id')]=$rs->getInt('latecount');
	$latecount[$rs->getInt(1)]=$rs->getInt(20);
}
$rs->beforeFirst();

while ($rs->next()) {
	$t = new Tracker();
	$t->hydrate($rs, 1);
	
	if (!$t->userCanRead()) {
		continue;
	}
	$projectcount[$t->getProjectId()][]=$t;
	$trackers[$t->getProjectId()][]=true;
}

$sql="SELECT t.*,(SELECT count(*) FROM tracker_item 
	WHERE status_id=".Tracker::STATUS_OPEN." 
	AND close_date < now()
	AND tracker_id=t.tracker_id) AS latecount 
	FROM tracker t
	WHERE 
	t.datatype=".Tracker::DATATYPE_TASK."
	$sqlproject_id
	AND open_count > 0
	ORDER BY t.project_id,t.tracker_name";

$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);
while ($rs->next()) {
	//$latecount[$rs->getInt('tracker_id')]=$rs->getInt('latecount');
	$latecount[$rs->getInt(1)]=$rs->getInt(20);
}
$rs->beforeFirst();

while ($rs->next()) {
	$t = new Tracker();
	$t->hydrate($rs, 1);
	
	if (!$t->userCanRead()) {
		continue;
	}

	$projectcount[$t->getProjectId()][]=$t;
	$taskmgrs[$t->getProjectId()][]=true;	
}

echo '<h3>'.$Lang->getText('Dashboard.ProjectDashboard').'</h3>';
$theader = array();
$theader[] = $Lang->getText('Dashboard.Project');
$theader[] = $Lang->getText('Dashboard.Type');
$theader[] = $Lang->getText('Dashboard.Tracker');
$theader[] = $Lang->getText('Dashboard.OpenCount');
$theader[] = $Lang->getText('Dashboard.LateCount');
$theader[] = $Lang->getText('Dashboard.Status');
echo $theme->tableTop($theader);

$lastProject='';
$lastdatatype='';
$project_ids=array_keys($projectcount);
foreach ($project_ids as $proj) {
	foreach ($projectcount[$proj] as $t) {
		$trow=array();
		$tmod=array(); //extra param to tableRow to give us a rowspan
		if (!$t->userCanRead()) {
			continue;
		}
		if ($t->getProjectId() != "$lastProject") {
			$lastProject = $t->getProjectId();
			$lastdatatype='';
			$tmod[]='rowspan="'.count($projectcount[$proj]).'" bgcolor="#FFFFFF"';
			$trow[]=$t->getProject()->getProjectLink();
		}
		if ($t->getDatatype() != $lastdatatype) {
			$lastdatatype=$t->getDatatype();
			if ($t->getDatatype() == Tracker::DATATYPE_TASK) {
				$tmod[]='rowspan="'.count($taskmgrs[$proj]).'" bgcolor="#FFFFFF"';
				$trow[]='Tasks';
			} else {
				$tmod[]='rowspan="'.count($trackers[$proj]).'" bgcolor="#FFFFFF"';
				$trow[]='Issues';
			}
		}
		$tmod[]='';
		$trow[]=$t->getTrackerLink();
		$tmod[]='';
		$trow[]=$t->getOpenCount();
		$late=$latecount[$t->getTrackerId()];
		$tmod[]='';
		$trow[]=$late;
		if ($late == 0) {
			$tmod[]='bgcolor="#0cff00"';
			$trow[]=$Lang->getText('Dashboard.NoneLate');
		} elseif ($t->getOpenCount()==$late) {
			$tmod[]='bgcolor="BLACK"';
			$trow[]='<span id="white">'.$Lang->getText('Dashboard.AllLate').'</span>';
		} elseif ($t->getOpenCount() / $late > 2) {
			$tmod[]='bgcolor="#ffe400"';
			$trow[]=$Lang->getText('Dashboard.LessHalfLate');
		} elseif ($t->getOpenCount() / $late > 1) {
			$tmod[]='bgcolor="#ff0000"';
			$trow[]=$Lang->getText('Dashboard.OverHalfLate');
		}
		echo $theme->tableRow($trow,$tmod);
	}
}
echo $theme->tableBottom();

/* *****************************
 * Late TASKS by Id and Date
 ******************************* /

echo '<br />&nbsp;<br />';
$itemscount = 0;

//get a list of TASKS that are past due
$sql="SELECT ti.* FROM tracker_item ti, tracker t 
	WHERE t.datatype='".Tracker::DATATYPE_TASK."' 
	AND t.tracker_id=ti.tracker_id 
	$sqlproject_id
	$sqlmine
	AND ti.status_id='".Tracker::STATUS_OPEN."'
	AND ti.close_date < now() ORDER BY t.project_id ASC, ti.tracker_id ASC, ti.close_date ASC";

$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);
$tis=TrackerItemPeer::populateObjects($rs);
reset($tis);

$projectcount=array();
$trackercount=array();
//iterate the list of projects and put into array which will be 
//useful for getting a rowspan count
foreach ($tis as $ti) {
	$projectcount[$ti->getTracker()->getProjectId()][]=true;
}
//iterate the list of trackers and put into array which will be 
//useful for getting a rowspan count
foreach ($tis as $ti) {
	$trackercount[$ti->getTrackerId()][]=$ti;
}

reset($tis);
$lastTracker=0;
$lastProject=null;

echo '<br />&nbsp;<br />';
echo '<h3>'.$Lang->getText('TrackerReporting.LateTasks').'</h3>';
$theader = array('Project', 'Tracker',$Lang->getText('TrackerItem.SummaryName'), $Lang->getText('TrackerReporting.DueDate'));
echo $theme->tableTop($theader);

foreach ($tis as $ti) {
	$trow=array();
	$tmod=array(); //extra param to tableRow to give us a rowspan
	if ($lastProject == null || $ti->getTracker()->getProjectId() != $lastProject->getProjectId()) {
		$lastProject = $ti->getTracker()->getProject();
		$tmod[]='rowspan="'.count($projectcount[$lastProject->getProjectId()]).'" bgcolor="#FFFFFF"';
		$trow[]=$lastProject->getProjectName();
	}
	if ($ti->getTrackerId() != $lastTracker) {
		$lastTracker=$ti->getTrackerId();
		$tmod[]='rowspan="'.count($trackercount[$lastTracker]).'" bgcolor="#FFFFFF"';
		$trow[]=$ti->getTracker()->getTrackerName();
	}
	$tmod[]='';
	$trow[]='<a href="'.GFUrl::getURL()->projectURL($lastProject, 'TrackerItemEdit', 'tracker', '', array('tracker_item_id'=>$lastTracker,'tracker_id'=>$ti->getTrackerItemId())).'">'. $ti->getSummary().'</a>';
	
	$tmod[]='';
	$trow[]=$ti->getCloseDate();
	echo $theme->tableRow($trow,$tmod);
	unset($tmod);
	unset($trow);
	$itemscount++;
}

if ($itemscount==0) {
	echo $theme->tableFullRow($Lang->getText('TrackerReporting.NoneFound'));
}
echo $theme->tableBottom();

echo '<br /><br />';
/***
*	LATE TRACKER ITEMS
* /
$itemscount = 0;

//	get a list of issues that are past due
$sql="SELECT ti.*
	FROM tracker_item ti, tracker t 
	WHERE t.datatype='".Tracker::DATATYPE_TRACKER."' 
	AND t.tracker_id=ti.tracker_id 
	$sqlproject_id
	$sqlmine
	AND ti.status_id='".Tracker::STATUS_OPEN."'
	AND ti.open_date < (now() - (t.due_period*'1 second'::interval) ) 
	ORDER BY t.project_id ASC, ti.tracker_id ASC, ti.close_date ASC";

$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);
$tis=TrackerItemPeer::populateObjects($rs);

reset($tis);

$projectcount=array();
$trackercount=array();
//iterate the list of projects and put into array which will be 
//useful for getting a rowspan count
foreach ($tis as $ti) {
	$projectcount[$ti->getTracker()->getProjectId()][]=true;
}
//iterate the list of trackers and put into array which will be 
//useful for getting a rowspan count
foreach ($tis as $ti) {
	$trackercount[$ti->getTrackerId()][]=$ti;
}

reset($tis);

$lastProject=null;
$lastTracker=0;
$duePeriod=0;

echo '<h3>'.$Lang->getText('TrackerReporting.LateItems').'</h3>';
$theader = array('Project', 'Tracker',$Lang->getText('TrackerItem.SummaryName'), $Lang->getText('TrackerReporting.DueDate'));
echo $theme->tableTop($theader);

foreach ($tis as $ti) {
	$trow=array();
	$tmod=array(); //extra param to tableRow to give us a rowspan
	if ($lastProject == null || $ti->getTracker()->getProjectId() != $lastProject->getProjectId()) {
		$lastProject = $ti->getTracker()->getProject();
		$tmod[]='rowspan="'.count($projectcount[$lastProject->getProjectId()]).'" bgcolor="#FFFFFF"';
		$trow[]=$lastProject->getProjectName();
	}
	if ($ti->getTrackerId() != $lastTracker) {
		$lastTracker=$ti->getTrackerId();
		$tmod[]='rowspan="'.count($trackercount[$lastTracker]).'" bgcolor="#FFFFFF"';
		$trow[]=$ti->getTracker()->getTrackerName();
	}
	$tmod[]='';
	
	$trow[]='<a href="'.GFUrl::getURL()->projectURL($lastProject, 'TrackerItemEdit', 'tracker', '', array('tracker_item_id'=>$lastTracker,'tracker_id'=>$ti->getTrackerItemId())).'">'. $ti->getSummary().'</a>';
	//$trow[]=$ti->getName();
	
	$tmod[]='';
	$auxdue = (strtotime($ti->getOpenDate()) + $duePeriod);
	$trow[]= date('Y-m-d H:i:s', $auxdue);
	echo $theme->tableRow($trow,$tmod);
	unset($tmod);
	unset($trow);
	$itemscount++;
}

if ($itemscount==0) {
	echo $theme->tableFullRow($Lang->getText('TrackerReporting.NoneFound'));
}
echo $theme->tableBottom();
echo '<br /><br />';
*/
$theme->footer();
?>
