<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/tracker/lib/Tracker.php');
require_once("lib/GraphicPie.php");

$session = Session::getSession();
$Lang = $session->getLanguage();

$Project = GFUrl::getUrl()->getProject();
$project_id = $Project->getProjectId();

$sql = "select u.unix_name, count(*) as count from tracker t, project p, tracker_item ti, tracker_item_assignee tia, \"user\" u
where ti.tracker_id = t.tracker_id and tia.assignee != '100'
and tia.assignee = u.user_id and tia.tracker_item_id = ti.tracker_item_id 
and t.project_id = p.project_id and p.project_id = '$project_id'
and ti.status_id=".Tracker::STATUS_OPEN." group by u.unix_name order by count desc";

$gp = new GraphicPie($Lang->getText('ProjectReporting.ByAssignee'), 400, 250);
$gp->setSQL($sql);
$gp->setSQLFields('unix_name', 'count');
//$gp->setTheme('pastel');
$gp->showPie();
?>
