<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'core/ProjectPeer.php';

/**
 * Base class that represents a row from the 'project' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Project class. 
 * 
 * @package core 
 */
abstract class BaseProject extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ProjectPeer
	 */
	protected static $peer;

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the project_name field.
	 * @var string	  
	 */
	protected $project_name;	

	/**
	 * The value for the unix_name field.
	 * @var string	  
	 */
	protected $unix_name;	

	/**
	 * The value for the homepage_url field.
	 * @var string	  
	 */
	protected $homepage_url;	

	/**
	 * The value for the is_public field.
	 * @var boolean	  
	 */
	protected $is_public = true;	

	/**
	 * The value for the status field.
	 * @var int	  
	 */
	protected $status = 0;	

	/**
	 * The value for the description field.
	 * @var string	  
	 */
	protected $description;	

	/**
	 * The value for the register_purpose field.
	 * @var string	  
	 */
	protected $register_purpose;	

	/**
	 * The value for the register_license_other field.
	 * @var string	  
	 */
	protected $register_license_other;	

	/**
	 * The value for the create_date field.
	 * @var int	  
	 */
	protected $create_date = -1;	

	/**
	 * The value for the template_project_id field.
	 * @var int	  
	 */
	protected $template_project_id;	

	/**
	 * The value for the is_template field.
	 * @var boolean	  
	 */
	protected $is_template = false;	

	/**
	 * The value for the parent_project_id field.
	 * @var int	  
	 */
	protected $parent_project_id = 0;	

	/**
	 * The value for the root_parent_project_id field.
	 * @var int	  
	 */
	protected $root_parent_project_id = 0;	

	/**
	 * The value for the root_path field.
	 * @var string	  
	 */
	protected $root_path;	

	/**
	 * The value for the project_text1 field.
	 * @var string	  
	 */
	protected $project_text1;	

	/**
	 * The value for the project_text2 field.
	 * @var string	  
	 */
	protected $project_text2;	

	/**
	 * The value for the project_text3 field.
	 * @var string	  
	 */
	protected $project_text3;	

	/**
	 * The value for the project_text4 field.
	 * @var string	  
	 */
	protected $project_text4;	

	/**
	 * The value for the project_text5 field.
	 * @var string	  
	 */
	protected $project_text5;	

	/**
	 * The value for the project_text6 field.
	 * @var string	  
	 */
	protected $project_text6;	

	/**
	 * The value for the is_listed field.
	 * @var boolean	  
	 */
	protected $is_listed = false;	
  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = ProjectPeer::PROJECT_ID;
		}
			
		  // update associated Cruisecontrol		  
		  if ($this->collCruisecontrols !== null) {
			  for ($i=0,$size=count($this->collCruisecontrols); $i < $size; $i++) {
				  $this->collCruisecontrols[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated DocmanProjectSetting		  
		  if ($this->collDocmanProjectSettings !== null) {
			  for ($i=0,$size=count($this->collDocmanProjectSettings); $i < $size; $i++) {
				  $this->collDocmanProjectSettings[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated DocmanFolder		  
		  if ($this->collDocmanFolders !== null) {
			  for ($i=0,$size=count($this->collDocmanFolders); $i < $size; $i++) {
				  $this->collDocmanFolders[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated FrsProjectSetting		  
		  if ($this->collFrsProjectSettings !== null) {
			  for ($i=0,$size=count($this->collFrsProjectSettings); $i < $size; $i++) {
				  $this->collFrsProjectSettings[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated FrsPackage		  
		  if ($this->collFrsPackages !== null) {
			  for ($i=0,$size=count($this->collFrsPackages); $i < $size; $i++) {
				  $this->collFrsPackages[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated Mailman		  
		  if ($this->collMailmans !== null) {
			  for ($i=0,$size=count($this->collMailmans); $i < $size; $i++) {
				  $this->collMailmans[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated News		  
		  if ($this->collNewss !== null) {
			  for ($i=0,$size=count($this->collNewss); $i < $size; $i++) {
				  $this->collNewss[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated NewsCount		  
		  if ($this->collNewsCounts !== null) {
			  for ($i=0,$size=count($this->collNewsCounts); $i < $size; $i++) {
				  $this->collNewsCounts[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated ProjectJoinRequest		  
		  if ($this->collProjectJoinRequests !== null) {
			  for ($i=0,$size=count($this->collProjectJoinRequests); $i < $size; $i++) {
				  $this->collProjectJoinRequests[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated ProjectPlugin		  
		  if ($this->collProjectPlugins !== null) {
			  for ($i=0,$size=count($this->collProjectPlugins); $i < $size; $i++) {
				  $this->collProjectPlugins[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated ProjectScm		  
		  if ($this->collProjectScms !== null) {
			  for ($i=0,$size=count($this->collProjectScms); $i < $size; $i++) {
				  $this->collProjectScms[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated Role		  
		  if ($this->collRoles !== null) {
			  for ($i=0,$size=count($this->collRoles); $i < $size; $i++) {
				  $this->collRoles[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated ScmCommitFilterProject		  
		  if ($this->collScmCommitFilterProjects !== null) {
			  for ($i=0,$size=count($this->collScmCommitFilterProjects); $i < $size; $i++) {
				  $this->collScmCommitFilterProjects[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated ScmModule		  
		  if ($this->collScmModules !== null) {
			  for ($i=0,$size=count($this->collScmModules); $i < $size; $i++) {
				  $this->collScmModules[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated ScmPreference		  
		  if ($this->collScmPreferences !== null) {
			  for ($i=0,$size=count($this->collScmPreferences); $i < $size; $i++) {
				  $this->collScmPreferences[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated ScmProjectStats		  
		  if ($this->collScmProjectStatss !== null) {
			  for ($i=0,$size=count($this->collScmProjectStatss); $i < $size; $i++) {
				  $this->collScmProjectStatss[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated ScmCommit		  
		  if ($this->collScmCommits !== null) {
			  for ($i=0,$size=count($this->collScmCommits); $i < $size; $i++) {
				  $this->collScmCommits[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated DiskUsage		  
		  if ($this->collDiskUsages !== null) {
			  for ($i=0,$size=count($this->collDiskUsages); $i < $size; $i++) {
				  $this->collDiskUsages[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated ProjectExportRequest		  
		  if ($this->collProjectExportRequests !== null) {
			  for ($i=0,$size=count($this->collProjectExportRequests); $i < $size; $i++) {
				  $this->collProjectExportRequests[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated JabberProjectLog		  
		  if ($this->collJabberProjectLogs !== null) {
			  for ($i=0,$size=count($this->collJabberProjectLogs); $i < $size; $i++) {
				  $this->collJabberProjectLogs[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated ScmUserStats		  
		  if ($this->collScmUserStatss !== null) {
			  for ($i=0,$size=count($this->collScmUserStatss); $i < $size; $i++) {
				  $this->collScmUserStatss[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated SurveyQuestion		  
		  if ($this->collSurveyQuestions !== null) {
			  for ($i=0,$size=count($this->collSurveyQuestions); $i < $size; $i++) {
				  $this->collSurveyQuestions[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated Tracker		  
		  if ($this->collTrackers !== null) {
			  for ($i=0,$size=count($this->collTrackers); $i < $size; $i++) {
				  $this->collTrackers[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated UserProject		  
		  if ($this->collUserProjects !== null) {
			  for ($i=0,$size=count($this->collUserProjects); $i < $size; $i++) {
				  $this->collUserProjects[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated UserWatchedProject		  
		  if ($this->collUserWatchedProjects !== null) {
			  for ($i=0,$size=count($this->collUserWatchedProjects); $i < $size; $i++) {
				  $this->collUserWatchedProjects[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated WikiProjectSetting		  
		  if ($this->collWikiProjectSettings !== null) {
			  for ($i=0,$size=count($this->collWikiProjectSettings); $i < $size; $i++) {
				  $this->collWikiProjectSettings[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated MyReportProject		  
		  if ($this->collMyReportProjects !== null) {
			  for ($i=0,$size=count($this->collMyReportProjects); $i < $size; $i++) {
				  $this->collMyReportProjects[$i]->setProjectId($v);
			  }
		  }
			  	
		  // update associated CodeSearchModule		  
		  if ($this->collCodeSearchModules !== null) {
			  for ($i=0,$size=count($this->collCodeSearchModules); $i < $size; $i++) {
				  $this->collCodeSearchModules[$i]->setProjectId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the ProjectName column value.
	 *  
	 * @return string	  
	 */
	public function getProjectName()
	{
		return $this->project_name;
	}


	/**
	 * Set the value of `project_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setProjectName($v)
	{
		if ($this->project_name !== $v) {
			$this->project_name = $v;
			$this->modifiedColumns[] = ProjectPeer::PROJECT_NAME;
		}
				
	}

  
	/**
	 * Get the UnixName column value.
	 *  
	 * @return string	  
	 */
	public function getUnixName()
	{
		return $this->unix_name;
	}


	/**
	 * Set the value of `unix_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setUnixName($v)
	{
		if ($this->unix_name !== $v) {
			$this->unix_name = $v;
			$this->modifiedColumns[] = ProjectPeer::UNIX_NAME;
		}
				
	}

  
	/**
	 * Get the HomepageUrl column value.
	 *  
	 * @return string	  
	 */
	public function getHomepageUrl()
	{
		return $this->homepage_url;
	}


	/**
	 * Set the value of `homepage_url` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setHomepageUrl($v)
	{
		if ($this->homepage_url !== $v) {
			$this->homepage_url = $v;
			$this->modifiedColumns[] = ProjectPeer::HOMEPAGE_URL;
		}
				
	}

  
	/**
	 * Get the IsPublic column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsPublic()
	{
		return $this->is_public;
	}


	/**
	 * Set the value of `is_public` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsPublic($v)
	{
		if ($this->is_public !== $v || $v === true) {
			$this->is_public = $v;
			$this->modifiedColumns[] = ProjectPeer::IS_PUBLIC;
		}
				
	}

  
	/**
	 * Get the Status column value.
	 *  
	 * @return int	  
	 */
	public function getStatus()
	{
		return $this->status;
	}


	/**
	 * Set the value of `status` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setStatus($v)
	{
		if ($this->status !== $v || $v === 0) {
			$this->status = $v;
			$this->modifiedColumns[] = ProjectPeer::STATUS;
		}
				
	}

  
	/**
	 * Get the Description column value.
	 *  
	 * @return string	  
	 */
	public function getDescription()
	{
		return $this->description;
	}


	/**
	 * Set the value of `description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDescription($v)
	{
		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = ProjectPeer::DESCRIPTION;
		}
				
	}

  
	/**
	 * Get the RegisterPurpose column value.
	 *  
	 * @return string	  
	 */
	public function getRegisterPurpose()
	{
		return $this->register_purpose;
	}


	/**
	 * Set the value of `register_purpose` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setRegisterPurpose($v)
	{
		if ($this->register_purpose !== $v) {
			$this->register_purpose = $v;
			$this->modifiedColumns[] = ProjectPeer::REGISTER_PURPOSE;
		}
				
	}

  
	/**
	 * Get the RegisterLicenseOther column value.
	 *  
	 * @return string	  
	 */
	public function getRegisterLicenseOther()
	{
		return $this->register_license_other;
	}


	/**
	 * Set the value of `register_license_other` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setRegisterLicenseOther($v)
	{
		if ($this->register_license_other !== $v) {
			$this->register_license_other = $v;
			$this->modifiedColumns[] = ProjectPeer::REGISTER_LICENSE_OTHER;
		}
				
	}


	/**
	 * Get the [optionally formatted] `create_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCreateDate($format = 'Y-m-d H:i:s')
	{
		if ($this->create_date === null || $this->create_date === '') {
			return null;
		} elseif (!is_int($this->create_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->create_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of create_date as date/time value: " . var_export($this->create_date, true));
			}
		} else {
			$ts = $this->create_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `create_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setCreateDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for create_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->create_date !== $ts || $ts === -1) {
			$this->create_date = $ts;
			$this->modifiedColumns[] = ProjectPeer::CREATE_DATE;
		}
		
	}

  
	/**
	 * Get the TemplateProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getTemplateProjectId()
	{
		return $this->template_project_id;
	}


	/**
	 * Set the value of `template_project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setTemplateProjectId($v)
	{
		if ($this->template_project_id !== $v) {
			$this->template_project_id = $v;
			$this->modifiedColumns[] = ProjectPeer::TEMPLATE_PROJECT_ID;
		}
				
	}

  
	/**
	 * Get the IsTemplate column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsTemplate()
	{
		return $this->is_template;
	}


	/**
	 * Set the value of `is_template` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsTemplate($v)
	{
		if ($this->is_template !== $v || $v === false) {
			$this->is_template = $v;
			$this->modifiedColumns[] = ProjectPeer::IS_TEMPLATE;
		}
				
	}

  
	/**
	 * Get the ParentProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getParentProjectId()
	{
		return $this->parent_project_id;
	}


	/**
	 * Set the value of `parent_project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setParentProjectId($v)
	{
		if ($this->parent_project_id !== $v || $v === 0) {
			$this->parent_project_id = $v;
			$this->modifiedColumns[] = ProjectPeer::PARENT_PROJECT_ID;
		}
				
	}

  
	/**
	 * Get the RootParentProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getRootParentProjectId()
	{
		return $this->root_parent_project_id;
	}


	/**
	 * Set the value of `root_parent_project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRootParentProjectId($v)
	{
		if ($this->root_parent_project_id !== $v || $v === 0) {
			$this->root_parent_project_id = $v;
			$this->modifiedColumns[] = ProjectPeer::ROOT_PARENT_PROJECT_ID;
		}
				
	}

  
	/**
	 * Get the RootPath column value.
	 *  
	 * @return string	  
	 */
	public function getRootPath()
	{
		return $this->root_path;
	}


	/**
	 * Set the value of `root_path` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setRootPath($v)
	{
		if ($this->root_path !== $v) {
			$this->root_path = $v;
			$this->modifiedColumns[] = ProjectPeer::ROOT_PATH;
		}
				
	}

  
	/**
	 * Get the ProjectText1 column value.
	 *  
	 * @return string	  
	 */
	public function getProjectText1()
	{
		return $this->project_text1;
	}


	/**
	 * Set the value of `project_text1` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setProjectText1($v)
	{
		if ($this->project_text1 !== $v) {
			$this->project_text1 = $v;
			$this->modifiedColumns[] = ProjectPeer::PROJECT_TEXT1;
		}
				
	}

  
	/**
	 * Get the ProjectText2 column value.
	 *  
	 * @return string	  
	 */
	public function getProjectText2()
	{
		return $this->project_text2;
	}


	/**
	 * Set the value of `project_text2` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setProjectText2($v)
	{
		if ($this->project_text2 !== $v) {
			$this->project_text2 = $v;
			$this->modifiedColumns[] = ProjectPeer::PROJECT_TEXT2;
		}
				
	}

  
	/**
	 * Get the ProjectText3 column value.
	 *  
	 * @return string	  
	 */
	public function getProjectText3()
	{
		return $this->project_text3;
	}


	/**
	 * Set the value of `project_text3` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setProjectText3($v)
	{
		if ($this->project_text3 !== $v) {
			$this->project_text3 = $v;
			$this->modifiedColumns[] = ProjectPeer::PROJECT_TEXT3;
		}
				
	}

  
	/**
	 * Get the ProjectText4 column value.
	 *  
	 * @return string	  
	 */
	public function getProjectText4()
	{
		return $this->project_text4;
	}


	/**
	 * Set the value of `project_text4` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setProjectText4($v)
	{
		if ($this->project_text4 !== $v) {
			$this->project_text4 = $v;
			$this->modifiedColumns[] = ProjectPeer::PROJECT_TEXT4;
		}
				
	}

  
	/**
	 * Get the ProjectText5 column value.
	 *  
	 * @return string	  
	 */
	public function getProjectText5()
	{
		return $this->project_text5;
	}


	/**
	 * Set the value of `project_text5` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setProjectText5($v)
	{
		if ($this->project_text5 !== $v) {
			$this->project_text5 = $v;
			$this->modifiedColumns[] = ProjectPeer::PROJECT_TEXT5;
		}
				
	}

  
	/**
	 * Get the ProjectText6 column value.
	 *  
	 * @return string	  
	 */
	public function getProjectText6()
	{
		return $this->project_text6;
	}


	/**
	 * Set the value of `project_text6` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setProjectText6($v)
	{
		if ($this->project_text6 !== $v) {
			$this->project_text6 = $v;
			$this->modifiedColumns[] = ProjectPeer::PROJECT_TEXT6;
		}
				
	}

  
	/**
	 * Get the IsListed column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsListed()
	{
		return $this->is_listed;
	}


	/**
	 * Set the value of `is_listed` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsListed($v)
	{
		if ($this->is_listed !== $v || $v === false) {
			$this->is_listed = $v;
			$this->modifiedColumns[] = ProjectPeer::IS_LISTED;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->project_id = $rs->getInt($startcol + 0);					
			$this->project_name = $rs->getString($startcol + 1);					
			$this->unix_name = $rs->getString($startcol + 2);					
			$this->homepage_url = $rs->getString($startcol + 3);					
			$this->is_public = $rs->getBoolean($startcol + 4);					
			$this->status = $rs->getInt($startcol + 5);					
			$this->description = $rs->getString($startcol + 6);					
			$this->register_purpose = $rs->getString($startcol + 7);					
			$this->register_license_other = $rs->getString($startcol + 8);					
			$this->create_date = $rs->getTimestamp($startcol + 9, null);
			$this->template_project_id = $rs->getInt($startcol + 10);					
			$this->is_template = $rs->getBoolean($startcol + 11);					
			$this->parent_project_id = $rs->getInt($startcol + 12);					
			$this->root_parent_project_id = $rs->getInt($startcol + 13);					
			$this->root_path = $rs->getString($startcol + 14);					
			$this->project_text1 = $rs->getString($startcol + 15);					
			$this->project_text2 = $rs->getString($startcol + 16);					
			$this->project_text3 = $rs->getString($startcol + 17);					
			$this->project_text4 = $rs->getString($startcol + 18);					
			$this->project_text5 = $rs->getString($startcol + 19);					
			$this->project_text6 = $rs->getString($startcol + 20);					
			$this->is_listed = $rs->getBoolean($startcol + 21);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Project object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(ProjectPeer::DATABASE_NAME);
		$criteria->add(ProjectPeer::PROJECT_ID, $this->project_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(ProjectPeer::DATABASE_NAME);
		if ($this->isColumnModified(ProjectPeer::PROJECT_ID)) $criteria->add(ProjectPeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(ProjectPeer::PROJECT_NAME)) $criteria->add(ProjectPeer::PROJECT_NAME, $this->project_name);
		if ($this->isColumnModified(ProjectPeer::UNIX_NAME)) $criteria->add(ProjectPeer::UNIX_NAME, $this->unix_name);
		if ($this->isColumnModified(ProjectPeer::HOMEPAGE_URL)) $criteria->add(ProjectPeer::HOMEPAGE_URL, $this->homepage_url);
		if ($this->isColumnModified(ProjectPeer::IS_PUBLIC)) $criteria->add(ProjectPeer::IS_PUBLIC, $this->is_public);
		if ($this->isColumnModified(ProjectPeer::STATUS)) $criteria->add(ProjectPeer::STATUS, $this->status);
		if ($this->isColumnModified(ProjectPeer::DESCRIPTION)) $criteria->add(ProjectPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(ProjectPeer::REGISTER_PURPOSE)) $criteria->add(ProjectPeer::REGISTER_PURPOSE, $this->register_purpose);
		if ($this->isColumnModified(ProjectPeer::REGISTER_LICENSE_OTHER)) $criteria->add(ProjectPeer::REGISTER_LICENSE_OTHER, $this->register_license_other);
		if ($this->isColumnModified(ProjectPeer::CREATE_DATE)) $criteria->add(ProjectPeer::CREATE_DATE, $this->create_date);
		if ($this->isColumnModified(ProjectPeer::TEMPLATE_PROJECT_ID)) $criteria->add(ProjectPeer::TEMPLATE_PROJECT_ID, $this->template_project_id);
		if ($this->isColumnModified(ProjectPeer::IS_TEMPLATE)) $criteria->add(ProjectPeer::IS_TEMPLATE, $this->is_template);
		if ($this->isColumnModified(ProjectPeer::PARENT_PROJECT_ID)) $criteria->add(ProjectPeer::PARENT_PROJECT_ID, $this->parent_project_id);
		if ($this->isColumnModified(ProjectPeer::ROOT_PARENT_PROJECT_ID)) $criteria->add(ProjectPeer::ROOT_PARENT_PROJECT_ID, $this->root_parent_project_id);
		if ($this->isColumnModified(ProjectPeer::ROOT_PATH)) $criteria->add(ProjectPeer::ROOT_PATH, $this->root_path);
		if ($this->isColumnModified(ProjectPeer::PROJECT_TEXT1)) $criteria->add(ProjectPeer::PROJECT_TEXT1, $this->project_text1);
		if ($this->isColumnModified(ProjectPeer::PROJECT_TEXT2)) $criteria->add(ProjectPeer::PROJECT_TEXT2, $this->project_text2);
		if ($this->isColumnModified(ProjectPeer::PROJECT_TEXT3)) $criteria->add(ProjectPeer::PROJECT_TEXT3, $this->project_text3);
		if ($this->isColumnModified(ProjectPeer::PROJECT_TEXT4)) $criteria->add(ProjectPeer::PROJECT_TEXT4, $this->project_text4);
		if ($this->isColumnModified(ProjectPeer::PROJECT_TEXT5)) $criteria->add(ProjectPeer::PROJECT_TEXT5, $this->project_text5);
		if ($this->isColumnModified(ProjectPeer::PROJECT_TEXT6)) $criteria->add(ProjectPeer::PROJECT_TEXT6, $this->project_text6);
		if ($this->isColumnModified(ProjectPeer::IS_LISTED)) $criteria->add(ProjectPeer::IS_LISTED, $this->is_listed);
		return $criteria;			
	}
	
	

	/**
	 * Collection to store aggregation of collCruisecontrols	  
	 * @var array
	 */
	protected $collCruisecontrols; 

	/**
	 * Temporary storage of collCruisecontrols to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCruisecontrols()
	{
		if ($this->collCruisecontrols === null) {
			$this->collCruisecontrols = array();
		}
	}

	/**
	 * Method called to associate a Cruisecontrol object to this object
	 * through the Cruisecontrol foreign key attribute
	 *
	 * @param Cruisecontrol $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCruisecontrol(Cruisecontrol $l)
	{
		$this->collCruisecontrols[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collCruisecontrols.
	 * @var Criteria
	 */
	private $lastCruisecontrolsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related Cruisecontrols from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCruisecontrols($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCruisecontrols === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrols = array();
			} else {
	
				$criteria->add(CruisecontrolPeer::PROJECT_ID, $this->getProjectId() );

				$this->collCruisecontrols = CruisecontrolPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CruisecontrolPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastCruisecontrolsCriteria) || !$this->lastCruisecontrolsCriteria->equals($criteria)) {
					$this->collCruisecontrols = CruisecontrolPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCruisecontrolsCriteria = $criteria;

		return $this->collCruisecontrols;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related Cruisecontrols from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getCruisecontrolsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrols === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrols = array();
			} else {
	   
				$criteria->add(CruisecontrolPeer::PROJECT_ID, $this->getProjectId());
				$this->collCruisecontrols = CruisecontrolPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastCruisecontrolsCriteria) || !$this->lastCruisecontrolsCriteria->equals($criteria)) {
				$this->collCruisecontrols = CruisecontrolPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastCruisecontrolsCriteria = $criteria;

		return $this->collCruisecontrols;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related Cruisecontrols from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getCruisecontrolsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrols === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrols = array();
			} else {
	   
				$criteria->add(CruisecontrolPeer::PROJECT_ID, $this->getProjectId());
				$this->collCruisecontrols = CruisecontrolPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastCruisecontrolsCriteria) || !$this->lastCruisecontrolsCriteria->equals($criteria)) {
				$this->collCruisecontrols = CruisecontrolPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastCruisecontrolsCriteria = $criteria;

		return $this->collCruisecontrols;
	}

	/**
	 * Collection to store aggregation of collDocmanProjectSettings	  
	 * @var array
	 */
	protected $collDocmanProjectSettings; 

	/**
	 * Temporary storage of collDocmanProjectSettings to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initDocmanProjectSettings()
	{
		if ($this->collDocmanProjectSettings === null) {
			$this->collDocmanProjectSettings = array();
		}
	}

	/**
	 * Method called to associate a DocmanProjectSetting object to this object
	 * through the DocmanProjectSetting foreign key attribute
	 *
	 * @param DocmanProjectSetting $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addDocmanProjectSetting(DocmanProjectSetting $l)
	{
		$this->collDocmanProjectSettings[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collDocmanProjectSettings.
	 * @var Criteria
	 */
	private $lastDocmanProjectSettingsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related DocmanProjectSettings from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getDocmanProjectSettings($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanProjectSettingPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collDocmanProjectSettings === null) {
			if ($this->isNew()) {
			   $this->collDocmanProjectSettings = array();
			} else {
	
				$criteria->add(DocmanProjectSettingPeer::PROJECT_ID, $this->getProjectId() );

				$this->collDocmanProjectSettings = DocmanProjectSettingPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(DocmanProjectSettingPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastDocmanProjectSettingsCriteria) || !$this->lastDocmanProjectSettingsCriteria->equals($criteria)) {
					$this->collDocmanProjectSettings = DocmanProjectSettingPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDocmanProjectSettingsCriteria = $criteria;

		return $this->collDocmanProjectSettings;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related DocmanProjectSettings from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getDocmanProjectSettingsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanProjectSettingPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collDocmanProjectSettings === null) {
			if ($this->isNew()) {
			   $this->collDocmanProjectSettings = array();
			} else {
	   
				$criteria->add(DocmanProjectSettingPeer::PROJECT_ID, $this->getProjectId());
				$this->collDocmanProjectSettings = DocmanProjectSettingPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(DocmanProjectSettingPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastDocmanProjectSettingsCriteria) || !$this->lastDocmanProjectSettingsCriteria->equals($criteria)) {
				$this->collDocmanProjectSettings = DocmanProjectSettingPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastDocmanProjectSettingsCriteria = $criteria;

		return $this->collDocmanProjectSettings;
	}

	/**
	 * Collection to store aggregation of collDocmanFolders	  
	 * @var array
	 */
	protected $collDocmanFolders; 

	/**
	 * Temporary storage of collDocmanFolders to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initDocmanFolders()
	{
		if ($this->collDocmanFolders === null) {
			$this->collDocmanFolders = array();
		}
	}

	/**
	 * Method called to associate a DocmanFolder object to this object
	 * through the DocmanFolder foreign key attribute
	 *
	 * @param DocmanFolder $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addDocmanFolder(DocmanFolder $l)
	{
		$this->collDocmanFolders[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collDocmanFolders.
	 * @var Criteria
	 */
	private $lastDocmanFoldersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related DocmanFolders from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getDocmanFolders($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFolderPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collDocmanFolders === null) {
			if ($this->isNew()) {
			   $this->collDocmanFolders = array();
			} else {
	
				$criteria->add(DocmanFolderPeer::PROJECT_ID, $this->getProjectId() );

				$this->collDocmanFolders = DocmanFolderPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(DocmanFolderPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastDocmanFoldersCriteria) || !$this->lastDocmanFoldersCriteria->equals($criteria)) {
					$this->collDocmanFolders = DocmanFolderPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDocmanFoldersCriteria = $criteria;

		return $this->collDocmanFolders;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related DocmanFolders from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getDocmanFoldersJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFolderPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collDocmanFolders === null) {
			if ($this->isNew()) {
			   $this->collDocmanFolders = array();
			} else {
	   
				$criteria->add(DocmanFolderPeer::PROJECT_ID, $this->getProjectId());
				$this->collDocmanFolders = DocmanFolderPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(DocmanFolderPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastDocmanFoldersCriteria) || !$this->lastDocmanFoldersCriteria->equals($criteria)) {
				$this->collDocmanFolders = DocmanFolderPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastDocmanFoldersCriteria = $criteria;

		return $this->collDocmanFolders;
	}

	/**
	 * Collection to store aggregation of collFrsProjectSettings	  
	 * @var array
	 */
	protected $collFrsProjectSettings; 

	/**
	 * Temporary storage of collFrsProjectSettings to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initFrsProjectSettings()
	{
		if ($this->collFrsProjectSettings === null) {
			$this->collFrsProjectSettings = array();
		}
	}

	/**
	 * Method called to associate a FrsProjectSetting object to this object
	 * through the FrsProjectSetting foreign key attribute
	 *
	 * @param FrsProjectSetting $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addFrsProjectSetting(FrsProjectSetting $l)
	{
		$this->collFrsProjectSettings[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collFrsProjectSettings.
	 * @var Criteria
	 */
	private $lastFrsProjectSettingsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related FrsProjectSettings from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getFrsProjectSettings($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/frs/lib/FrsProjectSettingPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collFrsProjectSettings === null) {
			if ($this->isNew()) {
			   $this->collFrsProjectSettings = array();
			} else {
	
				$criteria->add(FrsProjectSettingPeer::PROJECT_ID, $this->getProjectId() );

				$this->collFrsProjectSettings = FrsProjectSettingPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(FrsProjectSettingPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastFrsProjectSettingsCriteria) || !$this->lastFrsProjectSettingsCriteria->equals($criteria)) {
					$this->collFrsProjectSettings = FrsProjectSettingPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastFrsProjectSettingsCriteria = $criteria;

		return $this->collFrsProjectSettings;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related FrsProjectSettings from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getFrsProjectSettingsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/frs/lib/FrsProjectSettingPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collFrsProjectSettings === null) {
			if ($this->isNew()) {
			   $this->collFrsProjectSettings = array();
			} else {
	   
				$criteria->add(FrsProjectSettingPeer::PROJECT_ID, $this->getProjectId());
				$this->collFrsProjectSettings = FrsProjectSettingPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(FrsProjectSettingPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastFrsProjectSettingsCriteria) || !$this->lastFrsProjectSettingsCriteria->equals($criteria)) {
				$this->collFrsProjectSettings = FrsProjectSettingPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastFrsProjectSettingsCriteria = $criteria;

		return $this->collFrsProjectSettings;
	}

	/**
	 * Collection to store aggregation of collFrsPackages	  
	 * @var array
	 */
	protected $collFrsPackages; 

	/**
	 * Temporary storage of collFrsPackages to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initFrsPackages()
	{
		if ($this->collFrsPackages === null) {
			$this->collFrsPackages = array();
		}
	}

	/**
	 * Method called to associate a FrsPackage object to this object
	 * through the FrsPackage foreign key attribute
	 *
	 * @param FrsPackage $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addFrsPackage(FrsPackage $l)
	{
		$this->collFrsPackages[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collFrsPackages.
	 * @var Criteria
	 */
	private $lastFrsPackagesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related FrsPackages from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getFrsPackages($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/frs/lib/FrsPackagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collFrsPackages === null) {
			if ($this->isNew()) {
			   $this->collFrsPackages = array();
			} else {
	
				$criteria->add(FrsPackagePeer::PROJECT_ID, $this->getProjectId() );

				$this->collFrsPackages = FrsPackagePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(FrsPackagePeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastFrsPackagesCriteria) || !$this->lastFrsPackagesCriteria->equals($criteria)) {
					$this->collFrsPackages = FrsPackagePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastFrsPackagesCriteria = $criteria;

		return $this->collFrsPackages;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related FrsPackages from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getFrsPackagesJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/frs/lib/FrsPackagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collFrsPackages === null) {
			if ($this->isNew()) {
			   $this->collFrsPackages = array();
			} else {
	   
				$criteria->add(FrsPackagePeer::PROJECT_ID, $this->getProjectId());
				$this->collFrsPackages = FrsPackagePeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(FrsPackagePeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastFrsPackagesCriteria) || !$this->lastFrsPackagesCriteria->equals($criteria)) {
				$this->collFrsPackages = FrsPackagePeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastFrsPackagesCriteria = $criteria;

		return $this->collFrsPackages;
	}

	/**
	 * Collection to store aggregation of collMailmans	  
	 * @var array
	 */
	protected $collMailmans; 

	/**
	 * Temporary storage of collMailmans to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMailmans()
	{
		if ($this->collMailmans === null) {
			$this->collMailmans = array();
		}
	}

	/**
	 * Method called to associate a Mailman object to this object
	 * through the Mailman foreign key attribute
	 *
	 * @param Mailman $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMailman(Mailman $l)
	{
		$this->collMailmans[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collMailmans.
	 * @var Criteria
	 */
	private $lastMailmansCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related Mailmans from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMailmans($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/mailman/lib/MailmanPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMailmans === null) {
			if ($this->isNew()) {
			   $this->collMailmans = array();
			} else {
	
				$criteria->add(MailmanPeer::PROJECT_ID, $this->getProjectId() );

				$this->collMailmans = MailmanPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MailmanPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastMailmansCriteria) || !$this->lastMailmansCriteria->equals($criteria)) {
					$this->collMailmans = MailmanPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMailmansCriteria = $criteria;

		return $this->collMailmans;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related Mailmans from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getMailmansJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/mailman/lib/MailmanPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMailmans === null) {
			if ($this->isNew()) {
			   $this->collMailmans = array();
			} else {
	   
				$criteria->add(MailmanPeer::PROJECT_ID, $this->getProjectId());
				$this->collMailmans = MailmanPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MailmanPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastMailmansCriteria) || !$this->lastMailmansCriteria->equals($criteria)) {
				$this->collMailmans = MailmanPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastMailmansCriteria = $criteria;

		return $this->collMailmans;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related Mailmans from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getMailmansJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/mailman/lib/MailmanPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMailmans === null) {
			if ($this->isNew()) {
			   $this->collMailmans = array();
			} else {
	   
				$criteria->add(MailmanPeer::PROJECT_ID, $this->getProjectId());
				$this->collMailmans = MailmanPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MailmanPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastMailmansCriteria) || !$this->lastMailmansCriteria->equals($criteria)) {
				$this->collMailmans = MailmanPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastMailmansCriteria = $criteria;

		return $this->collMailmans;
	}

	/**
	 * Collection to store aggregation of collNewss	  
	 * @var array
	 */
	protected $collNewss; 

	/**
	 * Temporary storage of collNewss to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initNewss()
	{
		if ($this->collNewss === null) {
			$this->collNewss = array();
		}
	}

	/**
	 * Method called to associate a News object to this object
	 * through the News foreign key attribute
	 *
	 * @param News $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addNews(News $l)
	{
		$this->collNewss[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collNewss.
	 * @var Criteria
	 */
	private $lastNewssCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related Newss from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getNewss($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/news/lib/NewsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collNewss === null) {
			if ($this->isNew()) {
			   $this->collNewss = array();
			} else {
	
				$criteria->add(NewsPeer::PROJECT_ID, $this->getProjectId() );

				$this->collNewss = NewsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(NewsPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastNewssCriteria) || !$this->lastNewssCriteria->equals($criteria)) {
					$this->collNewss = NewsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastNewssCriteria = $criteria;

		return $this->collNewss;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related Newss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getNewssJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/news/lib/NewsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collNewss === null) {
			if ($this->isNew()) {
			   $this->collNewss = array();
			} else {
	   
				$criteria->add(NewsPeer::PROJECT_ID, $this->getProjectId());
				$this->collNewss = NewsPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(NewsPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastNewssCriteria) || !$this->lastNewssCriteria->equals($criteria)) {
				$this->collNewss = NewsPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastNewssCriteria = $criteria;

		return $this->collNewss;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related Newss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getNewssJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/news/lib/NewsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collNewss === null) {
			if ($this->isNew()) {
			   $this->collNewss = array();
			} else {
	   
				$criteria->add(NewsPeer::PROJECT_ID, $this->getProjectId());
				$this->collNewss = NewsPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(NewsPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastNewssCriteria) || !$this->lastNewssCriteria->equals($criteria)) {
				$this->collNewss = NewsPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastNewssCriteria = $criteria;

		return $this->collNewss;
	}

	/**
	 * Collection to store aggregation of collNewsCounts	  
	 * @var array
	 */
	protected $collNewsCounts; 

	/**
	 * Temporary storage of collNewsCounts to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initNewsCounts()
	{
		if ($this->collNewsCounts === null) {
			$this->collNewsCounts = array();
		}
	}

	/**
	 * Method called to associate a NewsCount object to this object
	 * through the NewsCount foreign key attribute
	 *
	 * @param NewsCount $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addNewsCount(NewsCount $l)
	{
		$this->collNewsCounts[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collNewsCounts.
	 * @var Criteria
	 */
	private $lastNewsCountsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related NewsCounts from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getNewsCounts($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/news/lib/NewsCountPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collNewsCounts === null) {
			if ($this->isNew()) {
			   $this->collNewsCounts = array();
			} else {
	
				$criteria->add(NewsCountPeer::PROJECT_ID, $this->getProjectId() );

				$this->collNewsCounts = NewsCountPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(NewsCountPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastNewsCountsCriteria) || !$this->lastNewsCountsCriteria->equals($criteria)) {
					$this->collNewsCounts = NewsCountPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastNewsCountsCriteria = $criteria;

		return $this->collNewsCounts;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related NewsCounts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getNewsCountsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/news/lib/NewsCountPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collNewsCounts === null) {
			if ($this->isNew()) {
			   $this->collNewsCounts = array();
			} else {
	   
				$criteria->add(NewsCountPeer::PROJECT_ID, $this->getProjectId());
				$this->collNewsCounts = NewsCountPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(NewsCountPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastNewsCountsCriteria) || !$this->lastNewsCountsCriteria->equals($criteria)) {
				$this->collNewsCounts = NewsCountPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastNewsCountsCriteria = $criteria;

		return $this->collNewsCounts;
	}

	/**
	 * Collection to store aggregation of collProjectJoinRequests	  
	 * @var array
	 */
	protected $collProjectJoinRequests; 

	/**
	 * Temporary storage of collProjectJoinRequests to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initProjectJoinRequests()
	{
		if ($this->collProjectJoinRequests === null) {
			$this->collProjectJoinRequests = array();
		}
	}

	/**
	 * Method called to associate a ProjectJoinRequest object to this object
	 * through the ProjectJoinRequest foreign key attribute
	 *
	 * @param ProjectJoinRequest $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addProjectJoinRequest(ProjectJoinRequest $l)
	{
		$this->collProjectJoinRequests[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collProjectJoinRequests.
	 * @var Criteria
	 */
	private $lastProjectJoinRequestsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related ProjectJoinRequests from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getProjectJoinRequests($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectJoinRequestPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collProjectJoinRequests === null) {
			if ($this->isNew()) {
			   $this->collProjectJoinRequests = array();
			} else {
	
				$criteria->add(ProjectJoinRequestPeer::PROJECT_ID, $this->getProjectId() );

				$this->collProjectJoinRequests = ProjectJoinRequestPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ProjectJoinRequestPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastProjectJoinRequestsCriteria) || !$this->lastProjectJoinRequestsCriteria->equals($criteria)) {
					$this->collProjectJoinRequests = ProjectJoinRequestPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastProjectJoinRequestsCriteria = $criteria;

		return $this->collProjectJoinRequests;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ProjectJoinRequests from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getProjectJoinRequestsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectJoinRequestPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectJoinRequests === null) {
			if ($this->isNew()) {
			   $this->collProjectJoinRequests = array();
			} else {
	   
				$criteria->add(ProjectJoinRequestPeer::PROJECT_ID, $this->getProjectId());
				$this->collProjectJoinRequests = ProjectJoinRequestPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectJoinRequestPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastProjectJoinRequestsCriteria) || !$this->lastProjectJoinRequestsCriteria->equals($criteria)) {
				$this->collProjectJoinRequests = ProjectJoinRequestPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastProjectJoinRequestsCriteria = $criteria;

		return $this->collProjectJoinRequests;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ProjectJoinRequests from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getProjectJoinRequestsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectJoinRequestPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectJoinRequests === null) {
			if ($this->isNew()) {
			   $this->collProjectJoinRequests = array();
			} else {
	   
				$criteria->add(ProjectJoinRequestPeer::PROJECT_ID, $this->getProjectId());
				$this->collProjectJoinRequests = ProjectJoinRequestPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectJoinRequestPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastProjectJoinRequestsCriteria) || !$this->lastProjectJoinRequestsCriteria->equals($criteria)) {
				$this->collProjectJoinRequests = ProjectJoinRequestPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastProjectJoinRequestsCriteria = $criteria;

		return $this->collProjectJoinRequests;
	}

	/**
	 * Collection to store aggregation of collProjectPlugins	  
	 * @var array
	 */
	protected $collProjectPlugins; 

	/**
	 * Temporary storage of collProjectPlugins to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initProjectPlugins()
	{
		if ($this->collProjectPlugins === null) {
			$this->collProjectPlugins = array();
		}
	}

	/**
	 * Method called to associate a ProjectPlugin object to this object
	 * through the ProjectPlugin foreign key attribute
	 *
	 * @param ProjectPlugin $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addProjectPlugin(ProjectPlugin $l)
	{
		$this->collProjectPlugins[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collProjectPlugins.
	 * @var Criteria
	 */
	private $lastProjectPluginsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related ProjectPlugins from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getProjectPlugins($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPluginPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collProjectPlugins === null) {
			if ($this->isNew()) {
			   $this->collProjectPlugins = array();
			} else {
	
				$criteria->add(ProjectPluginPeer::PROJECT_ID, $this->getProjectId() );

				$this->collProjectPlugins = ProjectPluginPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ProjectPluginPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastProjectPluginsCriteria) || !$this->lastProjectPluginsCriteria->equals($criteria)) {
					$this->collProjectPlugins = ProjectPluginPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastProjectPluginsCriteria = $criteria;

		return $this->collProjectPlugins;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ProjectPlugins from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getProjectPluginsJoinPlugin($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPluginPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectPlugins === null) {
			if ($this->isNew()) {
			   $this->collProjectPlugins = array();
			} else {
	   
				$criteria->add(ProjectPluginPeer::PROJECT_ID, $this->getProjectId());
				$this->collProjectPlugins = ProjectPluginPeer::doSelectJoinPlugin($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectPluginPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastProjectPluginsCriteria) || !$this->lastProjectPluginsCriteria->equals($criteria)) {
				$this->collProjectPlugins = ProjectPluginPeer::doSelectJoinPlugin($criteria, $con);
			}
		}
		$this->lastProjectPluginsCriteria = $criteria;

		return $this->collProjectPlugins;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ProjectPlugins from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getProjectPluginsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPluginPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectPlugins === null) {
			if ($this->isNew()) {
			   $this->collProjectPlugins = array();
			} else {
	   
				$criteria->add(ProjectPluginPeer::PROJECT_ID, $this->getProjectId());
				$this->collProjectPlugins = ProjectPluginPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectPluginPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastProjectPluginsCriteria) || !$this->lastProjectPluginsCriteria->equals($criteria)) {
				$this->collProjectPlugins = ProjectPluginPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastProjectPluginsCriteria = $criteria;

		return $this->collProjectPlugins;
	}

	/**
	 * Collection to store aggregation of collProjectScms	  
	 * @var array
	 */
	protected $collProjectScms; 

	/**
	 * Temporary storage of collProjectScms to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initProjectScms()
	{
		if ($this->collProjectScms === null) {
			$this->collProjectScms = array();
		}
	}

	/**
	 * Method called to associate a ProjectScm object to this object
	 * through the ProjectScm foreign key attribute
	 *
	 * @param ProjectScm $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addProjectScm(ProjectScm $l)
	{
		$this->collProjectScms[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collProjectScms.
	 * @var Criteria
	 */
	private $lastProjectScmsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related ProjectScms from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getProjectScms($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ProjectScmPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collProjectScms === null) {
			if ($this->isNew()) {
			   $this->collProjectScms = array();
			} else {
	
				$criteria->add(ProjectScmPeer::PROJECT_ID, $this->getProjectId() );

				$this->collProjectScms = ProjectScmPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ProjectScmPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastProjectScmsCriteria) || !$this->lastProjectScmsCriteria->equals($criteria)) {
					$this->collProjectScms = ProjectScmPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastProjectScmsCriteria = $criteria;

		return $this->collProjectScms;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ProjectScms from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getProjectScmsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ProjectScmPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectScms === null) {
			if ($this->isNew()) {
			   $this->collProjectScms = array();
			} else {
	   
				$criteria->add(ProjectScmPeer::PROJECT_ID, $this->getProjectId());
				$this->collProjectScms = ProjectScmPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectScmPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastProjectScmsCriteria) || !$this->lastProjectScmsCriteria->equals($criteria)) {
				$this->collProjectScms = ProjectScmPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastProjectScmsCriteria = $criteria;

		return $this->collProjectScms;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ProjectScms from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getProjectScmsJoinScmServer($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ProjectScmPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectScms === null) {
			if ($this->isNew()) {
			   $this->collProjectScms = array();
			} else {
	   
				$criteria->add(ProjectScmPeer::PROJECT_ID, $this->getProjectId());
				$this->collProjectScms = ProjectScmPeer::doSelectJoinScmServer($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectScmPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastProjectScmsCriteria) || !$this->lastProjectScmsCriteria->equals($criteria)) {
				$this->collProjectScms = ProjectScmPeer::doSelectJoinScmServer($criteria, $con);
			}
		}
		$this->lastProjectScmsCriteria = $criteria;

		return $this->collProjectScms;
	}

	/**
	 * Collection to store aggregation of collRoles	  
	 * @var array
	 */
	protected $collRoles; 

	/**
	 * Temporary storage of collRoles to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initRoles()
	{
		if ($this->collRoles === null) {
			$this->collRoles = array();
		}
	}

	/**
	 * Method called to associate a Role object to this object
	 * through the Role foreign key attribute
	 *
	 * @param Role $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addRole(Role $l)
	{
		$this->collRoles[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collRoles.
	 * @var Criteria
	 */
	private $lastRolesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related Roles from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getRoles($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/RolePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collRoles === null) {
			if ($this->isNew()) {
			   $this->collRoles = array();
			} else {
	
				$criteria->add(RolePeer::PROJECT_ID, $this->getProjectId() );

				$this->collRoles = RolePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(RolePeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastRolesCriteria) || !$this->lastRolesCriteria->equals($criteria)) {
					$this->collRoles = RolePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastRolesCriteria = $criteria;

		return $this->collRoles;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related Roles from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getRolesJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/RolePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collRoles === null) {
			if ($this->isNew()) {
			   $this->collRoles = array();
			} else {
	   
				$criteria->add(RolePeer::PROJECT_ID, $this->getProjectId());
				$this->collRoles = RolePeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(RolePeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastRolesCriteria) || !$this->lastRolesCriteria->equals($criteria)) {
				$this->collRoles = RolePeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastRolesCriteria = $criteria;

		return $this->collRoles;
	}

	/**
	 * Collection to store aggregation of collScmCommitFilterProjects	  
	 * @var array
	 */
	protected $collScmCommitFilterProjects; 

	/**
	 * Temporary storage of collScmCommitFilterProjects to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initScmCommitFilterProjects()
	{
		if ($this->collScmCommitFilterProjects === null) {
			$this->collScmCommitFilterProjects = array();
		}
	}

	/**
	 * Method called to associate a ScmCommitFilterProject object to this object
	 * through the ScmCommitFilterProject foreign key attribute
	 *
	 * @param ScmCommitFilterProject $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addScmCommitFilterProject(ScmCommitFilterProject $l)
	{
		$this->collScmCommitFilterProjects[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collScmCommitFilterProjects.
	 * @var Criteria
	 */
	private $lastScmCommitFilterProjectsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related ScmCommitFilterProjects from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getScmCommitFilterProjects($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitFilterProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collScmCommitFilterProjects === null) {
			if ($this->isNew()) {
			   $this->collScmCommitFilterProjects = array();
			} else {
	
				$criteria->add(ScmCommitFilterProjectPeer::PROJECT_ID, $this->getProjectId() );

				$this->collScmCommitFilterProjects = ScmCommitFilterProjectPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ScmCommitFilterProjectPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastScmCommitFilterProjectsCriteria) || !$this->lastScmCommitFilterProjectsCriteria->equals($criteria)) {
					$this->collScmCommitFilterProjects = ScmCommitFilterProjectPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastScmCommitFilterProjectsCriteria = $criteria;

		return $this->collScmCommitFilterProjects;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ScmCommitFilterProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getScmCommitFilterProjectsJoinScmCommitFilter($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitFilterProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmCommitFilterProjects === null) {
			if ($this->isNew()) {
			   $this->collScmCommitFilterProjects = array();
			} else {
	   
				$criteria->add(ScmCommitFilterProjectPeer::PROJECT_ID, $this->getProjectId());
				$this->collScmCommitFilterProjects = ScmCommitFilterProjectPeer::doSelectJoinScmCommitFilter($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmCommitFilterProjectPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastScmCommitFilterProjectsCriteria) || !$this->lastScmCommitFilterProjectsCriteria->equals($criteria)) {
				$this->collScmCommitFilterProjects = ScmCommitFilterProjectPeer::doSelectJoinScmCommitFilter($criteria, $con);
			}
		}
		$this->lastScmCommitFilterProjectsCriteria = $criteria;

		return $this->collScmCommitFilterProjects;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ScmCommitFilterProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getScmCommitFilterProjectsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitFilterProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmCommitFilterProjects === null) {
			if ($this->isNew()) {
			   $this->collScmCommitFilterProjects = array();
			} else {
	   
				$criteria->add(ScmCommitFilterProjectPeer::PROJECT_ID, $this->getProjectId());
				$this->collScmCommitFilterProjects = ScmCommitFilterProjectPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmCommitFilterProjectPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastScmCommitFilterProjectsCriteria) || !$this->lastScmCommitFilterProjectsCriteria->equals($criteria)) {
				$this->collScmCommitFilterProjects = ScmCommitFilterProjectPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastScmCommitFilterProjectsCriteria = $criteria;

		return $this->collScmCommitFilterProjects;
	}

	/**
	 * Collection to store aggregation of collScmModules	  
	 * @var array
	 */
	protected $collScmModules; 

	/**
	 * Temporary storage of collScmModules to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initScmModules()
	{
		if ($this->collScmModules === null) {
			$this->collScmModules = array();
		}
	}

	/**
	 * Method called to associate a ScmModule object to this object
	 * through the ScmModule foreign key attribute
	 *
	 * @param ScmModule $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addScmModule(ScmModule $l)
	{
		$this->collScmModules[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collScmModules.
	 * @var Criteria
	 */
	private $lastScmModulesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related ScmModules from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getScmModules($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmModulePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collScmModules === null) {
			if ($this->isNew()) {
			   $this->collScmModules = array();
			} else {
	
				$criteria->add(ScmModulePeer::PROJECT_ID, $this->getProjectId() );

				$this->collScmModules = ScmModulePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ScmModulePeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastScmModulesCriteria) || !$this->lastScmModulesCriteria->equals($criteria)) {
					$this->collScmModules = ScmModulePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastScmModulesCriteria = $criteria;

		return $this->collScmModules;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ScmModules from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getScmModulesJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmModulePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmModules === null) {
			if ($this->isNew()) {
			   $this->collScmModules = array();
			} else {
	   
				$criteria->add(ScmModulePeer::PROJECT_ID, $this->getProjectId());
				$this->collScmModules = ScmModulePeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmModulePeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastScmModulesCriteria) || !$this->lastScmModulesCriteria->equals($criteria)) {
				$this->collScmModules = ScmModulePeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastScmModulesCriteria = $criteria;

		return $this->collScmModules;
	}

	/**
	 * Collection to store aggregation of collScmPreferences	  
	 * @var array
	 */
	protected $collScmPreferences; 

	/**
	 * Temporary storage of collScmPreferences to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initScmPreferences()
	{
		if ($this->collScmPreferences === null) {
			$this->collScmPreferences = array();
		}
	}

	/**
	 * Method called to associate a ScmPreference object to this object
	 * through the ScmPreference foreign key attribute
	 *
	 * @param ScmPreference $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addScmPreference(ScmPreference $l)
	{
		$this->collScmPreferences[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collScmPreferences.
	 * @var Criteria
	 */
	private $lastScmPreferencesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related ScmPreferences from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getScmPreferences($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmPreferencePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collScmPreferences === null) {
			if ($this->isNew()) {
			   $this->collScmPreferences = array();
			} else {
	
				$criteria->add(ScmPreferencePeer::PROJECT_ID, $this->getProjectId() );

				$this->collScmPreferences = ScmPreferencePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ScmPreferencePeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastScmPreferencesCriteria) || !$this->lastScmPreferencesCriteria->equals($criteria)) {
					$this->collScmPreferences = ScmPreferencePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastScmPreferencesCriteria = $criteria;

		return $this->collScmPreferences;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ScmPreferences from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getScmPreferencesJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmPreferencePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmPreferences === null) {
			if ($this->isNew()) {
			   $this->collScmPreferences = array();
			} else {
	   
				$criteria->add(ScmPreferencePeer::PROJECT_ID, $this->getProjectId());
				$this->collScmPreferences = ScmPreferencePeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmPreferencePeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastScmPreferencesCriteria) || !$this->lastScmPreferencesCriteria->equals($criteria)) {
				$this->collScmPreferences = ScmPreferencePeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastScmPreferencesCriteria = $criteria;

		return $this->collScmPreferences;
	}

	/**
	 * Collection to store aggregation of collScmProjectStatss	  
	 * @var array
	 */
	protected $collScmProjectStatss; 

	/**
	 * Temporary storage of collScmProjectStatss to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initScmProjectStatss()
	{
		if ($this->collScmProjectStatss === null) {
			$this->collScmProjectStatss = array();
		}
	}

	/**
	 * Method called to associate a ScmProjectStats object to this object
	 * through the ScmProjectStats foreign key attribute
	 *
	 * @param ScmProjectStats $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addScmProjectStats(ScmProjectStats $l)
	{
		$this->collScmProjectStatss[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collScmProjectStatss.
	 * @var Criteria
	 */
	private $lastScmProjectStatssCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related ScmProjectStatss from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getScmProjectStatss($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmProjectStatsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collScmProjectStatss === null) {
			if ($this->isNew()) {
			   $this->collScmProjectStatss = array();
			} else {
	
				$criteria->add(ScmProjectStatsPeer::PROJECT_ID, $this->getProjectId() );

				$this->collScmProjectStatss = ScmProjectStatsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ScmProjectStatsPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastScmProjectStatssCriteria) || !$this->lastScmProjectStatssCriteria->equals($criteria)) {
					$this->collScmProjectStatss = ScmProjectStatsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastScmProjectStatssCriteria = $criteria;

		return $this->collScmProjectStatss;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ScmProjectStatss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getScmProjectStatssJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmProjectStatsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmProjectStatss === null) {
			if ($this->isNew()) {
			   $this->collScmProjectStatss = array();
			} else {
	   
				$criteria->add(ScmProjectStatsPeer::PROJECT_ID, $this->getProjectId());
				$this->collScmProjectStatss = ScmProjectStatsPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmProjectStatsPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastScmProjectStatssCriteria) || !$this->lastScmProjectStatssCriteria->equals($criteria)) {
				$this->collScmProjectStatss = ScmProjectStatsPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastScmProjectStatssCriteria = $criteria;

		return $this->collScmProjectStatss;
	}

	/**
	 * Collection to store aggregation of collScmCommits	  
	 * @var array
	 */
	protected $collScmCommits; 

	/**
	 * Temporary storage of collScmCommits to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initScmCommits()
	{
		if ($this->collScmCommits === null) {
			$this->collScmCommits = array();
		}
	}

	/**
	 * Method called to associate a ScmCommit object to this object
	 * through the ScmCommit foreign key attribute
	 *
	 * @param ScmCommit $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addScmCommit(ScmCommit $l)
	{
		$this->collScmCommits[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collScmCommits.
	 * @var Criteria
	 */
	private $lastScmCommitsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related ScmCommits from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getScmCommits($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collScmCommits === null) {
			if ($this->isNew()) {
			   $this->collScmCommits = array();
			} else {
	
				$criteria->add(ScmCommitPeer::PROJECT_ID, $this->getProjectId() );

				$this->collScmCommits = ScmCommitPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ScmCommitPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastScmCommitsCriteria) || !$this->lastScmCommitsCriteria->equals($criteria)) {
					$this->collScmCommits = ScmCommitPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastScmCommitsCriteria = $criteria;

		return $this->collScmCommits;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ScmCommits from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getScmCommitsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmCommits === null) {
			if ($this->isNew()) {
			   $this->collScmCommits = array();
			} else {
	   
				$criteria->add(ScmCommitPeer::PROJECT_ID, $this->getProjectId());
				$this->collScmCommits = ScmCommitPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmCommitPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastScmCommitsCriteria) || !$this->lastScmCommitsCriteria->equals($criteria)) {
				$this->collScmCommits = ScmCommitPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastScmCommitsCriteria = $criteria;

		return $this->collScmCommits;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ScmCommits from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getScmCommitsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmCommits === null) {
			if ($this->isNew()) {
			   $this->collScmCommits = array();
			} else {
	   
				$criteria->add(ScmCommitPeer::PROJECT_ID, $this->getProjectId());
				$this->collScmCommits = ScmCommitPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmCommitPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastScmCommitsCriteria) || !$this->lastScmCommitsCriteria->equals($criteria)) {
				$this->collScmCommits = ScmCommitPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastScmCommitsCriteria = $criteria;

		return $this->collScmCommits;
	}

	/**
	 * Collection to store aggregation of collDiskUsages	  
	 * @var array
	 */
	protected $collDiskUsages; 

	/**
	 * Temporary storage of collDiskUsages to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initDiskUsages()
	{
		if ($this->collDiskUsages === null) {
			$this->collDiskUsages = array();
		}
	}

	/**
	 * Method called to associate a DiskUsage object to this object
	 * through the DiskUsage foreign key attribute
	 *
	 * @param DiskUsage $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addDiskUsage(DiskUsage $l)
	{
		$this->collDiskUsages[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collDiskUsages.
	 * @var Criteria
	 */
	private $lastDiskUsagesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related DiskUsages from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getDiskUsages($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/DiskUsagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collDiskUsages === null) {
			if ($this->isNew()) {
			   $this->collDiskUsages = array();
			} else {
	
				$criteria->add(DiskUsagePeer::PROJECT_ID, $this->getProjectId() );

				$this->collDiskUsages = DiskUsagePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(DiskUsagePeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastDiskUsagesCriteria) || !$this->lastDiskUsagesCriteria->equals($criteria)) {
					$this->collDiskUsages = DiskUsagePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDiskUsagesCriteria = $criteria;

		return $this->collDiskUsages;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related DiskUsages from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getDiskUsagesJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/DiskUsagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collDiskUsages === null) {
			if ($this->isNew()) {
			   $this->collDiskUsages = array();
			} else {
	   
				$criteria->add(DiskUsagePeer::PROJECT_ID, $this->getProjectId());
				$this->collDiskUsages = DiskUsagePeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(DiskUsagePeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastDiskUsagesCriteria) || !$this->lastDiskUsagesCriteria->equals($criteria)) {
				$this->collDiskUsages = DiskUsagePeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastDiskUsagesCriteria = $criteria;

		return $this->collDiskUsages;
	}

	/**
	 * Collection to store aggregation of collProjectExportRequests	  
	 * @var array
	 */
	protected $collProjectExportRequests; 

	/**
	 * Temporary storage of collProjectExportRequests to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initProjectExportRequests()
	{
		if ($this->collProjectExportRequests === null) {
			$this->collProjectExportRequests = array();
		}
	}

	/**
	 * Method called to associate a ProjectExportRequest object to this object
	 * through the ProjectExportRequest foreign key attribute
	 *
	 * @param ProjectExportRequest $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addProjectExportRequest(ProjectExportRequest $l)
	{
		$this->collProjectExportRequests[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collProjectExportRequests.
	 * @var Criteria
	 */
	private $lastProjectExportRequestsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related ProjectExportRequests from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getProjectExportRequests($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectExportRequestPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collProjectExportRequests === null) {
			if ($this->isNew()) {
			   $this->collProjectExportRequests = array();
			} else {
	
				$criteria->add(ProjectExportRequestPeer::PROJECT_ID, $this->getProjectId() );

				$this->collProjectExportRequests = ProjectExportRequestPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ProjectExportRequestPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastProjectExportRequestsCriteria) || !$this->lastProjectExportRequestsCriteria->equals($criteria)) {
					$this->collProjectExportRequests = ProjectExportRequestPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastProjectExportRequestsCriteria = $criteria;

		return $this->collProjectExportRequests;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ProjectExportRequests from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getProjectExportRequestsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectExportRequestPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectExportRequests === null) {
			if ($this->isNew()) {
			   $this->collProjectExportRequests = array();
			} else {
	   
				$criteria->add(ProjectExportRequestPeer::PROJECT_ID, $this->getProjectId());
				$this->collProjectExportRequests = ProjectExportRequestPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectExportRequestPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastProjectExportRequestsCriteria) || !$this->lastProjectExportRequestsCriteria->equals($criteria)) {
				$this->collProjectExportRequests = ProjectExportRequestPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastProjectExportRequestsCriteria = $criteria;

		return $this->collProjectExportRequests;
	}

	/**
	 * Collection to store aggregation of collJabberProjectLogs	  
	 * @var array
	 */
	protected $collJabberProjectLogs; 

	/**
	 * Temporary storage of collJabberProjectLogs to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initJabberProjectLogs()
	{
		if ($this->collJabberProjectLogs === null) {
			$this->collJabberProjectLogs = array();
		}
	}

	/**
	 * Method called to associate a JabberProjectLog object to this object
	 * through the JabberProjectLog foreign key attribute
	 *
	 * @param JabberProjectLog $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addJabberProjectLog(JabberProjectLog $l)
	{
		$this->collJabberProjectLogs[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collJabberProjectLogs.
	 * @var Criteria
	 */
	private $lastJabberProjectLogsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related JabberProjectLogs from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getJabberProjectLogs($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/jabber/lib/JabberProjectLogPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collJabberProjectLogs === null) {
			if ($this->isNew()) {
			   $this->collJabberProjectLogs = array();
			} else {
	
				$criteria->add(JabberProjectLogPeer::PROJECT_ID, $this->getProjectId() );

				$this->collJabberProjectLogs = JabberProjectLogPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(JabberProjectLogPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastJabberProjectLogsCriteria) || !$this->lastJabberProjectLogsCriteria->equals($criteria)) {
					$this->collJabberProjectLogs = JabberProjectLogPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJabberProjectLogsCriteria = $criteria;

		return $this->collJabberProjectLogs;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related JabberProjectLogs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getJabberProjectLogsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/jabber/lib/JabberProjectLogPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collJabberProjectLogs === null) {
			if ($this->isNew()) {
			   $this->collJabberProjectLogs = array();
			} else {
	   
				$criteria->add(JabberProjectLogPeer::PROJECT_ID, $this->getProjectId());
				$this->collJabberProjectLogs = JabberProjectLogPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(JabberProjectLogPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastJabberProjectLogsCriteria) || !$this->lastJabberProjectLogsCriteria->equals($criteria)) {
				$this->collJabberProjectLogs = JabberProjectLogPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastJabberProjectLogsCriteria = $criteria;

		return $this->collJabberProjectLogs;
	}

	/**
	 * Collection to store aggregation of collScmUserStatss	  
	 * @var array
	 */
	protected $collScmUserStatss; 

	/**
	 * Temporary storage of collScmUserStatss to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initScmUserStatss()
	{
		if ($this->collScmUserStatss === null) {
			$this->collScmUserStatss = array();
		}
	}

	/**
	 * Method called to associate a ScmUserStats object to this object
	 * through the ScmUserStats foreign key attribute
	 *
	 * @param ScmUserStats $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addScmUserStats(ScmUserStats $l)
	{
		$this->collScmUserStatss[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collScmUserStatss.
	 * @var Criteria
	 */
	private $lastScmUserStatssCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related ScmUserStatss from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getScmUserStatss($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmUserStatsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collScmUserStatss === null) {
			if ($this->isNew()) {
			   $this->collScmUserStatss = array();
			} else {
	
				$criteria->add(ScmUserStatsPeer::PROJECT_ID, $this->getProjectId() );

				$this->collScmUserStatss = ScmUserStatsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ScmUserStatsPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastScmUserStatssCriteria) || !$this->lastScmUserStatssCriteria->equals($criteria)) {
					$this->collScmUserStatss = ScmUserStatsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastScmUserStatssCriteria = $criteria;

		return $this->collScmUserStatss;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ScmUserStatss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getScmUserStatssJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmUserStatsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmUserStatss === null) {
			if ($this->isNew()) {
			   $this->collScmUserStatss = array();
			} else {
	   
				$criteria->add(ScmUserStatsPeer::PROJECT_ID, $this->getProjectId());
				$this->collScmUserStatss = ScmUserStatsPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmUserStatsPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastScmUserStatssCriteria) || !$this->lastScmUserStatssCriteria->equals($criteria)) {
				$this->collScmUserStatss = ScmUserStatsPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastScmUserStatssCriteria = $criteria;

		return $this->collScmUserStatss;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related ScmUserStatss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getScmUserStatssJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmUserStatsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmUserStatss === null) {
			if ($this->isNew()) {
			   $this->collScmUserStatss = array();
			} else {
	   
				$criteria->add(ScmUserStatsPeer::PROJECT_ID, $this->getProjectId());
				$this->collScmUserStatss = ScmUserStatsPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmUserStatsPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastScmUserStatssCriteria) || !$this->lastScmUserStatssCriteria->equals($criteria)) {
				$this->collScmUserStatss = ScmUserStatsPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastScmUserStatssCriteria = $criteria;

		return $this->collScmUserStatss;
	}

	/**
	 * Collection to store aggregation of collSurveyQuestions	  
	 * @var array
	 */
	protected $collSurveyQuestions; 

	/**
	 * Temporary storage of collSurveyQuestions to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initSurveyQuestions()
	{
		if ($this->collSurveyQuestions === null) {
			$this->collSurveyQuestions = array();
		}
	}

	/**
	 * Method called to associate a SurveyQuestion object to this object
	 * through the SurveyQuestion foreign key attribute
	 *
	 * @param SurveyQuestion $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addSurveyQuestion(SurveyQuestion $l)
	{
		$this->collSurveyQuestions[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collSurveyQuestions.
	 * @var Criteria
	 */
	private $lastSurveyQuestionsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related SurveyQuestions from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getSurveyQuestions($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/survey/lib/SurveyQuestionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collSurveyQuestions === null) {
			if ($this->isNew()) {
			   $this->collSurveyQuestions = array();
			} else {
	
				$criteria->add(SurveyQuestionPeer::PROJECT_ID, $this->getProjectId() );

				$this->collSurveyQuestions = SurveyQuestionPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(SurveyQuestionPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastSurveyQuestionsCriteria) || !$this->lastSurveyQuestionsCriteria->equals($criteria)) {
					$this->collSurveyQuestions = SurveyQuestionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSurveyQuestionsCriteria = $criteria;

		return $this->collSurveyQuestions;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related SurveyQuestions from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getSurveyQuestionsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/survey/lib/SurveyQuestionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collSurveyQuestions === null) {
			if ($this->isNew()) {
			   $this->collSurveyQuestions = array();
			} else {
	   
				$criteria->add(SurveyQuestionPeer::PROJECT_ID, $this->getProjectId());
				$this->collSurveyQuestions = SurveyQuestionPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(SurveyQuestionPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastSurveyQuestionsCriteria) || !$this->lastSurveyQuestionsCriteria->equals($criteria)) {
				$this->collSurveyQuestions = SurveyQuestionPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastSurveyQuestionsCriteria = $criteria;

		return $this->collSurveyQuestions;
	}

	/**
	 * Collection to store aggregation of collTrackers	  
	 * @var array
	 */
	protected $collTrackers; 

	/**
	 * Temporary storage of collTrackers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackers()
	{
		if ($this->collTrackers === null) {
			$this->collTrackers = array();
		}
	}

	/**
	 * Method called to associate a Tracker object to this object
	 * through the Tracker foreign key attribute
	 *
	 * @param Tracker $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTracker(Tracker $l)
	{
		$this->collTrackers[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackers.
	 * @var Criteria
	 */
	private $lastTrackersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related Trackers from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackers === null) {
			if ($this->isNew()) {
			   $this->collTrackers = array();
			} else {
	
				$criteria->add(TrackerPeer::PROJECT_ID, $this->getProjectId() );

				$this->collTrackers = TrackerPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastTrackersCriteria) || !$this->lastTrackersCriteria->equals($criteria)) {
					$this->collTrackers = TrackerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackersCriteria = $criteria;

		return $this->collTrackers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related Trackers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getTrackersJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackers === null) {
			if ($this->isNew()) {
			   $this->collTrackers = array();
			} else {
	   
				$criteria->add(TrackerPeer::PROJECT_ID, $this->getProjectId());
				$this->collTrackers = TrackerPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastTrackersCriteria) || !$this->lastTrackersCriteria->equals($criteria)) {
				$this->collTrackers = TrackerPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastTrackersCriteria = $criteria;

		return $this->collTrackers;
	}

	/**
	 * Collection to store aggregation of collUserProjects	  
	 * @var array
	 */
	protected $collUserProjects; 

	/**
	 * Temporary storage of collUserProjects to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserProjects()
	{
		if ($this->collUserProjects === null) {
			$this->collUserProjects = array();
		}
	}

	/**
	 * Method called to associate a UserProject object to this object
	 * through the UserProject foreign key attribute
	 *
	 * @param UserProject $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUserProject(UserProject $l)
	{
		$this->collUserProjects[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collUserProjects.
	 * @var Criteria
	 */
	private $lastUserProjectsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related UserProjects from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserProjects($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUserProjects === null) {
			if ($this->isNew()) {
			   $this->collUserProjects = array();
			} else {
	
				$criteria->add(UserProjectPeer::PROJECT_ID, $this->getProjectId() );

				$this->collUserProjects = UserProjectPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserProjectPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastUserProjectsCriteria) || !$this->lastUserProjectsCriteria->equals($criteria)) {
					$this->collUserProjects = UserProjectPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserProjectsCriteria = $criteria;

		return $this->collUserProjects;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related UserProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getUserProjectsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserProjects === null) {
			if ($this->isNew()) {
			   $this->collUserProjects = array();
			} else {
	   
				$criteria->add(UserProjectPeer::PROJECT_ID, $this->getProjectId());
				$this->collUserProjects = UserProjectPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserProjectPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastUserProjectsCriteria) || !$this->lastUserProjectsCriteria->equals($criteria)) {
				$this->collUserProjects = UserProjectPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastUserProjectsCriteria = $criteria;

		return $this->collUserProjects;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related UserProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getUserProjectsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserProjects === null) {
			if ($this->isNew()) {
			   $this->collUserProjects = array();
			} else {
	   
				$criteria->add(UserProjectPeer::PROJECT_ID, $this->getProjectId());
				$this->collUserProjects = UserProjectPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserProjectPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastUserProjectsCriteria) || !$this->lastUserProjectsCriteria->equals($criteria)) {
				$this->collUserProjects = UserProjectPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastUserProjectsCriteria = $criteria;

		return $this->collUserProjects;
	}

	/**
	 * Collection to store aggregation of collUserWatchedProjects	  
	 * @var array
	 */
	protected $collUserWatchedProjects; 

	/**
	 * Temporary storage of collUserWatchedProjects to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserWatchedProjects()
	{
		if ($this->collUserWatchedProjects === null) {
			$this->collUserWatchedProjects = array();
		}
	}

	/**
	 * Method called to associate a UserWatchedProject object to this object
	 * through the UserWatchedProject foreign key attribute
	 *
	 * @param UserWatchedProject $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUserWatchedProject(UserWatchedProject $l)
	{
		$this->collUserWatchedProjects[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collUserWatchedProjects.
	 * @var Criteria
	 */
	private $lastUserWatchedProjectsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related UserWatchedProjects from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserWatchedProjects($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserWatchedProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUserWatchedProjects === null) {
			if ($this->isNew()) {
			   $this->collUserWatchedProjects = array();
			} else {
	
				$criteria->add(UserWatchedProjectPeer::PROJECT_ID, $this->getProjectId() );

				$this->collUserWatchedProjects = UserWatchedProjectPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserWatchedProjectPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastUserWatchedProjectsCriteria) || !$this->lastUserWatchedProjectsCriteria->equals($criteria)) {
					$this->collUserWatchedProjects = UserWatchedProjectPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserWatchedProjectsCriteria = $criteria;

		return $this->collUserWatchedProjects;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related UserWatchedProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getUserWatchedProjectsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserWatchedProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserWatchedProjects === null) {
			if ($this->isNew()) {
			   $this->collUserWatchedProjects = array();
			} else {
	   
				$criteria->add(UserWatchedProjectPeer::PROJECT_ID, $this->getProjectId());
				$this->collUserWatchedProjects = UserWatchedProjectPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserWatchedProjectPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastUserWatchedProjectsCriteria) || !$this->lastUserWatchedProjectsCriteria->equals($criteria)) {
				$this->collUserWatchedProjects = UserWatchedProjectPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastUserWatchedProjectsCriteria = $criteria;

		return $this->collUserWatchedProjects;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related UserWatchedProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getUserWatchedProjectsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserWatchedProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserWatchedProjects === null) {
			if ($this->isNew()) {
			   $this->collUserWatchedProjects = array();
			} else {
	   
				$criteria->add(UserWatchedProjectPeer::PROJECT_ID, $this->getProjectId());
				$this->collUserWatchedProjects = UserWatchedProjectPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserWatchedProjectPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastUserWatchedProjectsCriteria) || !$this->lastUserWatchedProjectsCriteria->equals($criteria)) {
				$this->collUserWatchedProjects = UserWatchedProjectPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastUserWatchedProjectsCriteria = $criteria;

		return $this->collUserWatchedProjects;
	}

	/**
	 * Collection to store aggregation of collWikiProjectSettings	  
	 * @var array
	 */
	protected $collWikiProjectSettings; 

	/**
	 * Temporary storage of collWikiProjectSettings to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initWikiProjectSettings()
	{
		if ($this->collWikiProjectSettings === null) {
			$this->collWikiProjectSettings = array();
		}
	}

	/**
	 * Method called to associate a WikiProjectSetting object to this object
	 * through the WikiProjectSetting foreign key attribute
	 *
	 * @param WikiProjectSetting $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addWikiProjectSetting(WikiProjectSetting $l)
	{
		$this->collWikiProjectSettings[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collWikiProjectSettings.
	 * @var Criteria
	 */
	private $lastWikiProjectSettingsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related WikiProjectSettings from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getWikiProjectSettings($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/wiki/lib/WikiProjectSettingPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collWikiProjectSettings === null) {
			if ($this->isNew()) {
			   $this->collWikiProjectSettings = array();
			} else {
	
				$criteria->add(WikiProjectSettingPeer::PROJECT_ID, $this->getProjectId() );

				$this->collWikiProjectSettings = WikiProjectSettingPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(WikiProjectSettingPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastWikiProjectSettingsCriteria) || !$this->lastWikiProjectSettingsCriteria->equals($criteria)) {
					$this->collWikiProjectSettings = WikiProjectSettingPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastWikiProjectSettingsCriteria = $criteria;

		return $this->collWikiProjectSettings;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related WikiProjectSettings from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getWikiProjectSettingsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/wiki/lib/WikiProjectSettingPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collWikiProjectSettings === null) {
			if ($this->isNew()) {
			   $this->collWikiProjectSettings = array();
			} else {
	   
				$criteria->add(WikiProjectSettingPeer::PROJECT_ID, $this->getProjectId());
				$this->collWikiProjectSettings = WikiProjectSettingPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(WikiProjectSettingPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastWikiProjectSettingsCriteria) || !$this->lastWikiProjectSettingsCriteria->equals($criteria)) {
				$this->collWikiProjectSettings = WikiProjectSettingPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastWikiProjectSettingsCriteria = $criteria;

		return $this->collWikiProjectSettings;
	}

	/**
	 * Collection to store aggregation of collMyReportProjects	  
	 * @var array
	 */
	protected $collMyReportProjects; 

	/**
	 * Temporary storage of collMyReportProjects to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMyReportProjects()
	{
		if ($this->collMyReportProjects === null) {
			$this->collMyReportProjects = array();
		}
	}

	/**
	 * Method called to associate a MyReportProject object to this object
	 * through the MyReportProject foreign key attribute
	 *
	 * @param MyReportProject $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMyReportProject(MyReportProject $l)
	{
		$this->collMyReportProjects[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collMyReportProjects.
	 * @var Criteria
	 */
	private $lastMyReportProjectsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related MyReportProjects from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMyReportProjects($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMyReportProjects === null) {
			if ($this->isNew()) {
			   $this->collMyReportProjects = array();
			} else {
	
				$criteria->add(MyReportProjectPeer::PROJECT_ID, $this->getProjectId() );

				$this->collMyReportProjects = MyReportProjectPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MyReportProjectPeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastMyReportProjectsCriteria) || !$this->lastMyReportProjectsCriteria->equals($criteria)) {
					$this->collMyReportProjects = MyReportProjectPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMyReportProjectsCriteria = $criteria;

		return $this->collMyReportProjects;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related MyReportProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getMyReportProjectsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportProjects === null) {
			if ($this->isNew()) {
			   $this->collMyReportProjects = array();
			} else {
	   
				$criteria->add(MyReportProjectPeer::PROJECT_ID, $this->getProjectId());
				$this->collMyReportProjects = MyReportProjectPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportProjectPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastMyReportProjectsCriteria) || !$this->lastMyReportProjectsCriteria->equals($criteria)) {
				$this->collMyReportProjects = MyReportProjectPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastMyReportProjectsCriteria = $criteria;

		return $this->collMyReportProjects;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related MyReportProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getMyReportProjectsJoinMyReport($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportProjects === null) {
			if ($this->isNew()) {
			   $this->collMyReportProjects = array();
			} else {
	   
				$criteria->add(MyReportProjectPeer::PROJECT_ID, $this->getProjectId());
				$this->collMyReportProjects = MyReportProjectPeer::doSelectJoinMyReport($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportProjectPeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastMyReportProjectsCriteria) || !$this->lastMyReportProjectsCriteria->equals($criteria)) {
				$this->collMyReportProjects = MyReportProjectPeer::doSelectJoinMyReport($criteria, $con);
			}
		}
		$this->lastMyReportProjectsCriteria = $criteria;

		return $this->collMyReportProjects;
	}

	/**
	 * Collection to store aggregation of collCodeSearchModules	  
	 * @var array
	 */
	protected $collCodeSearchModules; 

	/**
	 * Temporary storage of collCodeSearchModules to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCodeSearchModules()
	{
		if ($this->collCodeSearchModules === null) {
			$this->collCodeSearchModules = array();
		}
	}

	/**
	 * Method called to associate a CodeSearchModule object to this object
	 * through the CodeSearchModule foreign key attribute
	 *
	 * @param CodeSearchModule $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCodeSearchModule(CodeSearchModule $l)
	{
		$this->collCodeSearchModules[] = $l;
		$l->setProject($this);
	}

	/**
	 * The criteria used to select the current contents of collCodeSearchModules.
	 * @var Criteria
	 */
	private $lastCodeSearchModulesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project has previously
	 * been saved, it will retrieve related CodeSearchModules from storage.
	 * If this Project is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCodeSearchModules($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/CodeSearchModulePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCodeSearchModules === null) {
			if ($this->isNew()) {
			   $this->collCodeSearchModules = array();
			} else {
	
				$criteria->add(CodeSearchModulePeer::PROJECT_ID, $this->getProjectId() );

				$this->collCodeSearchModules = CodeSearchModulePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CodeSearchModulePeer::PROJECT_ID, $this->getProjectId());

				if (!isset($this->lastCodeSearchModulesCriteria) || !$this->lastCodeSearchModulesCriteria->equals($criteria)) {
					$this->collCodeSearchModules = CodeSearchModulePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCodeSearchModulesCriteria = $criteria;

		return $this->collCodeSearchModules;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Project is new, it will return
	 * an empty collection; or if this Project has previously
	 * been saved, it will retrieve related CodeSearchModules from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Project.
	 */
	public function getCodeSearchModulesJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/CodeSearchModulePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCodeSearchModules === null) {
			if ($this->isNew()) {
			   $this->collCodeSearchModules = array();
			} else {
	   
				$criteria->add(CodeSearchModulePeer::PROJECT_ID, $this->getProjectId());
				$this->collCodeSearchModules = CodeSearchModulePeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CodeSearchModulePeer::PROJECT_ID, $this->getProjectId());
			if (!isset($this->lastCodeSearchModulesCriteria) || !$this->lastCodeSearchModulesCriteria->equals($criteria)) {
				$this->collCodeSearchModules = CodeSearchModulePeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastCodeSearchModulesCriteria = $criteria;

		return $this->collCodeSearchModules;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("project_id", "project_name", "unix_name", "homepage_url", "is_public", "status", "description", "register_purpose", "register_license_other", "create_date", "template_project_id", "is_template", "parent_project_id", "root_parent_project_id", "root_path", "project_text1", "project_text2", "project_text3", "project_text4", "project_text5", "project_text6", "is_listed", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case ProjectPeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case ProjectPeer::PROJECT_NAME:
				return $this->getProjectName();
				break;
		  
			case ProjectPeer::UNIX_NAME:
				return $this->getUnixName();
				break;
		  
			case ProjectPeer::HOMEPAGE_URL:
				return $this->getHomepageUrl();
				break;
		  
			case ProjectPeer::IS_PUBLIC:
				return $this->getIsPublic();
				break;
		  
			case ProjectPeer::STATUS:
				return $this->getStatus();
				break;
		  
			case ProjectPeer::DESCRIPTION:
				return $this->getDescription();
				break;
		  
			case ProjectPeer::REGISTER_PURPOSE:
				return $this->getRegisterPurpose();
				break;
		  
			case ProjectPeer::REGISTER_LICENSE_OTHER:
				return $this->getRegisterLicenseOther();
				break;
		  
			case ProjectPeer::CREATE_DATE:
				return $this->getCreateDate();
				break;
		  
			case ProjectPeer::TEMPLATE_PROJECT_ID:
				return $this->getTemplateProjectId();
				break;
		  
			case ProjectPeer::IS_TEMPLATE:
				return $this->getIsTemplate();
				break;
		  
			case ProjectPeer::PARENT_PROJECT_ID:
				return $this->getParentProjectId();
				break;
		  
			case ProjectPeer::ROOT_PARENT_PROJECT_ID:
				return $this->getRootParentProjectId();
				break;
		  
			case ProjectPeer::ROOT_PATH:
				return $this->getRootPath();
				break;
		  
			case ProjectPeer::PROJECT_TEXT1:
				return $this->getProjectText1();
				break;
		  
			case ProjectPeer::PROJECT_TEXT2:
				return $this->getProjectText2();
				break;
		  
			case ProjectPeer::PROJECT_TEXT3:
				return $this->getProjectText3();
				break;
		  
			case ProjectPeer::PROJECT_TEXT4:
				return $this->getProjectText4();
				break;
		  
			case ProjectPeer::PROJECT_TEXT5:
				return $this->getProjectText5();
				break;
		  
			case ProjectPeer::PROJECT_TEXT6:
				return $this->getProjectText6();
				break;
		  
			case ProjectPeer::IS_LISTED:
				return $this->getIsListed();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getProjectId();
				break;
  
			case 1:
				return $this->getProjectName();
				break;
  
			case 2:
				return $this->getUnixName();
				break;
  
			case 3:
				return $this->getHomepageUrl();
				break;
  
			case 4:
				return $this->getIsPublic();
				break;
  
			case 5:
				return $this->getStatus();
				break;
  
			case 6:
				return $this->getDescription();
				break;
  
			case 7:
				return $this->getRegisterPurpose();
				break;
  
			case 8:
				return $this->getRegisterLicenseOther();
				break;
  
			case 9:
				return $this->getCreateDate();
				break;
  
			case 10:
				return $this->getTemplateProjectId();
				break;
  
			case 11:
				return $this->getIsTemplate();
				break;
  
			case 12:
				return $this->getParentProjectId();
				break;
  
			case 13:
				return $this->getRootParentProjectId();
				break;
  
			case 14:
				return $this->getRootPath();
				break;
  
			case 15:
				return $this->getProjectText1();
				break;
  
			case 16:
				return $this->getProjectText2();
				break;
  
			case 17:
				return $this->getProjectText3();
				break;
  
			case 18:
				return $this->getProjectText4();
				break;
  
			case 19:
				return $this->getProjectText5();
				break;
  
			case 20:
				return $this->getProjectText6();
				break;
  
			case 21:
				return $this->getIsListed();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(ProjectPeer::PROJECT_ID, $arr)) $this->setProjectId($arr[ProjectPeer::PROJECT_ID]);
  
		if (array_key_exists(ProjectPeer::PROJECT_NAME, $arr)) $this->setProjectName($arr[ProjectPeer::PROJECT_NAME]);
  
		if (array_key_exists(ProjectPeer::UNIX_NAME, $arr)) $this->setUnixName($arr[ProjectPeer::UNIX_NAME]);
  
		if (array_key_exists(ProjectPeer::HOMEPAGE_URL, $arr)) $this->setHomepageUrl($arr[ProjectPeer::HOMEPAGE_URL]);
  
		if (array_key_exists(ProjectPeer::IS_PUBLIC, $arr)) $this->setIsPublic($arr[ProjectPeer::IS_PUBLIC]);
  
		if (array_key_exists(ProjectPeer::STATUS, $arr)) $this->setStatus($arr[ProjectPeer::STATUS]);
  
		if (array_key_exists(ProjectPeer::DESCRIPTION, $arr)) $this->setDescription($arr[ProjectPeer::DESCRIPTION]);
  
		if (array_key_exists(ProjectPeer::REGISTER_PURPOSE, $arr)) $this->setRegisterPurpose($arr[ProjectPeer::REGISTER_PURPOSE]);
  
		if (array_key_exists(ProjectPeer::REGISTER_LICENSE_OTHER, $arr)) $this->setRegisterLicenseOther($arr[ProjectPeer::REGISTER_LICENSE_OTHER]);
  
		if (array_key_exists(ProjectPeer::CREATE_DATE, $arr)) $this->setCreateDate($arr[ProjectPeer::CREATE_DATE]);
  
		if (array_key_exists(ProjectPeer::TEMPLATE_PROJECT_ID, $arr)) $this->setTemplateProjectId($arr[ProjectPeer::TEMPLATE_PROJECT_ID]);
  
		if (array_key_exists(ProjectPeer::IS_TEMPLATE, $arr)) $this->setIsTemplate($arr[ProjectPeer::IS_TEMPLATE]);
  
		if (array_key_exists(ProjectPeer::PARENT_PROJECT_ID, $arr)) $this->setParentProjectId($arr[ProjectPeer::PARENT_PROJECT_ID]);
  
		if (array_key_exists(ProjectPeer::ROOT_PARENT_PROJECT_ID, $arr)) $this->setRootParentProjectId($arr[ProjectPeer::ROOT_PARENT_PROJECT_ID]);
  
		if (array_key_exists(ProjectPeer::ROOT_PATH, $arr)) $this->setRootPath($arr[ProjectPeer::ROOT_PATH]);
  
		if (array_key_exists(ProjectPeer::PROJECT_TEXT1, $arr)) $this->setProjectText1($arr[ProjectPeer::PROJECT_TEXT1]);
  
		if (array_key_exists(ProjectPeer::PROJECT_TEXT2, $arr)) $this->setProjectText2($arr[ProjectPeer::PROJECT_TEXT2]);
  
		if (array_key_exists(ProjectPeer::PROJECT_TEXT3, $arr)) $this->setProjectText3($arr[ProjectPeer::PROJECT_TEXT3]);
  
		if (array_key_exists(ProjectPeer::PROJECT_TEXT4, $arr)) $this->setProjectText4($arr[ProjectPeer::PROJECT_TEXT4]);
  
		if (array_key_exists(ProjectPeer::PROJECT_TEXT5, $arr)) $this->setProjectText5($arr[ProjectPeer::PROJECT_TEXT5]);
  
		if (array_key_exists(ProjectPeer::PROJECT_TEXT6, $arr)) $this->setProjectText6($arr[ProjectPeer::PROJECT_TEXT6]);
  
		if (array_key_exists(ProjectPeer::IS_LISTED, $arr)) $this->setIsListed($arr[ProjectPeer::IS_LISTED]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case ProjectPeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case ProjectPeer::PROJECT_NAME:
				$this->setProjectName($value);
				break;
	  
			case ProjectPeer::UNIX_NAME:
				$this->setUnixName($value);
				break;
	  
			case ProjectPeer::HOMEPAGE_URL:
				$this->setHomepageUrl($value);
				break;
	  
			case ProjectPeer::IS_PUBLIC:
				$this->setIsPublic($value);
				break;
	  
			case ProjectPeer::STATUS:
				$this->setStatus($value);
				break;
	  
			case ProjectPeer::DESCRIPTION:
				$this->setDescription($value);
				break;
	  
			case ProjectPeer::REGISTER_PURPOSE:
				$this->setRegisterPurpose($value);
				break;
	  
			case ProjectPeer::REGISTER_LICENSE_OTHER:
				$this->setRegisterLicenseOther($value);
				break;
	  
			case ProjectPeer::CREATE_DATE:
				$this->setCreateDate($value);
				break;
	  
			case ProjectPeer::TEMPLATE_PROJECT_ID:
				$this->setTemplateProjectId($value);
				break;
	  
			case ProjectPeer::IS_TEMPLATE:
				$this->setIsTemplate($value);
				break;
	  
			case ProjectPeer::PARENT_PROJECT_ID:
				$this->setParentProjectId($value);
				break;
	  
			case ProjectPeer::ROOT_PARENT_PROJECT_ID:
				$this->setRootParentProjectId($value);
				break;
	  
			case ProjectPeer::ROOT_PATH:
				$this->setRootPath($value);
				break;
	  
			case ProjectPeer::PROJECT_TEXT1:
				$this->setProjectText1($value);
				break;
	  
			case ProjectPeer::PROJECT_TEXT2:
				$this->setProjectText2($value);
				break;
	  
			case ProjectPeer::PROJECT_TEXT3:
				$this->setProjectText3($value);
				break;
	  
			case ProjectPeer::PROJECT_TEXT4:
				$this->setProjectText4($value);
				break;
	  
			case ProjectPeer::PROJECT_TEXT5:
				$this->setProjectText5($value);
				break;
	  
			case ProjectPeer::PROJECT_TEXT6:
				$this->setProjectText6($value);
				break;
	  
			case ProjectPeer::IS_LISTED:
				$this->setIsListed($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setProjectId($value);
				break;
  
			case 1:
				$this->setProjectName($value);
				break;
  
			case 2:
				$this->setUnixName($value);
				break;
  
			case 3:
				$this->setHomepageUrl($value);
				break;
  
			case 4:
				$this->setIsPublic($value);
				break;
  
			case 5:
				$this->setStatus($value);
				break;
  
			case 6:
				$this->setDescription($value);
				break;
  
			case 7:
				$this->setRegisterPurpose($value);
				break;
  
			case 8:
				$this->setRegisterLicenseOther($value);
				break;
  
			case 9:
				$this->setCreateDate($value);
				break;
  
			case 10:
				$this->setTemplateProjectId($value);
				break;
  
			case 11:
				$this->setIsTemplate($value);
				break;
  
			case 12:
				$this->setParentProjectId($value);
				break;
  
			case 13:
				$this->setRootParentProjectId($value);
				break;
  
			case 14:
				$this->setRootPath($value);
				break;
  
			case 15:
				$this->setProjectText1($value);
				break;
  
			case 16:
				$this->setProjectText2($value);
				break;
  
			case 17:
				$this->setProjectText3($value);
				break;
  
			case 18:
				$this->setProjectText4($value);
				break;
  
			case 19:
				$this->setProjectText5($value);
				break;
  
			case 20:
				$this->setProjectText6($value);
				break;
  
			case 21:
				$this->setIsListed($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ProjectPeer::DATABASE_NAME);

		try {
			$con->begin();
			ProjectPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(ProjectPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ProjectPeer::doInsert($this, $con);
					$this->setProjectId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					ProjectPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collCruisecontrols !== null) {
				for ($i=0,$size=count($this->collCruisecontrols); $i < $size; $i++) {
					$this->collCruisecontrols[$i]->save($con);
				}
			  }
			if ($this->collDocmanProjectSettings !== null) {
				for ($i=0,$size=count($this->collDocmanProjectSettings); $i < $size; $i++) {
					$this->collDocmanProjectSettings[$i]->save($con);
				}
			  }
			if ($this->collDocmanFolders !== null) {
				for ($i=0,$size=count($this->collDocmanFolders); $i < $size; $i++) {
					$this->collDocmanFolders[$i]->save($con);
				}
			  }
			if ($this->collFrsProjectSettings !== null) {
				for ($i=0,$size=count($this->collFrsProjectSettings); $i < $size; $i++) {
					$this->collFrsProjectSettings[$i]->save($con);
				}
			  }
			if ($this->collFrsPackages !== null) {
				for ($i=0,$size=count($this->collFrsPackages); $i < $size; $i++) {
					$this->collFrsPackages[$i]->save($con);
				}
			  }
			if ($this->collMailmans !== null) {
				for ($i=0,$size=count($this->collMailmans); $i < $size; $i++) {
					$this->collMailmans[$i]->save($con);
				}
			  }
			if ($this->collNewss !== null) {
				for ($i=0,$size=count($this->collNewss); $i < $size; $i++) {
					$this->collNewss[$i]->save($con);
				}
			  }
			if ($this->collNewsCounts !== null) {
				for ($i=0,$size=count($this->collNewsCounts); $i < $size; $i++) {
					$this->collNewsCounts[$i]->save($con);
				}
			  }
			if ($this->collProjectJoinRequests !== null) {
				for ($i=0,$size=count($this->collProjectJoinRequests); $i < $size; $i++) {
					$this->collProjectJoinRequests[$i]->save($con);
				}
			  }
			if ($this->collProjectPlugins !== null) {
				for ($i=0,$size=count($this->collProjectPlugins); $i < $size; $i++) {
					$this->collProjectPlugins[$i]->save($con);
				}
			  }
			if ($this->collProjectScms !== null) {
				for ($i=0,$size=count($this->collProjectScms); $i < $size; $i++) {
					$this->collProjectScms[$i]->save($con);
				}
			  }
			if ($this->collRoles !== null) {
				for ($i=0,$size=count($this->collRoles); $i < $size; $i++) {
					$this->collRoles[$i]->save($con);
				}
			  }
			if ($this->collScmCommitFilterProjects !== null) {
				for ($i=0,$size=count($this->collScmCommitFilterProjects); $i < $size; $i++) {
					$this->collScmCommitFilterProjects[$i]->save($con);
				}
			  }
			if ($this->collScmModules !== null) {
				for ($i=0,$size=count($this->collScmModules); $i < $size; $i++) {
					$this->collScmModules[$i]->save($con);
				}
			  }
			if ($this->collScmPreferences !== null) {
				for ($i=0,$size=count($this->collScmPreferences); $i < $size; $i++) {
					$this->collScmPreferences[$i]->save($con);
				}
			  }
			if ($this->collScmProjectStatss !== null) {
				for ($i=0,$size=count($this->collScmProjectStatss); $i < $size; $i++) {
					$this->collScmProjectStatss[$i]->save($con);
				}
			  }
			if ($this->collScmCommits !== null) {
				for ($i=0,$size=count($this->collScmCommits); $i < $size; $i++) {
					$this->collScmCommits[$i]->save($con);
				}
			  }
			if ($this->collDiskUsages !== null) {
				for ($i=0,$size=count($this->collDiskUsages); $i < $size; $i++) {
					$this->collDiskUsages[$i]->save($con);
				}
			  }
			if ($this->collProjectExportRequests !== null) {
				for ($i=0,$size=count($this->collProjectExportRequests); $i < $size; $i++) {
					$this->collProjectExportRequests[$i]->save($con);
				}
			  }
			if ($this->collJabberProjectLogs !== null) {
				for ($i=0,$size=count($this->collJabberProjectLogs); $i < $size; $i++) {
					$this->collJabberProjectLogs[$i]->save($con);
				}
			  }
			if ($this->collScmUserStatss !== null) {
				for ($i=0,$size=count($this->collScmUserStatss); $i < $size; $i++) {
					$this->collScmUserStatss[$i]->save($con);
				}
			  }
			if ($this->collSurveyQuestions !== null) {
				for ($i=0,$size=count($this->collSurveyQuestions); $i < $size; $i++) {
					$this->collSurveyQuestions[$i]->save($con);
				}
			  }
			if ($this->collTrackers !== null) {
				for ($i=0,$size=count($this->collTrackers); $i < $size; $i++) {
					$this->collTrackers[$i]->save($con);
				}
			  }
			if ($this->collUserProjects !== null) {
				for ($i=0,$size=count($this->collUserProjects); $i < $size; $i++) {
					$this->collUserProjects[$i]->save($con);
				}
			  }
			if ($this->collUserWatchedProjects !== null) {
				for ($i=0,$size=count($this->collUserWatchedProjects); $i < $size; $i++) {
					$this->collUserWatchedProjects[$i]->save($con);
				}
			  }
			if ($this->collWikiProjectSettings !== null) {
				for ($i=0,$size=count($this->collWikiProjectSettings); $i < $size; $i++) {
					$this->collWikiProjectSettings[$i]->save($con);
				}
			  }
			if ($this->collMyReportProjects !== null) {
				for ($i=0,$size=count($this->collMyReportProjects); $i < $size; $i++) {
					$this->collMyReportProjects[$i]->save($con);
				}
			  }
			if ($this->collCodeSearchModules !== null) {
				for ($i=0,$size=count($this->collCodeSearchModules); $i < $size; $i++) {
					$this->collCodeSearchModules[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return ProjectPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = ProjectPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collCruisecontrols !== null) {
				for ($i=0,$size=count($this->collCruisecontrols); $i < $size; $i++) {
					if (($retval = $this->collCruisecontrols[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collDocmanProjectSettings !== null) {
				for ($i=0,$size=count($this->collDocmanProjectSettings); $i < $size; $i++) {
					if (($retval = $this->collDocmanProjectSettings[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collDocmanFolders !== null) {
				for ($i=0,$size=count($this->collDocmanFolders); $i < $size; $i++) {
					if (($retval = $this->collDocmanFolders[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collFrsProjectSettings !== null) {
				for ($i=0,$size=count($this->collFrsProjectSettings); $i < $size; $i++) {
					if (($retval = $this->collFrsProjectSettings[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collFrsPackages !== null) {
				for ($i=0,$size=count($this->collFrsPackages); $i < $size; $i++) {
					if (($retval = $this->collFrsPackages[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collMailmans !== null) {
				for ($i=0,$size=count($this->collMailmans); $i < $size; $i++) {
					if (($retval = $this->collMailmans[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collNewss !== null) {
				for ($i=0,$size=count($this->collNewss); $i < $size; $i++) {
					if (($retval = $this->collNewss[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collNewsCounts !== null) {
				for ($i=0,$size=count($this->collNewsCounts); $i < $size; $i++) {
					if (($retval = $this->collNewsCounts[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collProjectJoinRequests !== null) {
				for ($i=0,$size=count($this->collProjectJoinRequests); $i < $size; $i++) {
					if (($retval = $this->collProjectJoinRequests[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collProjectPlugins !== null) {
				for ($i=0,$size=count($this->collProjectPlugins); $i < $size; $i++) {
					if (($retval = $this->collProjectPlugins[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collProjectScms !== null) {
				for ($i=0,$size=count($this->collProjectScms); $i < $size; $i++) {
					if (($retval = $this->collProjectScms[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collRoles !== null) {
				for ($i=0,$size=count($this->collRoles); $i < $size; $i++) {
					if (($retval = $this->collRoles[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collScmCommitFilterProjects !== null) {
				for ($i=0,$size=count($this->collScmCommitFilterProjects); $i < $size; $i++) {
					if (($retval = $this->collScmCommitFilterProjects[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collScmModules !== null) {
				for ($i=0,$size=count($this->collScmModules); $i < $size; $i++) {
					if (($retval = $this->collScmModules[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collScmPreferences !== null) {
				for ($i=0,$size=count($this->collScmPreferences); $i < $size; $i++) {
					if (($retval = $this->collScmPreferences[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collScmProjectStatss !== null) {
				for ($i=0,$size=count($this->collScmProjectStatss); $i < $size; $i++) {
					if (($retval = $this->collScmProjectStatss[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collScmCommits !== null) {
				for ($i=0,$size=count($this->collScmCommits); $i < $size; $i++) {
					if (($retval = $this->collScmCommits[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collDiskUsages !== null) {
				for ($i=0,$size=count($this->collDiskUsages); $i < $size; $i++) {
					if (($retval = $this->collDiskUsages[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collProjectExportRequests !== null) {
				for ($i=0,$size=count($this->collProjectExportRequests); $i < $size; $i++) {
					if (($retval = $this->collProjectExportRequests[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collJabberProjectLogs !== null) {
				for ($i=0,$size=count($this->collJabberProjectLogs); $i < $size; $i++) {
					if (($retval = $this->collJabberProjectLogs[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collScmUserStatss !== null) {
				for ($i=0,$size=count($this->collScmUserStatss); $i < $size; $i++) {
					if (($retval = $this->collScmUserStatss[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collSurveyQuestions !== null) {
				for ($i=0,$size=count($this->collSurveyQuestions); $i < $size; $i++) {
					if (($retval = $this->collSurveyQuestions[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackers !== null) {
				for ($i=0,$size=count($this->collTrackers); $i < $size; $i++) {
					if (($retval = $this->collTrackers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collUserProjects !== null) {
				for ($i=0,$size=count($this->collUserProjects); $i < $size; $i++) {
					if (($retval = $this->collUserProjects[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collUserWatchedProjects !== null) {
				for ($i=0,$size=count($this->collUserWatchedProjects); $i < $size; $i++) {
					if (($retval = $this->collUserWatchedProjects[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collWikiProjectSettings !== null) {
				for ($i=0,$size=count($this->collWikiProjectSettings); $i < $size; $i++) {
					if (($retval = $this->collWikiProjectSettings[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collMyReportProjects !== null) {
				for ($i=0,$size=count($this->collMyReportProjects); $i < $size; $i++) {
					if (($retval = $this->collMyReportProjects[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collCodeSearchModules !== null) {
				for ($i=0,$size=count($this->collCodeSearchModules); $i < $size; $i++) {
					if (($retval = $this->collCodeSearchModules[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed project_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setProjectId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getProjectId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Project Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Project();
		$copyObj->setProjectName($this->project_name);
		$copyObj->setUnixName($this->unix_name);
		$copyObj->setHomepageUrl($this->homepage_url);
		$copyObj->setIsPublic($this->is_public);
		$copyObj->setStatus($this->status);
		$copyObj->setDescription($this->description);
		$copyObj->setRegisterPurpose($this->register_purpose);
		$copyObj->setRegisterLicenseOther($this->register_license_other);
		$copyObj->setCreateDate($this->create_date);
		$copyObj->setTemplateProjectId($this->template_project_id);
		$copyObj->setIsTemplate($this->is_template);
		$copyObj->setParentProjectId($this->parent_project_id);
		$copyObj->setRootParentProjectId($this->root_parent_project_id);
		$copyObj->setRootPath($this->root_path);
		$copyObj->setProjectText1($this->project_text1);
		$copyObj->setProjectText2($this->project_text2);
		$copyObj->setProjectText3($this->project_text3);
		$copyObj->setProjectText4($this->project_text4);
		$copyObj->setProjectText5($this->project_text5);
		$copyObj->setProjectText6($this->project_text6);
		$copyObj->setIsListed($this->is_listed);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getCruisecontrols() as $relObj) {
				$copyObj->addCruisecontrol($relObj->copy());
			}

			foreach($this->getDocmanProjectSettings() as $relObj) {
				$copyObj->addDocmanProjectSetting($relObj->copy());
			}

			foreach($this->getDocmanFolders() as $relObj) {
				$copyObj->addDocmanFolder($relObj->copy());
			}

			foreach($this->getFrsProjectSettings() as $relObj) {
				$copyObj->addFrsProjectSetting($relObj->copy());
			}

			foreach($this->getFrsPackages() as $relObj) {
				$copyObj->addFrsPackage($relObj->copy());
			}

			foreach($this->getMailmans() as $relObj) {
				$copyObj->addMailman($relObj->copy());
			}

			foreach($this->getNewss() as $relObj) {
				$copyObj->addNews($relObj->copy());
			}

			foreach($this->getNewsCounts() as $relObj) {
				$copyObj->addNewsCount($relObj->copy());
			}

			foreach($this->getProjectJoinRequests() as $relObj) {
				$copyObj->addProjectJoinRequest($relObj->copy());
			}

			foreach($this->getProjectPlugins() as $relObj) {
				$copyObj->addProjectPlugin($relObj->copy());
			}

			foreach($this->getProjectScms() as $relObj) {
				$copyObj->addProjectScm($relObj->copy());
			}

			foreach($this->getRoles() as $relObj) {
				$copyObj->addRole($relObj->copy());
			}

			foreach($this->getScmCommitFilterProjects() as $relObj) {
				$copyObj->addScmCommitFilterProject($relObj->copy());
			}

			foreach($this->getScmModules() as $relObj) {
				$copyObj->addScmModule($relObj->copy());
			}

			foreach($this->getScmPreferences() as $relObj) {
				$copyObj->addScmPreference($relObj->copy());
			}

			foreach($this->getScmProjectStatss() as $relObj) {
				$copyObj->addScmProjectStats($relObj->copy());
			}

			foreach($this->getScmCommits() as $relObj) {
				$copyObj->addScmCommit($relObj->copy());
			}

			foreach($this->getDiskUsages() as $relObj) {
				$copyObj->addDiskUsage($relObj->copy());
			}

			foreach($this->getProjectExportRequests() as $relObj) {
				$copyObj->addProjectExportRequest($relObj->copy());
			}

			foreach($this->getJabberProjectLogs() as $relObj) {
				$copyObj->addJabberProjectLog($relObj->copy());
			}

			foreach($this->getScmUserStatss() as $relObj) {
				$copyObj->addScmUserStats($relObj->copy());
			}

			foreach($this->getSurveyQuestions() as $relObj) {
				$copyObj->addSurveyQuestion($relObj->copy());
			}

			foreach($this->getTrackers() as $relObj) {
				$copyObj->addTracker($relObj->copy());
			}

			foreach($this->getUserProjects() as $relObj) {
				$copyObj->addUserProject($relObj->copy());
			}

			foreach($this->getUserWatchedProjects() as $relObj) {
				$copyObj->addUserWatchedProject($relObj->copy());
			}

			foreach($this->getWikiProjectSettings() as $relObj) {
				$copyObj->addWikiProjectSetting($relObj->copy());
			}

			foreach($this->getMyReportProjects() as $relObj) {
				$copyObj->addMyReportProject($relObj->copy());
			}

			foreach($this->getCodeSearchModules() as $relObj) {
				$copyObj->addCodeSearchModule($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setProjectId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return ProjectPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ProjectPeer();
		}
		return self::$peer;
	}

}
